;M E S S A G E S

;Allgemeines
MSC_GEN_QUIT    equ 0   ;Programm wird aufgefordert, sich zu beenden

;Kernel Commands
MSC_KRL_MTADDP  equ 1   ;Prozess hinzufgen (P1/2=Stack, P3=Prioritt (7hoch-1niedrig), P4=Bank (0-8))
MSC_KRL_MTDELP  equ 2   ;Prozess entfernen (P1=Nummer)
MSC_KRL_MTADDT  equ 3   ;Timer hinzufgen (P1/2=Stack, P4=Bank (0-8))
MSC_KRL_MTDELT  equ 4   ;Timer entfernen (P1=Nummer)
MSC_KRL_MTSLPP  equ 5   ;Prozess in Dauer-Schlafzustand versetzen
MSC_KRL_MTWAKP  equ 6   ;Prozess aus Dauer-Schlafzustand holen

;Kernel Responses
MSR_KRL_MTADDP  equ 129 ;Prozess wurde hinzugefgt (P1=0/1->ok/failed, P2=Nummer)
MSR_KRL_MTDELP  equ 130 ;Prozess wurde entfernt
MSR_KRL_MTADDT  equ 131 ;Timer wurde hinzugefgt (P1=0/1->ok/failed, P2=Nummer)
MSR_KRL_MTDELT  equ 132 ;Timer wurde entfernt
MSR_KRL_MTSLPP  equ 133 ;Prozess wurde in Dauer-Schlafzustand versetzt
MSR_KRL_MTWAKP  equ 134 ;Prozess wurde aus Dauer-Schlafzustand geholt

;System Commands
MSC_SYS_PRGRUN  equ 16  ;Programm laden und starten
MSC_SYS_PRGEND  equ 17  ;Programm beenden
;System Responses
MSR_SYS_PRGRUN  equ 144 ;Programm wurde geladen (P1=Result [0=ok, 1=Datei existiert nicht, 2=Datei ist kein Programm, 3=Fehler beim Laden, 4=Speicher voll])

;Desktop Commands
MSC_DSK_WINOPN  equ 32  ;Neues Fenster anlegen (P1=Bank, P2/3=Adresse Datensatz) A/IY=Adresse Datensatz =>> CF=0-> A=Fensternummer, CF=1-> Speicher voll)
MSC_DSK_WINMEN  equ 33  ;Baut Menueleiste eines Fensters auf (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WININH  equ 34  ;Zeichnet Fensterinhalt (P1=Fensternummer, P2=-1/Objekt) (I/IY,A,CF=1) [nur Top]
MSC_DSK_WINTOL  equ 35  ;Zeichnet Toolleiste (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINTIT  equ 36  ;Gibt Fenstertitel aus (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINSTA  equ 37  ;Gibt Fensterstatus aus (P1=Fensternummer) (I/IY) [nur Top]
MSC_DSK_WINMVX  equ 38  ;Setzt Fensterinhalt-Beginn im X-Bereich (P1=Fensternummer, P2/3=XPos) (I/IY,DE) [nur Top]
MSC_DSK_WINMVY  equ 39  ;Setzt Fensterinhalt-Beginn im Y-Bereich (P1=Fensternummer, P2/3=XPos) (I/IY,DE) [nur Top]
MSC_DSK_WINTOP  equ 40  ;Holt Fenster nach vorne (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMAX  equ 41  ;Maximiert Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMIN  equ 42  ;Minimiert Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMID  equ 43  ;Wiederherstellt Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINMOV  equ 44  ;Verschiebt Fenster (P1=Fensternummer, P2/3=XPos, P4/5=YPos) (A,DE/HL) [immer]
MSC_DSK_WINSIZ  equ 45  ;Setzt Fenster-Groesse (P1=Fensternummer, P2/3=XPos, P4/5=YPos) (A,DE/HL) [immer]
MSC_DSK_WINCLS  equ 46  ;Schliesst und entfernt Fenster (P1=Fensternummer) (A) [immer]
MSC_DSK_WINDIN  equ 47  ;Redrawt den Fensterinhalt eines Fensters, welches nicht Focus hat (P1=Fensternummer, P2=-1/Objekt) (A,E) [immer]
MSC_DSK_DSKSRV  equ 48  ;Desktop-Service-Anfrage (P1=Typ, P2-P5=Parameter)

;Desktop Responses
MSR_DSK_WOPNER  equ 160 ;Fensterffnen gescheitert (kein Speicher)
MSR_DSK_WOPNOK  equ 161 ;Fensterffnen erfolgreich (P4=Nummer)
MSR_DSK_WCLICK  equ 162 ;Fenster wurde geklickt (P1=Fensternummer, P2=Aktion, P4/5,P6/7,P8/9=Parameter)
MSR_DSK_DSKSRV  equ 163 ;Desktop-Service-Antwort (P1=Typ, P2-P5=Parameter)


;D E S K T O P - A K T I O N
DSK_ACT_CLOSE   equ 5   ;Close-Button wurde geklickt
DSK_ACT_MENU    equ 6   ;Menu wurde geklickt (P8/9=Menupunkt-Wert)
DSK_ACT_CONTENT equ 14  ;Inhalt wurde geklickt (P8/9=Objekt-Wert)
DSK_ACT_TOOLBAR equ 15  ;Toolbar wurde geklickt (P8/9=Objekt-Wert)


;J U M P S
jmp_memsum  equ #8100 ;MEMSUM
jmp_sysinf  equ #8103 ;SYSINF
jmp_clcnum  equ #8106 ;CLCNUM
jmp_mtgcnt  equ #8109 ;MTGCNT
jmp_timget  equ #810C ;TIMGET
jmp_timset  equ #810F ;TIMSET

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 56  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;

ORG #100
;**** 256 Application Header ****
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
              dw  AppTrnBeg-AppDatBeg      ;Length of Dat
              dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
              dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "Application 1                   ",0
.AppMemTab     db  "SymExe10"             ;File Check
              ds  34
.AppIcnSml    
db 2,8,8:db #77,#EE:db #F8,#F1:db #E9,#F1:db #DA,#79:db #BC,#5B:db #F8,#B5:db #F8,#F1:db #77,#EE
.AppIcnBig    
db 6,24,24:db #00,#00,#00,#00,#00,#00:db #00,#77,#FF,#FF,#FF,#CC:db #00,#8F,#0F,#0F,#0F,#64:db #11,#0F,#0F,#0F,#0E,#EC:db #22,#00,#00,#00,#11,#EC:db #22,#7C,#F0,#F0,#D7,#EC:db #22,#78,#F0,#F0,#D3,#EC:db #22,#78,#F0,#F0,#D3,#EC
db #22,#78,#B4,#F0,#D3,#EC:db #22,#78,#5A,#F0,#D3,#EC:db #22,#4F,#E1,#E1,#5F,#EC:db #22,#78,#F0,#5A,#D3,#EC:db #22,#78,#F0,#B4,#D3,#EC:db #22,#78,#F0,#F0,#D3,#EC:db #22,#7C,#F0,#F0,#D7,#EC:db #22,#0F,#0F,#0F,#1F,#EA:db #33,#FF,#FF,#FF,#FF,#F6
db #70,#F0,#F0,#F0,#F0,#FE:db #88,#00,#00,#00,#00,#FE:db #8B,#0F,#0F,#0F,#0F,#FE:db #9B,#9E,#F0,#3C,#E1,#FE:db #8B,#0F,#2F,#0F,#4F,#EC:db #FF,#FF,#FF,#FF,#FF,#C8:db #70,#F0,#F0,#F0,#F0,#80

;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.AppPrz:
       ld    a,(AppPrzN)
       ld    (AppDatWin+WinDatPrz),a
       db    #dd:ld l,a
       ld    a,(DskPrzN)
       db    #dd:ld h,a
       ld    a,(AppBnkNum)
       ld    h,a
       ld    l,MSC_DSK_WINOPN
       ld    (AppMsgB),hl
       ld    hl,AppDatWin
       ld    (AppMsgB+2),hl
       ld    iy,AppMsgB
       rst   #10
.App_Prz1:
       call  App_Wait_Message
       jr    nc,App_Prz1
       ld    a,(DskPrzN)
       db    #dd:cp h
       jr    nz,App_Prz1
       ld    a,(AppMsgB)
       cp    MSR_DSK_WOPNER
       jp    z,App_End
       cp    MSR_DSK_WOPNOK
       jr    nz,App_Prz1
       ld    a,(AppMsgB+4)
       ld    (AppWin),a
.App_Control_Loop:
       call   App_Wait_Message
       jr     nc,App_Control_Loop0
       cp     MSR_DSK_WCLICK
       jr     nz,App_Control_Loop0
       ld     a,(AppMsgB+2)
       cp     DSK_ACT_CLOSE
       jp     z,App_End
       cp     DSK_ACT_MENU
       jp     z,App_Menu
       cp     DSK_ACT_CONTENT
       jp     z,App_Content
.App_Control_Loop0:
       jr     App_Control_Loop

.App_Menu:
       ld     a,(AppMsgB+9)
       cp     #0
       jp     z,App_Control_Loop
       ld     hl,(AppMsgB+8)
       ld     (App_Call_Set2+1),hl
.App_Call_Set2:
       call   0
       jp     App_Control_Loop

.App_Content:
       ld     a,(AppMsgB+9)
       cp     #0
       jp     z,App_Control_Loop
       ld     hl,(AppMsgB+8)
       ld     (App_Call_Set+1),hl
.App_Call_Set:
       call   0
       jp     App_Control_Loop

.App_Wait_Message:
        rst   #30
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        db    #dd:ld h,-1
        ld    iy,AppMsgB
        rst   #18
        Or    a
        db    #dd:dec l
        ret   nz
        ld    a,(AppMsgB+0)
        Or    a
        jr    z,App_End
        scf
        ret
.App_End:
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        ld    a,(SysPrzN)
        db    #dd:ld h,a
        ld    a,(AppCodBeg+PrgPstNum)
        ld    h,a
        ld    l,MSC_SYS_PRGEND
        ld    (AppMsgB),hl
        ld    iy,AppMsgB
        rst   #10
.App_End0:
        rst   #30
        jr    App_End0









;**********************
;**** Data Section ****
;**********************
.AppDatBeg
Mnu_File   db  "File",0
Mnu_File_Open   db  "Open Project",0
Mnu_File_Save   db  "Save Project",0
Mnu_File_SaveAs   db  "Save Project as",0
Mnu_Edit   db  "Edit",0
Mnu_Edit_Copy   db  "Copy",0
Menu_List_3   db  "Option 1",0
Menu_List_2   db  "Option2",0
Menu_List_5   db  "-",0
Menu_List_1   db  "Option3",0
Menu_List_4   db  "Cut",0
Menu_List_166   db  "Paste",0
;**** Form Icon ***
.Form1_Icon:
        db 2,8,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.Form1_Caption:                 db "Personal Detail Form",0
.Form1_StatusCaption:           db "Object(s) - None Known",0
.Frame1_Text:                   db  "Frame1",0
.Frame2_Text:                   db  "Frame2",0
.Label1_Text:                   db  "Name:",0
.Radio1_Text:                   db  "Under 20",0
.Radio2_Text:                   db  "Over 20",0
.Radio3_Text:                   db  "Over 30",0
.Button1_ExtData:               
.Button1_Text:                  db  "Dont Press",0
.Button2_ExtData:               
.Button2_Text:                  db  "Press",0
.Button3_ExtData:               
.Button3_Text:                  db  "Explode",0
.Label2_Text:                   db  "Border Colour:",0
.Check1_Text:                   db  "Cheques",0
.Check2_Text:                   db  "Mail allowed",0
.Check3_Text:                   db  "Own teeth",0
.Check4_Text:                   db  "Massive organ",0


;**************************
;**** Transfer Section ****
;**************************
.AppTrnBeg
          ds    128
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB  ds    14

;***
;**** Z80 version of Form Form1 ***
;***
.AppDatWin
.Form1
.Form1_Status:                  db 1
.Form1_Display:                 db 116
.Form1_SizeAdjust:              db 0
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 28
.Form1_Top:                     dw 16
.Form1_Width:                   dw 260
.Form1_Height:                  dw 143
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 251
.Form1_ContentHeight:           dw 142
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 320
.Form1_MaxHeight:               dw 192
.Form1_IconAddr:                dw Form1_Icon
.Form1_CaptionAddr:             dw Form1_Caption
.Form1_StatusAddr:              dw Form1_StatusCaption
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw 0 ;Form1_ControlTool
.Form1_ToolBarHeight:           dw 8
     ds 136+14
.Form1_Menu:                    
.Form1_MenuData1:               dw 2
        dw  5,Mnu_File,Form1_MenuData2,0
        dw  5,Mnu_Edit,Form1_MenuData3,0
.Form1_MenuData2:               dw 3
        dw  1,Mnu_File_Open,0,0
        dw  1,Mnu_File_Save,0,0
        dw  1,Mnu_File_SaveAs,0,0
.Form1_MenuData3:               dw 3
        dw  5,Mnu_Edit_Copy,Form1_MenuData4,0
        dw  1,Menu_List_4,0,0
        dw  0,Menu_List_166,0,0
.Form1_MenuData4:               dw 4
        dw  1,Menu_List_3,0,0
        dw  3,Menu_List_2,0,0
        dw  1+8,#8000,0,0
        dw  1,Menu_List_1,0,0
;****
;**** Data Control Record (ControlWindow) ****
;****
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 17
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
;****
.Form1_ControlWindowData:       
;**** OBject Window Background Data Record ****
dw 0,255*256+0,          2,  0,0,1000,1000,0
;**** Object (Frame1) Data Record ****
.Frame1_ID:                     dw 2
.Frame1_Type:                   db 3   ;* Button
.Frame1_ExtDataBank:            db 255
.Frame1_ExtDataAddr:            dw Frame1_ExtData
.Frame1_Left:                   dw 6
.Frame1_Top:                    dw 7
.Frame1_Width:                  dw 91
.Frame1_Height:                 dw 95
     db 0,0
;**** Object (Frame2) Data Record ****
.Frame2_ID:                     dw 3
.Frame2_Type:                   db 3   ;* Button
.Frame2_ExtDataBank:            db 255
.Frame2_ExtDataAddr:            dw Frame2_ExtData
.Frame2_Left:                   dw 103
.Frame2_Top:                    dw 7
.Frame2_Width:                  dw 93
.Frame2_Height:                 dw 95
     db 0,0
;**** Object (TextLine1) Data Record ****
.TextLine1_ID:                  dw 4
.TextLine1_Type:                db 32   ;* 
.TextLine1_ExtDataBank:         db 255
.TextLine1_ExtDataAddr:         dw TextLine1_ExtData
.TextLine1_Left:                dw 12
.TextLine1_Top:                 dw 29
.TextLine1_Width:               dw 79
.TextLine1_Height:              dw 11
     db 0,0
;**** Object (Label1) Data Record ****
.Label1_ID:                     dw 5
.Label1_Type:                   db 1   ;* Form
.Label1_ExtDataBank:            db 255
.Label1_ExtDataAddr:            dw Label1_ExtData
.Label1_Left:                   dw 13
.Label1_Top:                    dw 19
.Label1_Width:                  dw 50
.Label1_Height:                 dw 8
     db 0,0
;**** Object (Radio1) Data Record ****
.Radio1_ID:                     dw 6
.Radio1_Type:                   db 18   ;* 
.Radio1_ExtDataBank:            db 255
.Radio1_ExtDataAddr:            dw Radio1_ExtData
.Radio1_Left:                   dw 12
.Radio1_Top:                    dw 49
.Radio1_Width:                  dw 73
.Radio1_Height:                 dw 8
     db 0,0
;**** Object (Radio2) Data Record ****
.Radio2_ID:                     dw 7
.Radio2_Type:                   db 18   ;* 
.Radio2_ExtDataBank:            db 255
.Radio2_ExtDataAddr:            dw Radio2_ExtData
.Radio2_Left:                   dw 12
.Radio2_Top:                    dw 58
.Radio2_Width:                  dw 77
.Radio2_Height:                 dw 8
     db 0,0
;**** Object (Radio3) Data Record ****
.Radio3_ID:                     dw 8
.Radio3_Type:                   db 18   ;* 
.Radio3_ExtDataBank:            db 255
.Radio3_ExtDataAddr:            dw Radio3_ExtData
.Radio3_Left:                   dw 12
.Radio3_Top:                    dw 67
.Radio3_Width:                  dw 79
.Radio3_Height:                 dw 9
     db 0,0
;**** Object (Button1) Data Record ****
.Button1_ID:                    dw 9
.Button1_Type:                  db 16   ;* 
.Button1_ExtDataBank:           db 255
.Button1_ExtDataAddr:           dw Button1_ExtData
.Button1_Left:                  dw 203
.Button1_Top:                   dw 11
.Button1_Width:                 dw 50
.Button1_Height:                dw 11
     db 0,0
;**** Object (Button2) Data Record ****
.Button2_ID:                    dw 10
.Button2_Type:                  db 16   ;* 
.Button2_ExtDataBank:           db 255
.Button2_ExtDataAddr:           dw Button2_ExtData
.Button2_Left:                  dw 203
.Button2_Top:                   dw 25
.Button2_Width:                 dw 50
.Button2_Height:                dw 11
     db 0,0
;**** Object (Button3) Data Record ****
.Button3_ID:                    dw 11
.Button3_Type:                  db 16   ;* 
.Button3_ExtDataBank:           db 255
.Button3_ExtDataAddr:           dw Button3_ExtData
.Button3_Left:                  dw 203
.Button3_Top:                   dw 39
.Button3_Width:                 dw 50
.Button3_Height:                dw 11
     db 0,0
;**** Object (HScroll1) Data Record ****
.HScroll1_ID:                   dw 12
.HScroll1_Type:                 db 24   ;* 
.HScroll1_ExtDataBank:          db 255
.HScroll1_ExtDataAddr:          dw HScroll1_ExtData
.HScroll1_Left:                 dw 6
.HScroll1_Top:                  dw 118
.HScroll1_Width:                dw 89
.HScroll1_Height:               dw 8
     db 0,0
;**** Object (Label2) Data Record ****
.Label2_ID:                     dw 13
.Label2_Type:                   db 1   ;* Form
.Label2_ExtDataBank:            db 255
.Label2_ExtDataAddr:            dw Label2_ExtData
.Label2_Left:                   dw 7
.Label2_Top:                    dw 109
.Label2_Width:                  dw 50
.Label2_Height:                 dw 8
     db 0,0
;**** Object (Check1) Data Record ****
.Check1_ID:                     dw 14
.Check1_Type:                   db 17   ;* 
.Check1_ExtDataBank:            db 255
.Check1_ExtDataAddr:            dw Check1_ExtData
.Check1_Left:                   dw 110
.Check1_Top:                    dw 20
.Check1_Width:                  dw 73
.Check1_Height:                 dw 8
     db 0,0
;**** Object (Check2) Data Record ****
.Check2_ID:                     dw 15
.Check2_Type:                   db 17   ;* 
.Check2_ExtDataBank:            db 255
.Check2_ExtDataAddr:            dw Check2_ExtData
.Check2_Left:                   dw 110
.Check2_Top:                    dw 31
.Check2_Width:                  dw 77
.Check2_Height:                 dw 8
     db 0,0
;**** Object (Check3) Data Record ****
.Check3_ID:                     dw 16
.Check3_Type:                   db 17   ;* 
.Check3_ExtDataBank:            db 255
.Check3_ExtDataAddr:            dw Check3_ExtData
.Check3_Left:                   dw 110
.Check3_Top:                    dw 43
.Check3_Width:                  dw 79
.Check3_Height:                 dw 8
     db 0,0
;**** Object (Check4) Data Record ****
.Check4_ID:                     dw 17
.Check4_Type:                   db 17   ;* 
.Check4_ExtDataBank:            db 255
.Check4_ExtDataAddr:            dw Check4_ExtData
.Check4_Left:                   dw 110
.Check4_Top:                    dw 54
.Check4_Width:                  dw 76
.Check4_Height:                 dw 7
     db 0,0
;**** Object (Frame1) Extra Data Record ****
.Frame1_ExtData:                
.Frame1_TextAddr:               dw  Frame1_Text
.Frame1_Appearance:             db  6
;**** Object (Frame2) Extra Data Record ****
.Frame2_ExtData:                
.Frame2_TextAddr:               dw  Frame2_Text
.Frame2_Appearance:             db  6
;**** Object (TextLine1) Extra Data Record ****
.TextLine1_ExtData:             
.TextLine1_TextAddr:            dw  TextLine1_Text
.TextLine1_FDC:                 dw  0
.TextLine1_CurPos:              dw  0
.TextLine1_Selected:            dw  0
.TextLine1_TextLen:             dw  6
.TextLine1_TextMax:             dw  24
.TextLine1_Flags:               db  0
.TextLine1_Text:                db  "Robert",0
    ds  18
;**** Object (Label1) Extra Data Record ****
.Label1_ExtData:                
.Label1_TextAddr:               dw  Label1_Text
.Label1_TextAppearance:         db  134
.Label1_TextAlignment:          db  0
;**** Object (Radio1) Extra Data Record ****
.Radio1_ExtData:                
.Radio1_GroupStatusAddr:        dw  GroupStatus0
.Radio1_TextAddr:               dw  Radio1_Text
.Radio1_TextAppearance:         db  6
.Radio1_Value:                  db  6
.Radio1_GroupCoordAddr:         dw  GroupCoord0
;**** Object (Radio2) Extra Data Record ****
.Radio2_ExtData:                
.Radio2_GroupStatusAddr:        dw  GroupStatus0
.Radio2_TextAddr:               dw  Radio2_Text
.Radio2_TextAppearance:         db  6
.Radio2_Value:                  db  7
.Radio2_GroupCoordAddr:         dw  GroupCoord0
;**** Object (Radio3) Extra Data Record ****
.Radio3_ExtData:                
.Radio3_GroupStatusAddr:        dw  GroupStatus0
.Radio3_TextAddr:               dw  Radio3_Text
.Radio3_TextAppearance:         db  6
.Radio3_Value:                  db  8
.Radio3_GroupCoordAddr:         dw  GroupCoord0
;**** Object (Button1) Extra Data Record ****
;**** Object (Button2) Extra Data Record ****
;**** Object (Button3) Extra Data Record ****
;**** Object (HScroll1) Extra Data Record ****
.HScroll1_ExtData:              
.HScroll1_FixedValue:           db  3
     db  0    ;Not Used Yet
.HScroll1_Value:                dw  0
.HScroll1_Max:                  dw  255
.HScroll1_ValueIncrease:        db  1
.HScroll1_ValueDecrease:        db  -1
;**** Object (Label2) Extra Data Record ****
.Label2_ExtData:                
.Label2_TextAddr:               dw  Label2_Text
.Label2_TextAppearance:         db  134
.Label2_TextAlignment:          db  0
;**** Object (Check1) Extra Data Record ****
.Check1_ExtData:                
.Check1_ValueAddr:              dw  Check1_Value
.Check1_TextAddr:               dw  Check1_Text
.Check1_TextAppearance:         db  6
.Check1_Value:                  db  0
;**** Object (Check2) Extra Data Record ****
.Check2_ExtData:                
.Check2_ValueAddr:              dw  Check2_Value
.Check2_TextAddr:               dw  Check2_Text
.Check2_TextAppearance:         db  6
.Check2_Value:                  db  0
;**** Object (Check3) Extra Data Record ****
.Check3_ExtData:                
.Check3_ValueAddr:              dw  Check3_Value
.Check3_TextAddr:               dw  Check3_Text
.Check3_TextAppearance:         db  6
.Check3_Value:                  db  1
;**** Object (Check4) Extra Data Record ****
.Check4_ExtData:                
.Check4_ValueAddr:              dw  Check4_Value
.Check4_TextAddr:               dw  Check4_Text
.Check4_TextAppearance:         db  6
.Check4_Value:                  db  1
.GroupStatus0:  db  7
.GroupCoord0:   db  -1,-1,-1,-1
.AppTrnEnd


