
;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_Control_ID		db	0
.V_App_Control_Addr		dw	0
.V_App_Form_ID			db	0
.V_App_Form_Addr		dw 	0
.V_App_Action_ID		db	0
.V_App_OS_Form			db  0
.V_App_In_Use			db 	0

.AppPrz:
;**** Open Primary Window ****
		call	SymStudio_StringMemory
		ld		a,0								;**** Form to Open first
		call	SyB_Studio_WindowOpen			;**** Form Opener
		;**** Sets up the Timer Stack ****
		ld		hl,SyStudio_TimerStack
		ld		a,(AppBnkNum)
		call	SyKernel_MTADDT
  		jp      c,SyB_Studio_End
       	ld      (PrgPstSpz+AppCodBeg),a

;****************************************
;**** Main Application Control Loop *****
;****************************************
.SyB_Control_Loop:
		ld		a,(V_App_In_Use)
		And		a
		jr		nz,SyB_Control_Loop_1		
		call	SymStudio_App_Wait_Message		;**** See what Event has occurred
		jr		nc,SyB_Control_Loop_2			;**** Erm none do again
		cp		MSR_DSK_WCLICK
		jp		z,SyB_Event_Control_1		
		cp		166								;**** Resize window
		jp		z,SyB_Event_Resize_1
.SyB_Control_Loop_2:
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,4								;**** C = 4 = Main loop
		call	SyB_Call_Form_Event
.SyB_Control_Loop_1:
		Xor		a
		ld		(V_App_In_Use),a
		jr		SyB_Control_Loop
		
	
.SyB_Event_Control_1		
		ld		a,(Event_Type)	   
		cp		DSK_ACT_CLOSE
		jp		z,SyB_Studio_End
		cp		DSK_ACT_MENU
 		jp		z,App_Menu
 		cp		DSK_ACT_CONTENT
 		jp		z,App_Content
		cp		DSK_ACT_KEY
		jp		z,App_Key
		jp		SyB_Control_Loop_1
		
		
		
		
;****              ****		
;**** Resize Event ****
;****              ****
.SyB_Event_Resize_1:
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,3								;**** C = 3 = Resize event
		call	SyB_Call_Form_Event
		jp		SyB_Control_Loop_1			

;*********************
;**** Key Control ****
;*********************
.App_Key:
		ld		a,(AppMsgB+4)
		jp		SyB_Control_Loop
		di
		jr		App_Key

;**********************
;**** Menu Control ****
;**********************
.App_Menu:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		hl,(AppMsgB+8)
		Xor		a
		cp		h
		jr		nz,App_Call_Set12
		cp		l
		jp		z,SyB_Control_Loop_1
.App_Call_Set12
		Xor		a
		ld		(V_App_In_Use),a
		push	ix
		push	iy
		ld		(App_Call_Set2+1),hl
.App_Call_Set2:
		call	0
		pop		iy
		pop		ix		
		jp		SyB_Control_Loop

;****************************************
;**** User has clicked on one Object ****
;****************************************
.App_Content:
		call	SyB_Studio_Event_Object
		ld		e,(ix+14)
		ld		d,(ix+15)
		Xor		a
		cp		e
		jp		nz,SyB_Studio_Content_Event_1
		cp		d
		jp		nz,SyB_Studio_Content_Event_1
		jp		SyB_Control_Loop
.SyB_Studio_Content_Event_1:
		Xor		a
		ld		(V_App_In_Use),a
		ld		(SyB_Studio_Content_Event_2+1),de
.SyB_Studio_Content_Event_2
		call	0		
		jp		SyB_Control_Loop		
		
		
		


;		call	App_Get_Event_Control_Addr
;		;**** Tab Check should go here
;		;ld		de,2
;		;add		hl,de
;		;ld		a,(hl)						;**** Get type
;		;cp		20
;		;jp		z,Check_Tabs		
;		ld		de,14
;		add		hl,de
;		Xor		a
;		ld		e,(hl)
;		inc		hl
;		ld		d,(hl)
;		cp		e
;		jr		nz,App_CallUserEvent_2
;		cp		d
;		jp		z,SyB_Control_Loop_1
;.App_CallUserEvent_2
;		Xor		a
;		ld		(V_App_In_Use),a
;		push	ix
;		push	iy
;		ld		(App_Content3+1),de
;		ld		a,(AppMsgB+0)				;**** Action ID
;.App_Content3:
;		call	0
;		pop		iy
;		pop		ix
;		jp		SyB_Control_Loop
;
;.App_Get_Event_Control_Addr
;		ld		a,(Event_Control_ID+1)
;		add		a
;		ld		e,a
;		ld		d,0
;		ld		hl,ControWindowDataList
;		add		hl,de
;		ld		e,(hl)
;		inc		hl
;		ld		d,(hl)
;		ld		a,(Event_Control_ID+0)
;		ld		l,a
;		ld		h,0
;		add		hl,hl
;		add		hl,hl
;		add		hl,hl
;		add		hl,hl
;		add		hl,de
;		ret

;****                                     ****
;**** Get 16 Byte Address block of Object ****
;****                                     ****
.SyB_Studio_Event_Object:
		ld		a,(Event_Form_ID)
		ld		c,a
		call	SyB_Get_FormNo
		;e = Symstudio form number
		ld		d,0
		ld		hl,ControWindowDataList
		add		hl,de
		add		hl,de
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		a,(Event_Control_ID)
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,de
		push	hl
		pop		ix
		ret

;*********************************
;**** SymStudio wait Message *****
;*********************************
.SymStudio_App_Wait_Message:
		rst		#30
		ld		a,(AppPrzN)
       	db		#dd:ld l,a
		db		#dd:ld h,-1
 		ld		iy,AppMsgB
		rst		#18
		Or		a
		db		#dd:dec l
		ret		nz
		ld		a,(AppMsgB+0)
		Or		a
		jp		z,SyB_Studio_End
		scf
		ret

;****                       ****		
;**** Shut down Application ****
;****                       ****		
.SyB_Studio_End
		ld		a,(Event_Form_ID)
		ld		c,a
		call	SyB_Get_FormNo
		push	de
		ld		a,e
		call	SyB_Studio_CloseForm
		pop		de
		ld		a,e
		And		a
		jp		z,SyB_Studio_End_2
		;Is Form 0 form?????
		ld		a,(SyB_Studio_FormOS)
		call	SyDesktop_WINCLS		
		jp		SyB_Control_Loop_1
		
.SyB_Studio_End_2
		Xor		a	
		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.SyB_Studio_End_1
 		rst		#30
		jr		SyB_Studio_End_1

;****                  ****
;**** Opens a Form 0-7 ****
;****                  ****
.SyB_Studio_WindowOpen:
		ld		(SyB_Studio_FormNo),a			;**** Store the number of the Internal Window
		ld		hl,SyB_Studio_FormIDs			;**** Point to Start of Window List
		ld		e,a								;**** DE = A
		ld		d,0
		add		hl,de							;**** Calc Position
		ld		a,(hl)							;**** Checks if exists
		push	hl
		cp		255								;
		jr		nz,SyB_Studio_WindowOpen_2		;**** If not clear then Already Open 	
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,0								;**** C = 0 = Get data Begin Address
		call	SymStudio_GetWindowEventAddr	;**** Get Address of Window Data
		ld		e,(hl)
		inc		hl
		ld		d,(hl)							;**** DE = Address of Window Data
		ld		a,(AppBnkNum)
		call	SyDesktop_WINOPN
		jr		c,SyB_Studio_WindowOpen_2		;**** If Carry then hasn't Opened window
		pop		hl
		ld		(hl),a							;**** Store Inetrnal number into form list
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number
		ld		c,1								;**** C = 1 = Get Open Address
		call	SyB_Call_Form_Event
		Xor		a		
		ret
.SyB_Studio_WindowOpen_2
		pop		hl
		di
.djr	jr		djr

		Xor		a
		scf
		ret
;****              ****		
;**** Close a Form ****
;****              ****
.SyB_Studio_CloseForm
		ld		(SyB_Studio_FormNo),a			;**** Store the number of the Internal Window
		ld		hl,SyB_Studio_FormIDs			;**** Point to Start of Window List
		ld		e,a								;**** DE = A
		ld		d,0
		add		hl,de							;**** Calc Position
		ld		a,(hl)							;**** Checks if exists
		cp		255
		jp		z,SyB_Studio_CloseForm_Fail
		ld		(SyB_Studio_FormOS),a
		ld		a,255
		ld		(hl),a
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number
		ld		c,2								;**** C = 1 = Get Open Address
		call	SyB_Call_Form_Event	
		ret		
.SyB_Studio_CloseForm_Fail
		Xor		a
		ret
.SyB_Studio_FormOS:		db		0

;****                       ****
;**** Check If Event and Do ****
;****                       ****
;A=Form No C=Event To search
.SyB_Call_Form_Event:
		call	SymStudio_GetWindowEventAddr
		Xor		a
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		cp		e		
		jr		nz,SyB_Call_Form_Event_2	
		cp		d
		ret		z
.SyB_Call_Form_Event_2	
		ld		(SyB_Call_Form_Event_3+1),de
.SyB_Call_Form_Event_3
		call	0
		ret

;****                                 ****
;**** Get User Form No fro OS Form No ****
;****                                 ****
;C=OS Form Number to search for
.SyB_Get_FormNo:
	ld		b,8
	ld		e,0
	ld		hl,SyB_Studio_FormIDs
.SyB_Get_FormNo_1	
	ld		a,(hl)
	cp		c
	ret		z
	inc		e
	inc		hl
	djnz	SyB_Get_FormNo_1
	Xor		a
	ret


;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
;****     4 = Main Loop Address
.SymStudio_GetWindowEventAddr
	add		a				;Times 2
	add		a				;Times 4
	add		a				;Times 8
	add		a				;Times 16
	ld		hl,App_Form_List
	ld		e,a
	ld		d,0
	add		hl,de
	ld		b,0
	add		hl,bc		
	add		hl,bc
	ret

.SyB_Studio_FormNo:		db	0
.SyB_Studio_FormIDs:	db  255,255,255,255,255,255,255,255


.SymStudio_StringMemory:
		ld		a,(AppBnkNum)
		ld		e,0
		ld		bc,#1000
		rst 	#20:dw #8118
		Xor		a
		ld		(SyB_StrStackAddr),hl
		ld		bc,1024+506					;506 ; Cos it goes down	
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ld		bc,6						;Total 1536
		add		hl,bc
		ld		(SyB_File_Name_Input),hl
		ld		bc,256						;Total 1792
		add		hl,bc
		ld		(SyB_File_Data_Buffer_1),hl
		ld		(hl),a
		ld		bc,528						;Total 2320
		add		hl,bc
		ld		(SyB_File_Data_Buffer_2),hl
		ld		(hl),a
		ld		bc,528						;Total 2848
		add		hl,bc
		ld		(SyB_File_Data_Buffer_3),hl
		ld		(hl),a
		ld		bc,528						;Total 3376
		add		hl,bc
		ld		(SyB_File_Data_Buffer_4),hl
		ld		(hl),a
		;**** Bit in Transfer RAM
		ld		a,(AppBnkNum)
		ld		e,2
		ld		bc,#200
		rst 	#20:dw #8118
		ld		(SyB_File_Dialog_Pointer),hl
		ret
		
		
		
.SyB_File_Dialog_Pointer:	dw	0		
.SyB_File_Name_Input:		dw	0
.SyB_File_Data_Buffer_1:	dw	0
.SyB_File_Data_Buffer_2:	dw	0
.SyB_File_Data_Buffer_3:	dw	0
.SyB_File_Data_Buffer_4:	dw	0
.SyB_StrStackAddr:			dw	0
.SyB_RetAddrTemp:			dw	0
.SyB_StackAddr:				dw	0
.ErrorNum:					dw	0
.ErrorPC:					dw	0

.False:						db	0
.True:						db	1
		
		
;0      - String Stack		
;1024   - Stack
;1536   - File store
;1792   - File Data Buffer 1
;2320	- File Data Buffer 2
;2848   - File Data Buffer 3
;3376   - File Data Buffer 4
;3904   End

;.SyB_StrStackAddr:	dw	SyB_StrStackData
;.SyB_StrStackData:	ds	1024,0
;.SyB_RetAddrTemp:	dw	0
;.SyB_StackAddr:		dw	SyB_StackDataTop
;.SyB_StackData:		ds	32*6
;.SyB_StackDataTop:	ds	6

;**** This is a Purely SymStudio contruct ****
.Sys_Timer_Code:
	ld		hl,SyStud_TimerRoutines		;List of where all the Timer data is
.Sys_Timer_Loop_Thing
	ld		e,(hl)						;Get Address from HL into DE
	inc		hl							;
	ld		d,(hl)						;
	inc		hl							;
	Xor		a							;Check if DE=0 cos then No more Timer Check
	cp		d
	jr		nz,Sys_Keep_Going1	
	cp		e
	jr		nz,Sys_Keep_Going1
	rst		#30							;Routine Empty
	jp		Sys_Timer_Code
.Sys_Keep_Going1
	ld		a,(de)						;Check the Timer Active if not 1 ingore
	cp		1
	jr		nz,Sys_Timer_Loop_Thing
	;**** Status clear so can check if Event Happens
	inc		de							;Move onto Timer Status byte
	ld		a,(de)
	cp 		0							;If A=then Active
	jr		nz,Sys_Timer_Loop_Thing
	;**** Okay we have to Do the Counter now
	ex		de,hl
	inc		hl
	ld		c,(hl)
	inc		hl
	ld		b,(hl)
	dec		bc
	bit		7,b
	jr		nz,Sys_Timer_Timed_Out
	ld		(hl),b
	dec		hl
	ld		(hl),c
	ex		de,hl
	jr		Sys_Timer_Loop_Thing
.Sys_Timer_Timed_Out:
	inc		hl							;Moves to Low Byte of Max Word
	ld		c,(hl)						;Get
	inc		hl							;Move to High Byte of Max Word
	ld		b,(hl)						;Get
	dec		hl							;Back to Low Byte
	dec		hl							;Back to Hi Byte Counter
	ld		(hl),b						;Store
	dec		hl							;Low Byte Counter
	ld		(hl),c						;Store
	dec		hl							;Back to Status
	push	hl
	ld		a,1
	ld		(hl),a
	inc		hl
	inc		hl							;High Byte Counter
	inc		hl							;Low Byte Max
	inc		hl							;High Byte Max
	inc		hl   						;Jump Address
	ld		a,(hl)
	ld		(Sys_Timer_JumpLoc1+1),a
	inc		hl
	ld		a,(hl)
	ld		(Sys_Timer_JumpLoc1+2),a
	push	de
.Sys_Timer_JumpLoc1
	call	0
	pop		hl
	pop		de
	ld		a,0
	ld		(de),a
	jr		Sys_Timer_Loop_Thing
	