
;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_Control_ID		db	0
.V_App_Control_Addr		dw	0
.V_App_Form_ID			db	0
.V_App_Form_Addr		dw 	0
.V_App_Action_ID		db	0
.V_App_OS_Form			db  0
.V_App_In_Use			db 	0

.False:					db	0
.True:					db	1

.AppPrz:
;**** Open Primary Window ****
		ld		a,0							;**** Form to Open first
		call	SymStudio_WindowOpen		;**** Form Opener
		;**** Sets up the Timer Stack ****
		ld		hl,SyStudio_TimerStack
		ld		a,(AppBnkNum)
		call	SyKernel_MTADDT
  		jp      c,App_End
       	ld      (PrgPstSpz+AppCodBeg),a

		call	SymStudio_StringMemory


;****************************************
;**** Main Application Control Loop *****
;****************************************
.SyB_Control_Loop:
		ld		a,(V_App_In_Use)
		And		a
		jr		nz,SyB_Control_Loop_1
		call	SymStudio_App_Wait_Message	;**** See what Event has occurred
		jr		nc,SyB_Control_Loop_1		;**** Erm none do again
		cp		MSR_DSK_WCLICK
		jp		z,SyB_Event_Control_1		
		cp		166							;**** Resize window
		jp		z,SyB_Event_Resize_1

.SyB_Control_Loop_1:
		Xor		a
		ld		(V_App_In_Use),a
		jr		SyB_Control_Loop
		
;****              ****		
;**** Resize Event ****
;****              ****
.SyB_Event_Resize_1:
		ld		a,(SymStudio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,3								;**** C = 3 = Resize event
		jp		SyB_User_Event
		
		
;****                          ****		
;**** Call User Event if Exist ****
;****                          ****
;a = form application number
;c = event type   (0)-Main (1)-Open (2)-Close (3)-Resize
.SyB_User_Event:		
		call	SymStudio_GetWindowEventAddr	;**** Get Address of Window Data
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		Xor		a
		Or		e
		jp		nz,SyB_Event_Resize_3
		Or 		d
		jp		z,SyB_Control_Loop_1
.SyB_Event_Resize_3:
		ld		(SyB_Event_Resize_4+1),de
		push	ix
		push	iy		
.SyB_Event_Resize_4:
		call	0
		pop		iy
		pop		ix		
		jp		SyB_Control_Loop_1
		
		
		
		
.SyB_Event_Control_1		
		ld		a,(Event_Type)	   
		cp		DSK_ACT_CLOSE
		jp		z,App_End
		cp		DSK_ACT_MENU
 		jp		z,App_Menu
 		cp		DSK_ACT_CONTENT
 		jp		z,App_Content
		cp		DSK_ACT_KEY
		jp		z,App_Key
		jp		SyB_Control_Loop_1

;*********************
;**** Key Control ****
;*********************
.App_Key:
		ld		a,(AppMsgB+4)
		jp		SyB_Control_Loop
		di
		jr		App_Key

;**********************
;**** Menu Control ****
;**********************
.App_Menu:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		hl,(AppMsgB+8)
		Xor		a
		cp		h
		jr		nz,App_Call_Set12
		cp		l
		jp		z,SyB_Control_Loop_1
.App_Call_Set12
		Xor		a
		ld		(V_App_In_Use),a
		push	ix
		push	iy
		ld		(App_Call_Set2+1),hl
.App_Call_Set2:
		call	0
		pop		iy
		pop		ix		
		jp		SyB_Control_Loop

;****************************************
;**** User has clicked on one Object ****
;****************************************
.App_Content:
		call	App_Get_Event_Control_Addr
		;**** Tab Check should go here
		;ld		de,2
		;add		hl,de
		;ld		a,(hl)						;**** Get type
		;cp		20
		;jp		z,Check_Tabs		
		ld		de,14
		add		hl,de
		Xor		a
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		cp		e
		jr		nz,App_CallUserEvent_2
		cp		d
		jp		z,SyB_Control_Loop_1
.App_CallUserEvent_2
		Xor		a
		ld		(V_App_In_Use),a
		push	ix
		push	iy
		ld		(App_Content3+1),de
		ld		a,(AppMsgB+0)				;**** Action ID
.App_Content3:
		call	0
		pop		iy
		pop		ix
		jp		SyB_Control_Loop

.App_Get_Event_Control_Addr
		ld		a,(Event_Control_ID+1)
		add		a
		ld		e,a
		ld		d,0
		ld		hl,ControWindowDataList
		add		hl,de
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		a,(Event_Control_ID+0)
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,de
		ret

;*********************************
;**** SymStudio wait Message *****
;*********************************
.SymStudio_App_Wait_Message:
		rst		#30
		ld		a,(AppPrzN)
       db		#dd:ld l,a
       db		#dd:ld h,-1
       ld		iy,AppMsgB
       rst		#18
       Or		a
       db		#dd:dec l
       ret		nz
       ld		a,(AppMsgB+0)
       Or		a
       jr		z,App_End
		scf
		ret
.App_End:
        ld    a,(AppPrzN)
        db    #dd:ld l,a
        ld    a,(SysPrzN)
        db    #dd:ld h,a
        ld    a,(AppCodBeg+PrgPstNum)
        ld    h,a
        ld    l,MSC_SYS_PRGEND
        ld    (AppMsgB),hl
        ld    iy,AppMsgB
        rst   #10
.App_End0:
        rst   #30
        jr    App_End0

;**** Opens a SymStudio Window - A = 0-7 (Window Number)
.SymStudio_WindowOpen:
	ld		(SymStudio_FormNo),a			;**** Store the number of the Internal Window
	ld		hl,SymStudio_FormIDs			;**** Point to Start of Window List
	ld		e,a								;**** DE = A
	ld		d,0
	add		hl,de							;**** Calc Position
	ld		a,(hl)							;**** Checks if exists
	cp		0								;
	jr		nz,SymStudio_WindowOpen_2		;**** If not clear then Already Open 
	ld		a,(SymStudio_FormNo)			;**** A = SymStudio Window Number			
	ld		c,0								;**** C = 0 = Get data Begin Address
	call	SymStudio_GetWindowEventAddr	;**** Get Address of Window Data
	ld		e,(hl)
	inc		hl
	ld		d,(hl)							;**** DE = Address of Window Data
	ld		a,(AppPrzN)	
	ld		hl,WinDatPrz
    add		hl,de
	ld		(hl),a
	ld		a,(AppBnkNum)
	call	SyDesktop_WINOPN
	jr		c,SymStudio_WindowOpen_2		;**** If Carry then hasn't Opened window
	ld		b,a								;**** B = The Symbos Internal Window Number
	ld		a,(SymStudio_FormNo)			;**** A = SymStudio Window Number
	ld		hl,SymStudio_FormIDs			;**** Get the Start of FormID list
	ld		e,a								;**** Adds together
	ld		d,0
	add		hl,de						
	ld		(hl),b							;**** Store Inetrnal number into form list
	ld		c,1								;**** C = 1 = Get Open Address
	call	SymStudio_GetWindowEventAddr
	ld		e,(hl)
	inc		hl
	ld		d,(hl)
	cp		e		
	jr		nz,SymStudio_WindowOpenEvent	
	cp		d
	jp		z,SymStudio_WindowOpen_2
.SymStudio_WindowOpenEvent	
	ld		(SymStudio_WindowOpenEvent2+1),de
.SymStudio_WindowOpenEvent2
	call	0
.SymStudio_WindowOpen_2	
	ret	


;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
.SymStudio_GetWindowEventAddr
	add		a
	add		a
	add		a
	ld		hl,App_Form_List
	ld		e,a
	ld		d,0
	add		hl,de
	ld		b,0
	add		hl,bc
	add		hl,bc
	ret

.SymStudio_FormNo:	db	0
.SymStudio_FormIDs:	db  0,0,0,0,0,0,0,0


.SymStudio_StringMemory:
		ld		a,(AppBnkNum)
		ld		e,0
		ld		bc,#1000
		rst 	#20:dw #8118
		Xor		a
		ld		(SyB_StrStackAddr),hl
		ld		bc,1024+506					;506 ; Cos it goes down	
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ld		bc,6						;Total 1536
		add		hl,bc
		ld		(SyB_File_Name_Input),hl
		ld		bc,256						;Total 1792
		add		hl,bc
		ld		(SyB_File_Data_Buffer_1),hl
		ld		(hl),a
		ld		bc,528						;Total 2320
		add		hl,bc
		ld		(SyB_File_Data_Buffer_2),hl
		ld		(hl),a
		ld		bc,528						;Total 2848
		add		hl,bc
		ld		(SyB_File_Data_Buffer_3),hl
		ld		(hl),a
		ld		bc,528						;Total 3376
		add		hl,bc
		ld		(SyB_File_Data_Buffer_4),hl
		ld		(hl),a
		;**** Bit in Transfer RAM
		ld		a,(AppBnkNum)
		ld		e,2
		ld		bc,#200
		rst 	#20:dw #8118
		ld		(SyB_File_Dialog_Pointer),hl
		ret
		
		
		
.SyB_File_Dialog_Pointer:	dw	0		
.SyB_File_Name_Input:		dw	0
.SyB_File_Data_Buffer_1:	dw	0
.SyB_File_Data_Buffer_2:	dw	0
.SyB_File_Data_Buffer_3:	dw	0
.SyB_File_Data_Buffer_4:	dw	0
.SyB_StrStackAddr:			dw	0
.SyB_RetAddrTemp:			dw	0
.SyB_StackAddr:				dw	0
.ErrorNum:					dw	0
.ErrorPC:					dw	0


		
		
;0      - String Stack		
;1024   - Stack
;1536   - File store
;1792   - File Data Buffer 1
;2320	- File Data Buffer 2
;2848   - File Data Buffer 3
;3376   - File Data Buffer 4
;3904   End

;.SyB_StrStackAddr:	dw	SyB_StrStackData
;.SyB_StrStackData:	ds	1024,0
;.SyB_RetAddrTemp:	dw	0
;.SyB_StackAddr:		dw	SyB_StackDataTop
;.SyB_StackData:		ds	32*6
;.SyB_StackDataTop:	ds	6

;**** This is a Purely SymStudio contruct ****
.Sys_Timer_Code:
	ld		hl,SyStud_TimerRoutines		;List of where all the Timer data is
.Sys_Timer_Loop_Thing
	ld		e,(hl)						;Get Address from HL into DE
	inc		hl							;
	ld		d,(hl)						;
	inc		hl							;
	Xor		a							;Check if DE=0 cos then No more Timer Check
	cp		d
	jr		nz,Sys_Keep_Going1	
	cp		e
	jr		nz,Sys_Keep_Going1
	rst		#30							;Routine Empty
	jp		Sys_Timer_Code
.Sys_Keep_Going1
	ld		a,(de)						;Check the Timer Active if not 1 ingore
	cp		1
	jr		nz,Sys_Timer_Loop_Thing
	;**** Status clear so can check if Event Happens
	inc		de							;Move onto Timer Status byte
	ld		a,(de)
	cp 		0							;If A=then Active
	jr		nz,Sys_Timer_Loop_Thing
	;**** Okay we have to Do the Counter now
	ex		de,hl
	inc		hl
	ld		c,(hl)
	inc		hl
	ld		b,(hl)
	dec		bc
	bit		7,b
	jr		nz,Sys_Timer_Timed_Out
	ld		(hl),b
	dec		hl
	ld		(hl),c
	ex		de,hl
	jr		Sys_Timer_Loop_Thing
.Sys_Timer_Timed_Out:
	inc		hl							;Moves to Low Byte of Max Word
	ld		c,(hl)						;Get
	inc		hl							;Move to High Byte of Max Word
	ld		b,(hl)						;Get
	dec		hl							;Back to Low Byte
	dec		hl							;Back to Hi Byte Counter
	ld		(hl),b						;Store
	dec		hl							;Low Byte Counter
	ld		(hl),c						;Store
	dec		hl							;Back to Status
	push	hl
	ld		a,1
	ld		(hl),a
	inc		hl
	inc		hl							;High Byte Counter
	inc		hl							;Low Byte Max
	inc		hl							;High Byte Max
	inc		hl   						;Jump Address
	ld		a,(hl)
	ld		(Sys_Timer_JumpLoc1+1),a
	inc		hl
	ld		a,(hl)
	ld		(Sys_Timer_JumpLoc1+2),a
	push	de
.Sys_Timer_JumpLoc1
	call	0
	pop		hl
	pop		de
	ld		a,0
	ld		(de),a
	jr		Sys_Timer_Loop_Thing
	