;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                    S y m b O S   -   C o n s t a n t s                     @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


retro_mode      equ 0   ;flag, if OS is assembled for trex/c-one core/rom/dsk-control
rom_mode        equ 1   ;Rom-Version 1, Disc-Version 0


;P R O C E S S - I D S
PRC_ID_KERNEL   equ 1   ;kernel process
PRC_ID_DESKTOP  equ 2   ;desktop manager process
PRC_ID_SYSTEM   equ 3   ;system manager process


;M E S S A G E S
;General
MSC_GEN_QUIT    equ 0   ;application is beeing asked, to quit itself

;Kernel Commands
MSC_KRL_MTADDP  equ 1   ;add process (P1/2=stack, P3=priority (7 high - 1 low), P4=ram bank (0-8))
MSC_KRL_MTDELP  equ 2   ;delete process (P1=ID)
MSC_KRL_MTADDT  equ 3   ;add timer (P1/2=stack, P4=ram bank (0-8))
MSC_KRL_MTDELT  equ 4   ;delete timer (P1=ID)
MSC_KRL_MTSLPP  equ 5   ;set process to sleep mode
MSC_KRL_MTWAKP  equ 6   ;wake up process
MSC_KRL_TMADDT  equ 7   ;add counter service (P1/2=address, P3=ram bank, P4=process, P5=frequency)
MSC_KRL_TMDELT  equ 8   ;delete counter service (P1/2=address, P3=ram bank)
MSC_KRL_TMDELP  equ 9   ;delete all counter services of one process (P1=process ID)

;Kernel Responses
MSR_KRL_MTADDP  equ 129 ;process has been added (P1=0/1->ok/failed, P2=ID)
MSR_KRL_MTDELP  equ 130 ;process has been deleted
MSR_KRL_MTADDT  equ 131 ;timer process has been deleted (P1=0/1->ok/failed, P2=ID)
MSR_KRL_MTDELT  equ 132 ;timer has been removed
MSR_KRL_MTSLPP  equ 133 ;process is sleeping now
MSR_KRL_MTWAKP  equ 134 ;process has been waked up
MSR_KRL_TMADDT  equ 135 ;counter service has been added (P1=0/1->ok/failed)
MSR_KRL_TMDELT  equ 136 ;counter service has been deleted
MSR_KRL_TMDELP  equ 137 ;all counter services of a process have been deleted

;System Commands
MSC_SYS_PRGRUN  equ 16  ;load application or document (P1/2=address filename, P3=ram bank filename)
MSC_SYS_PRGEND  equ 17  ;quit application (P1=ID)
MSC_SYS_SYSWNX  equ 18  ;open dialogue to change current window (next) (-)
MSC_SYS_SYSWPR  equ 19  ;open dialogue to change current window (previouse) (vorheriges) (-)
MSC_SYS_PRGSTA  equ 20  ;open dialogue to load application or document (-)
MSC_SYS_SYSSEC  equ 21  ;open system secuity dialogue (-)
MSC_SYS_SYSQIT  equ 22  ;open shut shown dialogue (-)
MSC_SYS_SYSOFF  equ 23  ;shut down (-)
MSC_SYS_PRGSET  equ 24  ;start control panel (P1=submodul -> 0=main window, 1=display settings, 2=date/time)
MSC_SYS_PRGTSK  equ 25  ;start taskmanager (-)
MSC_SYS_SYSFIL  equ 26  ;call filemanager function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
MSC_SYS_SYSKRN  equ 27  ;call kernel function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
MSC_SYS_SYSCFG  equ 28  ;call config function (P1=number, 0=load, 1=save, 2=reload background)
MSC_SYS_SYSWRN  equ 29  ;open warning window (P1/2=adresse, P3=ram bank, P4=number of buttons)
MSC_SYS_SELOPN  equ 31  ;open fileselect dialogue (P6=filename ram bank, P8/9=filename address, P7=forbidden attributes, P10=max entries, P12=max buffer size)

;System Responses
MSR_SYS_PRGRUN  equ 144 ;application has been started (P1=result -> 0=ok, 1=file doesnt exist, 2=file is not executable, 3=error while loading, 4=memory full)
MSR_SYS_SYSFIL  equ 154 ;filemanager function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
MSR_SYS_SYSKRN  equ 155 ;kernel function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
MSR_SYS_SELOPN  equ 159 ;message from fileselect dialogue (P1 -> 0=Ok, 1=cancel, 2=already in use, 3=no memory free, 4=no window free, -1=open ok, super window has been opened [P2=number])

;Desktop Commands
MSC_DSK_WINOPN  equ 32  ;open window (P1=ram bank, P2/3=address data record)
MSC_DSK_WINMEN  equ 33  ;redraw menu bar (P1=window ID) [only if focus]
MSC_DSK_WININH  equ 34  ;redraw window content (P1=window ID, P2=-1/-Num/Object, P3=Object) [only if focus]
MSC_DSK_WINTOL  equ 35  ;redraw window toolbar (P1=window ID) [only if focus]
MSC_DSK_WINTIT  equ 36  ;redraw window title (P1=window ID) [only if focus]
MSC_DSK_WINSTA  equ 37  ;redraw window status lien (P1=window ID) [only if focus]
MSC_DSK_WINMVX  equ 38  ;set content x offset (P1=window ID, P2/3=XPos) [only if focus]
MSC_DSK_WINMVY  equ 39  ;set content y offset (P1=window ID, P2/3=XPos) [only if focus]
MSC_DSK_WINTOP  equ 40  ;takes window to the front (P1=window ID) [always]
MSC_DSK_WINMAX  equ 41  ;maximize window (P1=window ID) [always]
MSC_DSK_WINMIN  equ 42  ;minimize window (P1=window ID) [always]
MSC_DSK_WINMID  equ 43  ;restore window size (P1=window ID) [always]
MSC_DSK_WINMOV  equ 44  ;moves window to a new position (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
MSC_DSK_WINSIZ  equ 45  ;resize the window (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
MSC_DSK_WINCLS  equ 46  ;closes and removes window (P1=window ID) [always]
MSC_DSK_WINDIN  equ 47  ;redraw window content, even if it hasnt focus (P1=window ID, P2=-1/Objekt) [always]
MSC_DSK_DSKSRV  equ 48  ;desktop service request (P1=type, P2-P5=parameters)
MSC_DSK_WINSLD  equ 49  ;redraw window scrollbars (P1=window ID) [only if focus]
MSC_DSK_WINPIN  equ 50  ;redraw window content part (P1=window ID, P2=-1/-Num/Object, P3=Object, P4/5=Xbeg, P6/7=Ybeg, P8/9=Xlen, P10/11=Xlen) [always]

;Desktop Responses
MSR_DSK_WOPNER  equ 160 ;open window failed; the maximum of 32 windows has been reached
MSR_DSK_WOPNOK  equ 161 ;open window successfull (P4=number)
MSR_DSK_WCLICK  equ 162 ;window has been clicked (P1=window number, P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
MSR_DSK_DSKSRV  equ 163 ;desktop service answer (P1=type, P2-P5=parameters)
MSR_DSK_WFOCUS  equ 164 ;window got/lost focus (P1=window number, P2=type [0=blur, 1=focus])
MSR_DSK_CFOCUS  equ 165 ;control focus changed (P1=window number, P2=control number, P3=reason [0=mouse click/wheel, 1=tab key])

;Shell Commands
MSC_SHL_CHRINP  equ 64  ;char is requested (P1=channel [0=standard, 1=keyboard])
MSC_SHL_STRINP  equ 65  ;line is requested (P1=channel [0=standard, 1=keyboard], P2=ram bank, P3/4=address)
MSC_SHL_CHROUT  equ 66  ;char should be writtten (P1=channel [0=standard, 1=screen], P2=char)
MSC_SHL_STROUT  equ 67  ;line should be writtten (P1=channel [0=standard, 1=screen], P2=ram bank, P3/4=address, P5=length)
MSC_SHL_EXIT    equ 68  ;application released focus or quit itself (P1 -> 0=quit, 1=blur)

;Shell Responses
MSR_SHL_CHRINP  equ 192 ;char has been received (P1=EOF-flag [0=no EOF], P2=char, P3=error status)
MSR_SHL_STRINP  equ 193 ;line has been received (P1=EOF-flag [0=no EOF], P3=error status)
MSR_SHL_CHROUT  equ 194 ;char has been written (P3=error status)
MSR_SHL_STROUT  equ 195 ;line has been written (P3=error status)

;Screensaver Messages
MSC_SAV_INIT    equ 1   ;initialises the screen saver (P1=bank of config data, P2/3=address of config data [64bytes])
MSC_SAV_START   equ 2   ;start screen saver
MSC_SAV_CONFIG  equ 3   ;open screen savers own config window (at the end the screen saver has to send the result back to the sender)
MSR_SAV_CONFIG  equ 4   ;returns user adjusted screen saver config data (P1=bank of config data, P2/3=address of config data [64bytes])


;D E S K T O P - A C T I O N S
DSK_ACT_CLOSE   equ 5   ;close button has been clicked or ALT+F4 has been pressed
DSK_ACT_MENU    equ 6   ;menu entry has been clicked (P8/9=menu entry value)
DSK_ACT_CONTENT equ 14  ;a control of the content has been clicked (P3=sub spec [see dsk_sub...], P4=key or P4/5=Xpos within the window, P6/7=Ypos, P8/9=control value)
DSK_ACT_TOOLBAR equ 15  ;a control of the toolbar has been clicked (see DSK_ACT_CONTENT)
DSK_ACT_KEY     equ 16  ;key has been pressed without touching/modifying a control (P4=Ascii Code)

DSK_SUB_MLCLICK equ 0   ;left mouse button has been clicked
DSK_SUB_MRCLICK equ 1   ;right mouse button has been clicked
DSK_SUB_MDCLICK equ 2   ;double click with the left mouse button
DSK_SUB_MMCLICK equ 3   ;middle mouse button has been clicked
DSK_SUB_KEY     equ 7   ;keyboard has been clicked and did modify/click a control (P4=Ascii Code)
DSK_SUB_MWHEEL  equ 8   ;mouse wheel has been moved (P4=Offset)


;D E S K T O P - S E R V I C E S
DSK_SRV_MODGET  equ 1   ;get screen mode (output P2=mode)
DSK_SRV_MODSET  equ 2   ;set screen mode (input P2=mode)
DSK_SRV_COLGET  equ 3   ;get colour      (input P2=number, output P2=number, P3/4=RGB value)
DSK_SRV_COLSET  equ 4   ;set colour      (input P2=number, P3/4=RGB value)
DSK_SRV_DSKSTP  equ 5   ;freeze desktop  (input P2=type [0=Pen0, 1=Raster, 2=background, 255=no screen modification, switch off mouse])
DSK_SRV_DSKCNT  equ 6   ;continue desktop
DSK_SRV_DSKPNT  equ 7   ;clear desktop   (Eingabe P2=Typ [0=Pen0, 1=Raster, 2=background])
DSK_SRV_DSKBGR  equ 8   ;initialize and redraw desktop background
DSK_SRV_DSKPLT  equ 9   ;redraw the complete desktop


;J U M P S
jmp_memsum  equ #8100 ;MEMSUM
jmp_sysinf  equ #8103 ;SYSINF
jmp_clcnum  equ #8106 ;CLCNUM
jmp_mtgcnt  equ #8109 ;MTGCNT
jmp_timget  equ #810C ;TIMGET
jmp_timset  equ #810F ;TIMSET
jmp_memget  equ #8118 ;MEMGET
jmp_memfre  equ #811B ;MEMFRE
jmp_memsiz  equ #811E ;MEMSIZ
jmp_meminf  equ #8121 ;MEMINF
jmp_bnkrwd  equ #8124 ;BNKRWD
jmp_bnkwwd  equ #8127 ;BNKWWD
jmp_bnkrbt  equ #812A ;BNKRBT
jmp_bnkwbt  equ #812D ;BNKWBT
jmp_bnkcop  equ #8130 ;BNKCOP
jmp_bnkget  equ #8133 ;BNKGET
jmp_filf2t  equ #8136 ;FILF2T
jmp_filt2f  equ #8139 ;FILT2F
jmp_mosget  equ #813C ;MOSGET
jmp_moskey  equ #813F ;MOSKEY
jmp_bnk16c  equ #8142 ;BNK16C
jmp_keytst  equ #8145 ;KEYTST
jmp_keysta  equ #8148 ;KEYSTA
jmp_keyput  equ #814B ;KEYPUT


;Filemanager Functions (call via MSC_SYS_SYSFIL)
FNC_FIL_STOINI  equ 000
FNC_FIL_STONEW  equ 001
FNC_FIL_STORLD  equ 002
FNC_FIL_STODEL  equ 003
FNC_FIL_STOINP  equ 004
FNC_FIL_STOOUT  equ 005
FNC_FIL_STOACT  equ 006
FNC_FIL_STOINF  equ 007

FNC_FIL_DEVDIR  equ 013
FNC_FIL_DEVINI  equ 014
FNC_FIL_DEVSET  equ 015

FNC_FIL_FILINI  equ 016
FNC_FIL_FILNEW  equ 017
FNC_FIL_FILOPN  equ 018
FNC_FIL_FILCLO  equ 019
FNC_FIL_FILINP  equ 020
FNC_FIL_FILOUT  equ 021
FNC_FIL_FILPOI  equ 022
FNC_FIL_FILF2T  equ 023
FNC_FIL_FILT2F  equ 024
FNC_FIL_FILLIN  equ 025

FNC_FIL_DIRDEV  equ 032
FNC_FIL_DIRPTH  equ 033
FNC_FIL_DIRPRS  equ 034
FNC_FIL_DIRPRR  equ 035
FNC_FIL_DIRREN  equ 036
FNC_FIL_DIRNEW  equ 037
FNC_FIL_DIRINP  equ 038
FNC_FIL_DIRDEL  equ 039
FNC_FIL_DIRRMD  equ 040
FNC_FIL_DIRMOV  equ 041
FNC_FIL_DIRINF  equ 042

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 56  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;
SYMBOS_ORG #100
;**** 256 Application Header ****
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
              dw  AppTrnBeg-AppDatBeg      ;Length of Dat
              dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
              dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "SymbOS Application              ",0
.AppMemTab     db  "SymExe10"             ;File Check
              ds  34
.AppIcnSml    
        db 2,8,8
      db     0,0,42,252,32,204,42,240,2,204,42,252,85,85,0,0

        db 6,24,24
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_Control_ID		db	0
.V_App_Control_Addr		dw	0
.V_App_Form_ID			db	0
.V_App_Form_Addr		dw 	0
.V_App_Action_ID		db	0
.V_App_OS_Form			db  0
.V_App_In_Use			db 	0

.AppPrz:
;**** Open Primary Window ****
		call	SymStudio_StringMemory
		ld		a,0								;**** Form to Open first
		call	SyB_Studio_WindowOpen			;**** Form Opener
		;**** Sets up the Timer Stack ****
		ld		hl,SyStudio_TimerStack
		ld		a,(AppBnkNum)
		call	SyKernel_MTADDT
  		jp      c,SyB_Studio_End
       	ld      (PrgPstSpz+AppCodBeg),a

;****************************************
;**** Main Application Control Loop *****
;****************************************
.SyB_Control_Loop:
		ld		a,(V_App_In_Use)
		And		a
		jr		nz,SyB_Control_Loop_1		
		call	SymStudio_App_Wait_Message		;**** See what Event has occurred
		jr		nc,SyB_Control_Loop_2			;**** Erm none do again
		cp		MSR_DSK_WCLICK
		jp		z,SyB_Event_Control_1		
		cp		166								;**** Resize window
		jp		z,SyB_Event_Resize_1
.SyB_Control_Loop_2:
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,4								;**** C = 4 = Main loop
		call	SyB_Call_Form_Event
.SyB_Control_Loop_1:
		Xor		a
		ld		(V_App_In_Use),a
		jr		SyB_Control_Loop
		
	
.SyB_Event_Control_1		
		ld		a,(Event_Type)	   
		cp		DSK_ACT_CLOSE
		jp		z,SyB_Studio_End
		cp		DSK_ACT_MENU
 		jp		z,App_Menu
 		cp		DSK_ACT_CONTENT
 		jp		z,App_Content
		cp		DSK_ACT_KEY
		jp		z,App_Key
		jp		SyB_Control_Loop_1
		
		
		
		
;****              ****		
;**** Resize Event ****
;****              ****
.SyB_Event_Resize_1:
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,3								;**** C = 3 = Resize event
		call	SyB_Call_Form_Event
		jp		SyB_Control_Loop_1			

;*********************
;**** Key Control ****
;*********************
.App_Key:
		ld		a,(AppMsgB+4)
		jp		SyB_Control_Loop
		di
		jr		App_Key

;**********************
;**** Menu Control ****
;**********************
.App_Menu:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		hl,(AppMsgB+8)
		Xor		a
		cp		h
		jr		nz,App_Call_Set12
		cp		l
		jp		z,SyB_Control_Loop_1
.App_Call_Set12
		Xor		a
		ld		(V_App_In_Use),a
		push	ix
		push	iy
		ld		(App_Call_Set2+1),hl
.App_Call_Set2:
		call	0
		pop		iy
		pop		ix		
		jp		SyB_Control_Loop

;****************************************
;**** User has clicked on one Object ****
;****************************************
.App_Content:
		call	SyB_Studio_Event_Object
		ld		e,(ix+14)
		ld		d,(ix+15)
		Xor		a
		cp		e
		jp		nz,SyB_Studio_Content_Event_1
		cp		d
		jp		nz,SyB_Studio_Content_Event_1
		jp		SyB_Control_Loop
.SyB_Studio_Content_Event_1:
		Xor		a
		ld		(V_App_In_Use),a
		ld		(SyB_Studio_Content_Event_2+1),de
.SyB_Studio_Content_Event_2
		call	0		
		jp		SyB_Control_Loop		
		
		
		


;		call	App_Get_Event_Control_Addr
;		;**** Tab Check should go here
;		;ld		de,2
;		;add		hl,de
;		;ld		a,(hl)						;**** Get type
;		;cp		20
;		;jp		z,Check_Tabs		
;		ld		de,14
;		add		hl,de
;		Xor		a
;		ld		e,(hl)
;		inc		hl
;		ld		d,(hl)
;		cp		e
;		jr		nz,App_CallUserEvent_2
;		cp		d
;		jp		z,SyB_Control_Loop_1
;.App_CallUserEvent_2
;		Xor		a
;		ld		(V_App_In_Use),a
;		push	ix
;		push	iy
;		ld		(App_Content3+1),de
;		ld		a,(AppMsgB+0)				;**** Action ID
;.App_Content3:
;		call	0
;		pop		iy
;		pop		ix
;		jp		SyB_Control_Loop
;
;.App_Get_Event_Control_Addr
;		ld		a,(Event_Control_ID+1)
;		add		a
;		ld		e,a
;		ld		d,0
;		ld		hl,ControWindowDataList
;		add		hl,de
;		ld		e,(hl)
;		inc		hl
;		ld		d,(hl)
;		ld		a,(Event_Control_ID+0)
;		ld		l,a
;		ld		h,0
;		add		hl,hl
;		add		hl,hl
;		add		hl,hl
;		add		hl,hl
;		add		hl,de
;		ret

;****                                     ****
;**** Get 16 Byte Address block of Object ****
;****                                     ****
.SyB_Studio_Event_Object:
		ld		a,(Event_Form_ID)
		ld		c,a
		call	SyB_Get_FormNo
		;e = Symstudio form number
		ld		d,0
		ld		hl,ControWindowDataList
		add		hl,de
		add		hl,de
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		a,(Event_Control_ID)
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,de
		push	hl
		pop		ix
		ret

;*********************************
;**** SymStudio wait Message *****
;*********************************
.SymStudio_App_Wait_Message:
		rst		#30
		ld		a,(AppPrzN)
       	db		#dd:ld l,a
		db		#dd:ld h,-1
 		ld		iy,AppMsgB
		rst		#18
		Or		a
		db		#dd:dec l
		ret		nz
		ld		a,(AppMsgB+0)
		Or		a
		jp		z,SyB_Studio_End
		scf
		ret

;****                       ****		
;**** Shut down Application ****
;****                       ****		
.SyB_Studio_End
		ld		a,(Event_Form_ID)
		ld		c,a
		call	SyB_Get_FormNo
		push	de
		ld		a,e
		call	SyB_Studio_CloseForm
		pop		de
		ld		a,e
		And		a
		jp		z,SyB_Studio_End_2
		;Is Form 0 form?????
		ld		a,(SyB_Studio_FormOS)
		call	SyDesktop_WINCLS		
		jp		SyB_Control_Loop_1
		
.SyB_Studio_End_2
		Xor		a	
		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.SyB_Studio_End_1
 		rst		#30
		jr		SyB_Studio_End_1

;****                  ****
;**** Opens a Form 0-7 ****
;****                  ****
.SyB_Studio_WindowOpen:
		ld		(SyB_Studio_FormNo),a			;**** Store the number of the Internal Window
		ld		hl,SyB_Studio_FormIDs			;**** Point to Start of Window List
		ld		e,a								;**** DE = A
		ld		d,0
		add		hl,de							;**** Calc Position
		ld		a,(hl)							;**** Checks if exists
		push	hl
		cp		255								;
		jr		nz,SyB_Studio_WindowOpen_2		;**** If not clear then Already Open 	
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number			
		ld		c,0								;**** C = 0 = Get data Begin Address
		call	SymStudio_GetWindowEventAddr	;**** Get Address of Window Data
		ld		e,(hl)
		inc		hl
		ld		d,(hl)							;**** DE = Address of Window Data
		ld		a,(AppBnkNum)
		call	SyDesktop_WINOPN
		jr		c,SyB_Studio_WindowOpen_2		;**** If Carry then hasn't Opened window
		pop		hl
		ld		(hl),a							;**** Store Inetrnal number into form list
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number
		ld		c,1								;**** C = 1 = Get Open Address
		call	SyB_Call_Form_Event
		Xor		a		
		ret
.SyB_Studio_WindowOpen_2
		pop		hl
		di
.djr	jr		djr

		Xor		a
		scf
		ret
;****              ****		
;**** Close a Form ****
;****              ****
.SyB_Studio_CloseForm
		ld		(SyB_Studio_FormNo),a			;**** Store the number of the Internal Window
		ld		hl,SyB_Studio_FormIDs			;**** Point to Start of Window List
		ld		e,a								;**** DE = A
		ld		d,0
		add		hl,de							;**** Calc Position
		ld		a,(hl)							;**** Checks if exists
		cp		255
		jp		z,SyB_Studio_CloseForm_Fail
		ld		(SyB_Studio_FormOS),a
		ld		a,255
		ld		(hl),a
		ld		a,(SyB_Studio_FormNo)			;**** A = SymStudio Window Number
		ld		c,2								;**** C = 1 = Get Open Address
		call	SyB_Call_Form_Event	
		ret		
.SyB_Studio_CloseForm_Fail
		Xor		a
		ret
.SyB_Studio_FormOS:		db		0

;****                       ****
;**** Check If Event and Do ****
;****                       ****
;A=Form No C=Event To search
.SyB_Call_Form_Event:
		call	SymStudio_GetWindowEventAddr
		Xor		a
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		cp		e		
		jr		nz,SyB_Call_Form_Event_2	
		cp		d
		ret		z
.SyB_Call_Form_Event_2	
		ld		(SyB_Call_Form_Event_3+1),de
.SyB_Call_Form_Event_3
		call	0
		ret

;****                                 ****
;**** Get User Form No fro OS Form No ****
;****                                 ****
;C=OS Form Number to search for
.SyB_Get_FormNo:
	ld		b,8
	ld		e,0
	ld		hl,SyB_Studio_FormIDs
.SyB_Get_FormNo_1	
	ld		a,(hl)
	cp		c
	ret		z
	inc		e
	inc		hl
	djnz	SyB_Get_FormNo_1
	Xor		a
	ret


;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
;****     4 = Main Loop Address
.SymStudio_GetWindowEventAddr
	add		a				;Times 2
	add		a				;Times 4
	add		a				;Times 8
	add		a				;Times 16
	ld		hl,App_Form_List
	ld		e,a
	ld		d,0
	add		hl,de
	ld		b,0
	add		hl,bc		
	add		hl,bc
	ret

.SyB_Studio_FormNo:		db	0
.SyB_Studio_FormIDs:	db  255,255,255,255,255,255,255,255


.SymStudio_StringMemory:
		ld		a,(AppBnkNum)
		ld		e,0
		ld		bc,#1000
		rst 	#20:dw #8118
		Xor		a
		ld		(SyB_StrStackAddr),hl
		ld		bc,1024+506					;506 ; Cos it goes down	
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ld		bc,6						;Total 1536
		add		hl,bc
		ld		(SyB_File_Name_Input),hl
		ld		bc,256						;Total 1792
		add		hl,bc
		ld		(SyB_File_Data_Buffer_1),hl
		ld		(hl),a
		ld		bc,528						;Total 2320
		add		hl,bc
		ld		(SyB_File_Data_Buffer_2),hl
		ld		(hl),a
		ld		bc,528						;Total 2848
		add		hl,bc
		ld		(SyB_File_Data_Buffer_3),hl
		ld		(hl),a
		ld		bc,528						;Total 3376
		add		hl,bc
		ld		(SyB_File_Data_Buffer_4),hl
		ld		(hl),a
		;**** Bit in Transfer RAM
		ld		a,(AppBnkNum)
		ld		e,2
		ld		bc,#200
		rst 	#20:dw #8118
		ld		(SyB_File_Dialog_Pointer),hl
		ret
		
		
		
.SyB_File_Dialog_Pointer:	dw	0		
.SyB_File_Name_Input:		dw	0
.SyB_File_Data_Buffer_1:	dw	0
.SyB_File_Data_Buffer_2:	dw	0
.SyB_File_Data_Buffer_3:	dw	0
.SyB_File_Data_Buffer_4:	dw	0
.SyB_StrStackAddr:			dw	0
.SyB_RetAddrTemp:			dw	0
.SyB_StackAddr:				dw	0
.ErrorNum:					dw	0
.ErrorPC:					dw	0

.False:						db	0
.True:						db	1
		
		
;0      - String Stack		
;1024   - Stack
;1536   - File store
;1792   - File Data Buffer 1
;2320	- File Data Buffer 2
;2848   - File Data Buffer 3
;3376   - File Data Buffer 4
;3904   End

;.SyB_StrStackAddr:	dw	SyB_StrStackData
;.SyB_StrStackData:	ds	1024,0
;.SyB_RetAddrTemp:	dw	0
;.SyB_StackAddr:		dw	SyB_StackDataTop
;.SyB_StackData:		ds	32*6
;.SyB_StackDataTop:	ds	6

;**** This is a Purely SymStudio contruct ****
.Sys_Timer_Code:
	ld		hl,SyStud_TimerRoutines		;List of where all the Timer data is
.Sys_Timer_Loop_Thing
	ld		e,(hl)						;Get Address from HL into DE
	inc		hl							;
	ld		d,(hl)						;
	inc		hl							;
	Xor		a							;Check if DE=0 cos then No more Timer Check
	cp		d
	jr		nz,Sys_Keep_Going1	
	cp		e
	jr		nz,Sys_Keep_Going1
	rst		#30							;Routine Empty
	jp		Sys_Timer_Code
.Sys_Keep_Going1
	ld		a,(de)						;Check the Timer Active if not 1 ingore
	cp		1
	jr		nz,Sys_Timer_Loop_Thing
	;**** Status clear so can check if Event Happens
	inc		de							;Move onto Timer Status byte
	ld		a,(de)
	cp 		0							;If A=then Active
	jr		nz,Sys_Timer_Loop_Thing
	;**** Okay we have to Do the Counter now
	ex		de,hl
	inc		hl
	ld		c,(hl)
	inc		hl
	ld		b,(hl)
	dec		bc
	bit		7,b
	jr		nz,Sys_Timer_Timed_Out
	ld		(hl),b
	dec		hl
	ld		(hl),c
	ex		de,hl
	jr		Sys_Timer_Loop_Thing
.Sys_Timer_Timed_Out:
	inc		hl							;Moves to Low Byte of Max Word
	ld		c,(hl)						;Get
	inc		hl							;Move to High Byte of Max Word
	ld		b,(hl)						;Get
	dec		hl							;Back to Low Byte
	dec		hl							;Back to Hi Byte Counter
	ld		(hl),b						;Store
	dec		hl							;Low Byte Counter
	ld		(hl),c						;Store
	dec		hl							;Back to Status
	push	hl
	ld		a,1
	ld		(hl),a
	inc		hl
	inc		hl							;High Byte Counter
	inc		hl							;Low Byte Max
	inc		hl							;High Byte Max
	inc		hl   						;Jump Address
	ld		a,(hl)
	ld		(Sys_Timer_JumpLoc1+1),a
	inc		hl
	ld		a,(hl)
	ld		(Sys_Timer_JumpLoc1+2),a
	push	de
.Sys_Timer_JumpLoc1
	call	0
	pop		hl
	pop		de
	ld		a,0
	ld		(de),a
	jr		Sys_Timer_Loop_Thing
	

;;****                       ****
;;**** Command SetObjGraphic ****
;;****                       ****
;.SyB_SetObjGraphic
;		call	SyB_ReturnFormIDinIY
;		ld		l,(ix+13)
;		ld		h,0
;		dec		hl
;		add		hl,hl					;*2
;		add		hl,hl					;*4
;		ld		de,Sheet_Data
;		add		hl,de
;		ld		c,(hl)						;BC=Address Of Graphic Base
;		inc		hl
;		ld		b,(hl)
;		inc		hl
;		ld		e,(hl)
;		inc		hl
;		ld		d,(hl)
;		ld		l,(ix+7)
;		ld		h,(ix+8)
;		push	bc
;		ex		de,hl
;		push	hl
;		push	hl
;		pop		bc
;.SyB_Gtrrs_11		
;		add		hl,de
;		dec		bc
;		ld		a,b
;		Or		c
;		jr		nz,SyB_Gtrrs_11
;		pop		de
;		sbc		hl,de
;
;		pop		bc
;		add		hl,bc
;		ld		e,(iy+4)
;		ld		d,(iy+5)
;		push	de
;		pop		iy		
;		ld		(iy+5),l
;		ld		(iy+6),h
;		inc		hl
;		ld		(iy+3),l
;		ld		(iy+4),h
;		ld		bc,24
;		add		ix,bc
;		ld		(SyB_StackAddr),ix
;		ret

;;****                                     ****
;;**** Returns IY as Start of Form & ID No ****
;;****                                     ****
;;25 & 19 used for IX 4 Inputs
;SyB_ReturnFormIDinIY
;		ld		ix,(SyB_StackAddr)
;		ld		l,(ix+25)
;		ld		h,0
;		add		hl,hl
;		ld		de,ControWindowDataList
;		add		hl,de
;		ld		e,(hl)
;		inc		hl
;		ld		d,(hl)
;		ld		l,(ix+19)
;		ld		h,0		
;		add		hl,hl			;*2
;		add		hl,hl			;*4
;		add		hl,hl			;*8
;		add		hl,hl			;*16
;		add		hl,de
;		push	hl
;		pop		iy
;		ret
;****                       ****
;**** SheetGraphic Function ****
;****                       ****
AFunction SheetGraphic%(%,%)
		ld		ix,(SyB_StackAddr)
		ld		l,(ix+13)
		ld		h,0
		ld		de,Sheet_Data
		add		hl,hl
		add		hl,hl
		add		hl,de

		push	hl
		inc		hl
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)

		ld		l,(ix+7)
		ld		h,(ix+8)
		ex		de,hl
		push	hl
		push	hl
		pop		bc
.SyB_SheetGraphic_11
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB_SheetGraphic_11
		pop		de
		sbc		hl,de	
		ex		de,hl
		pop		hl
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		ex		de,hl
		add		hl,bc
		ld		(ix+13),l
		ld		(ix+14),h
		ld		bc,6
		add		ix,bc
		ld		(Syb_stackAddr),ix
Endf

;****                  ****
;**** Banking Commands ****
;****                  ****
.SyB_RamBankInfo
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0		
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
		db		0,0:dw 0,0,0
.SyB_RamBank_Temp:		dw	0









	

		
		
		

		




;;**** Push Byte ****
;.SyB_Push_V_Byt
;		pop		hl							;10
;		push	hl							;11
;		ld		a,(hl)						;7
;		inc		hl							;6
;		ld		h,(hl)						;7
;		ld		l,a							;4
;		ld		e,(hl)						;7
;		ld		hl,(SyB_StackAddr)			;16
;		Xor		a							;4
;		inc		hl							;6
;		ld		(hl),e						;7
;		inc		hl							;6
;		ld		(hl),a						;7
;		ld		bc,-8						;10
;		add		hl,bc						;11
;		ld		(SyB_StackAddr),hl			;16
;		pop		hl							;11
;		inc		hl							;6
;		inc		hl							;6
;		jp		(hl)


.SyB_Push_N_Flo
		pop		hl
		push	hl
		call	SyB_PushFlo
		pop		hl
		ld		bc,5
		add		hl,bc
		jp		(hl)
.SyB_Push_V_Flo
		pop		hl
		push	hl
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a
		call	SyB_PushFlo
		pop		hl
		inc		hl
		inc		hl
		jp		(hl)
.SyB_Push_Null_Flo
		ld		hl,(SyB_StackAddr)
		ld		a,1
		ld		(hl),a
		inc		hl
		Xor		a
		ld		(hl),a
		inc		hl
		ld		(hl),a
		inc		hl
		ld		(hl),a
		inc		hl
		ld		(hl),a
		inc		hl
		ld		(hl),a						;Strange but should be #80 but isnt		
		ld		bc,-11						;16
		add		hl,bc						;11
		ld		(SyB_StackAddr),hl			;16				
		ret	
;**** Push String
.SyB_Push_Null_Str
		ld		hl,(SyB_StackAddr)
		ld		a,5
		ld		(hl),a
		inc		hl
		ld		de,(SyB_StrStackAddr)
		ld		(hl),e
		inc		hl
		ld		(hl),d
		inc		hl
		Xor		a
		ld		(hl),a
		ld		bc,-9						;16
		add		hl,bc						;11
		ld		(SyB_StackAddr),hl			;16				
		ret


.SyB_Push_V_Str
		pop		hl
		push	hl
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		;address of text
		ld		hl,(SyB_StackAddr)
		push	de
		ld		a,5
		ld		(hl),a
		inc		hl
		dec		de
		ld		a,(de)
		ld		de,(SyB_StrStackAddr)
		ld		(hl),e
		inc		hl
		ld		(hl),d
		inc		hl
		ld		(hl),a
		ld		bc,-9
		add		hl,bc
		ld		(SyB_StackAddr),hl
		pop		hl
		ld		c,a
		ld		b,0
		Xor		a
		cp		c
		jr		z,SyB_Push_V_Str_2		
		ldir
.SyB_Push_V_Str_2		
		ld		(SyB_StrStackAddr),de
		pop		hl
		inc		hl
		inc		hl
		jp		(hl)


.SyB_PushFlo:
		ld		a,1
		ld		de,(SyB_StackAddr)			;**** Get Address of Data Stack
		ld		(de),a						;**** Puts Type
		inc		de							;**** Modes up Stack 1
		ldi									;**** Copies (HL)-(DE)
		ldi									;**** Copies (HL)-(DE)
		ldi									;**** Copies (HL)-(DE)
		ldi									;**** Copies (HL)-(DE)
		ldi									;**** Copies (HL)-(DE)
		ld		de,(SyB_StackAddr)
		ld		hl,-6
		add		hl,de
		ld		(SyB_StackAddr),hl
		ret								
											
;****                ****
;**** Decrease Stack ****
;**** Decreases the stack from HL (Which Is a stack Pos +1 hence -5 not 6)
;**** HL = (HL) Float Result		
.SyB_DecStack
		ld		hl,(SyB_StackAddr)
		ld		de,6
		add		hl,de
		ld		(SyB_StackAddr),hl
		ret



;****                      ****		
;**** Pushes Bool result 0 ****
;****                      ****
.SyB_Push_Bool_Result_0:
		ld		(ix+13),0					;19
		ld		(ix+14),0					;19
		ld		bc,6						;10
		add		ix,bc						;15
		ld		(Syb_StackAddr),ix			;20
		ret	
;****                      ****		
;**** Pushes Bool result 1 ****
;****                      ****
.SyB_Push_Bool_Result_1:
		ld		(ix+13),1					;19
		ld		(ix+14),0					;19
		ld		bc,6						;10
		add		ix,bc						;15
		ld		(Syb_StackAddr),ix			;20
		ret 								;10

;****           ****
;**** SyB_N_VGL ****
;****           ****
.SyB_N_VGL_2
		ld		ix,(SyB_StackAddr)		
		ld		a,(ix+14)
		Xor		%10000000
		ld		h,a
		ld		a,(ix+8)
		Xor		%10000000
		cp		h
		jr		z,SyB_N_VGL_1
		jp		nc,SyB_N_VGL_GT
		ld		a,1
		ret
.SyB_N_VGL_1
		ld		a,(ix+7)
		cp		(ix+13)
		jr		z,SyB_N_VGL_EQ		
		jp		nc,SyB_N_VGL_GT
.SyB_N_VGL_LT
		ld		a,1
		ret
.SyB_N_VGL_GT
		ld		a,-1
		ret
.SyB_N_VGL_EQ
		Xor		a
		ret		

;****           ****
;**** SyB_S_VGL ****
;****           ****
.SyB_S_VGL
		ld		ix,(SyB_StackAddr)
		ld		e,(ix+7)
		ld		d,(ix+8)
		ld		c,(ix+9)
		ld		l,(ix+13)
		ld		h,(ix+14)
		ld		b,(ix+15)
.SyB_S_VGL_1
		;**** Just Check Lengths
		ld		a,b
		cp		0
		jr		nz,SyB_S_VGL_2
		cp		c
		jr		z,SyB_N_VGL_EQ
.SyB_S_VGL_2
		Xor		a
		cp		c
		jr		z,SyB_N_VGL_LT
		cp		b
		jr		z,SyB_N_VGL_GT		
		;**** Now check Chars
		ld		a,(de)
		cp		(hl)		
		jr		nz,SyB_N_VGL_LT
		jr		c,SyB_N_VGL_GT
		inc		de
		inc		hl
		dec		b
		dec		c
		jr		SyB_S_VGL_1





;****               ****
;**** Do String Add ****
;****               ****
.SyB_S_Add:
		ld		hl,(SyB_StackAddr)
		ld		bc,9
		add		hl,bc
		ld		e,(hl)
		ld		bc,6
		add		hl,bc
		ld		a,(hl)
		add		e
		;should check not greater than 250
		ld		(hl),a
		ld		bc,-9
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ret

;******************************* 67 EQ ****************************		
;****                   ****
;**** Do Integer Equals ****
;****                   ****
.SyB2_INT_EQ
		call	SyB_N_VGL_2
.SyB2_INT_EQ_10
		cp		0
		jp		z,SyB_Push_Bool_Result_1	;***** Result was Greater Than so 1 Bool Result
		jp		SyB_Push_Bool_Result_0		;***** Result was not Greater than so 0 Bool Result		
;****                 ****
;**** Do Float Equals ****
;****                 ****
.SyB2_FLO_EQ
		call	SyB2_STACK_2_FLO
		call	FLO_VGL
		jr		SyB2_INT_EQ_10
;****                  ****
;**** Do String Equals ****
;****                  ****
.SyB2_STR_EQ
		call	SyB_S_VGL					;String comparison
		jr		SyB2_INT_EQ_10		
;******************************* 68 GTE ****************************		
;****                                ****
;**** Do Integer Greater Than Equals ****
;****                                ****
.SyB2_INT_GTE
		call	SyB_N_VGL_2
.SyB2_INT_GTE_10		
		cp		-1
		jp		z,SyB_Push_Bool_Result_0	;***** Result was not LessThanEqual so 0 Bool Result
		jp		SyB_Push_Bool_Result_1		;***** Result was LessThanEqual so 1 Bool Result
;****                              ****
;**** Do Float Greater Than Equals ****
;****                              ****
.SyB2_FLO_GTE
		call	SyB2_STACK_2_FLO
		call	FLO_VGL
		jr		SyB2_INT_GTE_10
;****                               ****
;**** Do String Greater Than Equals ****
;****                               ****
.SyB2_STR_GTE
		call	SyB_S_VGL					;String comparison
		jr		SyB2_INT_GTE_10				
;******************************* 69 LTE ****************************		
;****                              ****
;**** Do Integer Lesser Than Equal ****
;****                              ****
.SyB2_INT_LTE
		call	SyB_N_VGL_2
.SyB2_INT_LTE_10
		cp		1
		jp		z,SyB_Push_Bool_Result_0	;***** Result was not LessThanEqual so 0 Bool Result
		jp		SyB_Push_Bool_Result_1		;***** Result was LessThanEqual so 1 Bool Result
;****                            ****
;**** Do Float Lesser Than Equal ****
;****                            ****
.SyB2_FLO_LTE
		call	SyB2_STACK_2_FLO
		call	FLO_VGL
		jr		SyB2_INT_LTE_10
;****                             ****
;**** Do String Lesser Than Equal ****
;****                             ****
.SyB2_STR_LTE
		call	SyB_S_VGL					;String comparison
		jr		SyB2_INT_LTE_10	
;******************************* 70 OT ****************************		
;****                       ****
;**** Do Integer Other Than ****
;****                       ****
.SyB2_INT_OT
		call	SyB_N_VGL_2
.SyB2_INT_OT_10
		cp		0
		jp		z,SyB_Push_Bool_Result_0	;***** Result was not Other Than so 0 Bool Result
		jp		SyB_Push_Bool_Result_1		;***** Result was Other Than so 1 Bool Result
;****                     ****
;**** Do Float Other Than ****
;****                     ****
.SyB2_FLO_OT
		call	SyB2_STACK_2_FLO
		call	FLO_VGL
		jr		SyB2_INT_OT_10
;****                      ****
;**** Do String Other Than ****
;****                      ****
.SyB2_STR_OT
		call	SyB_S_VGL					;String comparison
		jr		SyB2_INT_OT_10				
;******************************* 71 LT ****************************		
;****                        ****
;**** Do Integer Lesser Than ****
;****                        ****
.SyB2_INT_LT
		call	SyB_N_VGL_2
.SyB2_INT_LT_10
		cp		-1
		jp		z,SyB_Push_Bool_Result_1	;***** Result was LessThan so 1 Bool Result
		jp		SyB_Push_Bool_Result_0		;***** Result was not LessThan so 0 Bool Result
;****                      ****
;**** Do Float Lesser Than ****
;****                      ****
.SyB2_FLO_LT
		call	SyB2_STACK_2_FLO
		call	FLO_VGL
		jr		SyB2_INT_LT_10
;****                       ****
;**** Do String Lesser Than ****
;****                       ****
.SyB2_STR_LT
		call	SyB_S_VGL					;String comparison
		jr		SyB2_INT_LT_10						
;******************************* 72 GT ****************************		
;****                         ****
;**** Do Integer Greater Than ****
;****                         ****
.SyB2_INT_GT
		call	SyB_N_VGL_2
.SyB2_INT_GT_10
		cp		1
		jp		z,SyB_Push_Bool_Result_1	;***** Result was Greater Than so 1 Bool Result
		jp		SyB_Push_Bool_Result_0		;***** Result was not Greater than so 0 Bool Result		
;****                       ****
;**** Do Float Greater Than ****
;****                       ****
.SyB2_FLO_GT
		call	SyB2_STACK_2_FLO
		call	FLO_VGL
		jr		SyB2_INT_GT_10
;****                        ****
;**** Do String Greater Than ****
;****                        ****
.SyB2_STR_GT
		call	SyB_S_VGL					;String comparison
		jr		SyB2_INT_GT_10






.SyB2_STACK_2_FLO
		ld		hl,(SyB_StackAddr)
		inc		hl
		ld		bc,6
		add		hl,bc
		ld		e,l
		ld		d,h
		add		hl,bc
		ret		

		


;**** Converts the Stack from an Int to Float Value
;**** Dependiong on What stack part needs it
SyB_INT_2_FLO_Stack_2
		ld		bc,12
		jp		SyB_INT_2_FLO_BC
SyB_INT_2_FLO_Stack_3
		ld		bc,18
		jp		SyB_INT_2_FLO_BC
SyB_INT_2_FLO_Stack_4
		ld		bc,24
		jp		SyB_INT_2_FLO_BC
SyB_INT_2_FLO_Stack_5
		ld		bc,30
		jp		SyB_INT_2_FLO_BC
SyB_INT_2_FLO_Stack_6
		ld		bc,36
		jp		SyB_INT_2_FLO_BC
SyB_INT_2_FLO_Stack_7
		ld		bc,42
		jp		SyB_INT_2_FLO_BC
SyB_INT_2_FLO_Stack_8
		ld		bc,48
		jp		SyB_INT_2_FLO_BC		
;**** Converts the Stack from an Int to Float Value
.SyB_INT_2_FLO_Stack_1
.SyB_INT_2_FLO
		ld		bc,6
.Syb_INT_2_FLO_BC		
		ld		hl,(SyB_StackAddr)
		add		hl,bc
		ld		a,1
		ld		(hl),a
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		dec		hl	
;		Xor		a
		bit		7,d
		jr		z,Syb_INT_2_FLO_BC_99				
		ld		a,e
		Xor		255
		ld		e,a
		ld		a,d
		Xor		255
		ld		d,a
		inc		de
		ld		a,128
.Syb_INT_2_FLO_BC_99			
		ex		de,hl
		call	FLO_KONV_HLA_TO_FLO	
		ret	

.SyB_Store_Char_Temp:	db 0


;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@         C P C   -   F l o a t i n g - P o i n t - R o u t i n e s          @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;--- RANDOM NUMBERS -----------------------------------------------------------
;### FLO_RANDOMIZE0 -> RND seek to 0
;### FLO_RANDOMIZE -> RND seek to (HL)
;### FLO_RND -> Gets next RND value
;### FLO_LAST_RND -> Gets current RND value

;--- OPERATIONS ---------------------------------------------------------------
;### FLO_ADD -> Adds (HL) and (DE) and copies the result in (HL)
;### FLO_SUB -> Substracts (DE) from (HL) and copies the result in (HL)
;### FLO_SUBX -> Substracts (HL) from (DE) and copies the result in (HL)
;### FLO_MULT -> Multiplicates (HL) with (DE) and copies the result in (HL)
;### FLO_DIV -> Divides (HL) by (DE) and copies the result in (HL)
;### FLO_POT -> Raises (HL) to the power of (DE) and copies the result in (HL)
;### FLO_VGL -> Compares (HL) with (DE)

;--- FUNCTIONS ----------------------------------------------------------------
;### FLO_VZW -> Changes the sign of (HL)
;### FLO_SQR -> Extracts the root of (HL)
;### FLO_LOG_NAT -> Gets natural logarythm of (HL)
;### FLO_LOG_DEC -> Gets 10-logarythm of (HL)
;### FLO_POT_E -> (HL)=E^(HL)
;### FLO_SIN -> Calculates the sinus of (HL)
;### FLO_COS -> Calculates the cosinus of (HL)
;### FLO_TAN -> Calculates the tangent of (HL)
;### FLO_ARC_TAN -> Calculates the arcus tangent of (HL)
;### FLO_10A -> (HL)=(HL)*10^A
;### FLO_SGN -> Tests the sign of (HL)

;--- MISCELLANEOUS ------------------------------------------------------------
;### FLO_PI -> Gets PI
;### FLO_MOVE -> Copies Value in (DE) to (HL)
;### FLO_DEGRAD -> Set Deg/Rad

;--- CONVERSION ---------------------------------------------------------------
;### FLO_KONV_HLA_TO_FLO -> Converts 16bit Integer + sign to FLO
;### FLO_KONV_LW_TO_FLO -> Converts 32bit Integer + sign to FLO
;### FLO_ROUND_FLO_TO_HLA -> Rounds FLO value and converts it to 16bit Integer + sign
;### FLO_ROUND_FLO_TO_LW -> Rounds FLO value and converts it to 32bit Integer + sign
;### FLO_FIX_FLO_TO_LW -> Cuts FLO value and converts it to 32bit Integer + sign
;### FLO_INT_FLO_TO_LW -> Cuts FLO value (and decrease if negative) and converts it to 32bit Integer + sign
;### FLO_KONV_HLB_TO_INT -> Converts 16bit integer + sign into 16bit Integer

;--- DISPLAY-PREPARATION ------------------------------------------------------
;### FLO_PREPARE -> Prepares the display of a FLO value


;--- begin routines -----------------------------------------------------------



.l2f7d
		ld		de,FLO_CONST_C
		jr		FLO_MOVE
.l2f87
		ex		de,hl
.l2f88
		ld hl,#b10e
		jr FLO_MOVE
.l2f8d
        ld de,#b104
.l2f90
        ex de,hl




;### FLO_MOVE -> Copies Value in (DE) to (HL)
;### Input      (DE)=Source value, (HL)=Destination
;### Output     (HL)=Value, CF=1
;### Unchanged  BC,DE,HL,IX,IY,(DE)
.FLO_MOVE
        push hl
        push de
        push bc
        ex de,hl
        ld bc,#0005
        ldir
        pop bc
        pop de
        pop hl
        scf
        ret


;### FLO_KONV_HLA_TO_FLO -> Converts 16bit Integer + sign to FLO
;### Input      HL=value, A[bit7]=sign, (DE)=destination
;### Output     HL=DE, (HL)=FLO value
;### Unchanged  BC,IX,IY
.FLO_KONV_HLA_TO_FLO
        push de
        push bc
        Or #7f
        ld b,a
        Xor a
        ld (de),a
        inc de
        ld (de),a
        inc de
        ld c,#90
        Or h
        jr nz,l2fbb
        ld c,a
        Or l
        jr z,l2fbf
        ld l,h
        ld c,#88
        jr l2fbb
.l2fb7
        dec c
        sla l
        adc a
.l2fbb
        jp p,l2fb7
        And b
.l2fbf
        ex de,hl
        ld (hl),e
        inc hl
        ld (hl),a
        inc hl
        ld (hl),c
        pop bc
        pop hl
        ret

;### FLO_KONV_LW_TO_FLO -> Converts 32bit Integer + sign to FLO
;### Input      (HL)=LW, A[bit7]=sign
;### Output     (HL)=FLO value
;### Unchanged  BC,DE,HL,IY
.FLO_KONV_LW_TO_FLO
        push bc
        ld bc,#a000
        call l2fd3
        pop bc
        ret
        ld b,#a8
.l2fd3
        push de
        call l379c
        pop de
        ret

;### FLO_ROUND_FLO_TO_HLA -> Rounds FLO value and converts it to 16bit Integer + sign
;### Input      (HL)=FLO value
;### Output     HL=abs((HL)), A[bit7]=sign
;###            CF=0 Overflow
;### Unchanged  BC,DE,IY
.FLO_ROUND_FLO_TO_HLA
        push hl
        pop ix
        Xor a
        sub (ix+#04)
        jr z,l2ffd
        add #90
        ret nc
        push de
        push bc
        add #10
        call l373d
        sla c
        adc hl,de
        jr z,l2ffa
        ld a,(ix+#03)
        Or a
.l2ff6
        ccf
        pop bc
        pop de
        ret
.l2ffa
        sbc a
        jr l2ff6
.l2ffd
        ld l,a
        ld h,a
        scf
        ret

;### FLO_ROUND_FLO_TO_LW -> Rounds FLO value and converts it to 32bit Integer + sign
;### Input      (HL)=FLO value
;### Output     (HL)=abs((HL)), B[bit7]=sign
;###            CF=0 Overflow
;### Unchanged  DE,HL,IY
.FLO_ROUND_FLO_TO_LW
        call FLO_FIX_FLO_TO_LW
        ret nc
        ret p
.l3006
        push hl
        ld a,c
.l3008
        inc (hl)
        jr nz,l3011
        inc hl
        dec a
        jr nz,l3008
        inc (hl)
        inc c
.l3011
        pop hl
        scf
        ret

;### FLO_FIX_FLO_TO_LW -> Cuts FLO value and converts it to 32bit Integer + sign
;### Input      (HL)=FLO value
;### Output     (HL)=abs((HL)), B[bit7]=sign
;###            CF=0 Overflow
;### Unchanged  DE,HL,IY
.FLO_FIX_FLO_TO_LW
        push hl
        push de
        push hl
        pop ix
        Xor a
        sub (ix+#04)
        jr nz,l3029
        ld b,#04
.l3021
        ld (hl),a
        inc hl
        djnz l3021
        ld c,#01
        jr l3051
.l3029
        add #a0
        jr nc,l3052
        push hl
        call l373d
        Xor a
        cp b
        adc a
        Or c
        ld c,l
        ld b,h
        pop hl
        ld (hl),c
        inc hl
        ld (hl),b
        inc hl
        ld (hl),e
        inc hl
        ld e,a
        ld a,(hl)
        ld (hl),d
        And #80
        ld b,a
        ld c,#04
        Xor a
.l3047
        Or (hl)
        jr nz,l304f
        dec hl
        dec c
        jr nz,l3047
        inc c
.l304f
        ld a,e
        Or a
.l3051
        scf
.l3052
        pop de
        pop hl
        ret

;### FLO_INT_FLO_TO_LW -> Cuts FLO value (and decrease if negative) and converts it to 32bit Integer + sign
;### Input      (HL)=FLO value
;### Output     (HL)=abs((HL)), B[bit7]=sign
;###            CF=0 Overflow
;### Unchanged  DE,HL,IY
.FLO_INT_FLO_TO_LW
        call FLO_FIX_FLO_TO_LW
        ret nc
        ret z
        bit 7,b
        ret z
        jr l3006

;### FLO_PREPARE -> Prepares the display of a FLO value
;### Input      (HL)=FLO value
;### Output     (HL)=LW normed mantissa
;###            B = sign of mantissa
;###            D = sign of exponent
;###            E = exponent/comma position
;###            C = number of significant mantissa bytes (NOT digits!)
;### Unchanged  HL
.FLO_PREPARE
        call FLO_SGN
        ld b,a
        jr z,l30b7
        call m,l3734
        push hl
        ld a,(ix+#04)
        sub #80
        ld e,a
        sbc a
        ld d,a
        ld l,e
        ld h,d
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,de
        add hl,hl
        add hl,de
        add hl,hl
        add hl,hl
        add hl,de
        ld a,h
        sub #09
        ld c,a
        pop hl
        push bc
        call nz,l30c8
.l3085
        ld de,FLO_CONST_A
        call l36e2
        jr nc,l3098
        ld de,FLO_CONST_D1
        call FLO_MULT
        pop de
        dec e
        push de
        jr l3085
.l3098
        ld de,FLO_CONST_B
        call l36e2
        jr c,l30ab
        ld de,FLO_CONST_D1
        call FLO_DIV
        pop de
        inc e
        push de
        jr l3098
.l30ab
        call FLO_ROUND_FLO_TO_LW
        ld a,c
        pop de
.l30b0
        ld b,d
        dec a
        add l
        ld l,a
        ret nc
        inc h
        ret
.l30b7
        ld e,a
        ld (hl),a
        ld c,#01
        ret

;### FLO_KONV_HLB_TO_INT -> Converts 16bit integer + sign into 16bit Integer
;### Input      HL=16 bit integer, B[bit7]=sign
;### Output     HL=signed 16 bit integer
;###            CF=0 Overflow
;### Unchanged  BC,DE,IX,IY
.FLO_KONV_HLB_TO_INT
        ld a,h
        Or a
        jp m,ldd42
        Or b
        jp m,ldded
        scf
        ret
.ldd42
        Xor #80
        Or l
        ret nz
        ld a,b
        scf
        adc a
        ret
.ldded
        Xor a
        sub l
        ld l,a
        sbc h
        sub l
        cp h
        ld h,a
        scf
        ret nz
        cp #01
        ret

;### FLO_10A -> (HL)=(HL)*10^A
;### Input      (HL)=value, A=potence
;### Output     (HL)=(HL)*10^A
;###            CF=0 Overflow
;### Unchanged  HL
.FLO_10A
        cpl
        inc a
.l30c8
        Or a
        scf
        ret z
        ld c,a
        jp p,l30d1
        cpl
        inc a
.l30d1
        ld de,FLO_CONST_D2
        sub #0d
        jr z,l30ed
        jr c,l30e3
        push bc
        push af
        call l30ed
        pop af
        pop bc
        jr l30d1
.l30e3
        ld b,a
        add a
        add a
        add b
        add e
        ld e,a
        ld a,#ff
        adc d
        ld d,a
.l30ed
        ld a,c
        Or a
        jp p,FLO_DIV
        jp FLO_MULT

;### FLO_RANDOMIZE0 -> RND seek to 0
;### Unchanged  AF,BC,DE,IX,IY
.FLO_RANDOMIZE0
        ld hl,#8965
        ld (FLO_VALUE_RND+2),hl
        ld hl,#6c07
        ld (FLO_VALUE_RND),hl
        ret

;### FLO_RANDOMIZE -> RND seek to (HL)
;### Input      (HL)=value
;### Unchanged  C,IY,FLO(HL)
.FLO_RANDOMIZE
        ex de,hl
        call FLO_RANDOMIZE0
        ex de,hl
        call FLO_SGN
        ret z
        ld de,FLO_VALUE_RND
        ld b,#04
.l3151
        ld a,(de)
        Xor (hl)
        ld (de),a
        inc de
        inc hl
        djnz l3151
        ret

;### FLO_RND -> Gets next RND value
;### Input      (HL)=Destination
;### Output     (HL)=new RND
;### Unchanged  HL,IY
.FLO_RND
        push hl
        ld hl,(FLO_VALUE_RND+2)
        ld bc,#6c07
        call l319c
        push hl
        ld hl,(FLO_VALUE_RND)
        ld bc,#8965
        call l319c
        push de
        push hl
        ld hl,(FLO_VALUE_RND+2)
        call l319c
        ex (sp),hl
        add hl,bc
        ld (FLO_VALUE_RND),hl
        pop hl
        ld bc,#6c07
        adc hl,bc
        pop bc
        add hl,bc
        pop bc
        add hl,bc
        ld (FLO_VALUE_RND+2),hl
        pop hl

;### FLO_LAST_RND -> Gets current RND value
;### Input      (HL)=Destination
;### Output     (HL)=current RND
;### Unchanged  HL,IY
.FLO_LAST_RND
        push hl
        pop ix
        ld hl,(FLO_VALUE_RND)
        ld de,(FLO_VALUE_RND+2)
        ld bc,#0000
        ld (ix+#04),#80
        jp l37ac
.l319c
        ex de,hl
        ld hl,#0000
        ld a,#11
.l31a2
        dec a
        ret z
        add hl,hl
        rl e
        rl d
        jr nc,l31a2
        add hl,bc
        jr nc,l31a2
        inc de
        jr l31a2

;### FLO_LOG_DEC -> Gets 10-logarythm of (HL)
;### Input      (HL)=value
;### Output     (HL)=LOG10((HL))
;###            CF=0 error, value zero or negative
;### Unchanged  HL
.FLO_LOG_DEC
        ld de,FLO_CONST_LOGDEC
        jr l31b9

;### FLO_LOG_NAT -> Gets natural logarythm of (HL)
;### Input      (HL)=value
;### Output     (HL)=LOG((HL))
;###            CF=0 error, value zero or negative
;### Unchanged  HL
.FLO_LOG_NAT
        ld de,FLO_CONST_LOGNAT
.l31b9
        call FLO_SGN
        dec a
        cp #01
        ret nc
        push de
        call l36d3
        push af
        ld (ix+#04),#80
        ld de,FLO_CONST_LOG
        call FLO_VGL
        jr nc,l31d7
        inc (ix+#04)
        pop af
        dec a
        push af
.l31d7
        call l2f87
        push de
        ld de,FLO_CONST_C
        push de
        call FLO_ADD
        pop de
        ex (sp),hl
        call FLO_SUB
        pop de
        call FLO_DIV
        call l3440
        db #04
        db #4c,#4b,#57,#5e,#7f
        db #0d,#08,#9b,#13,#80
        db #23,#93,#38,#76,#80
        db #20,#3b,#aa,#38,#82

.l3203
        push de
        call FLO_MULT
        pop de
        ex (sp),hl
        ld a,h
        Or a
        jp p,l3210
        cpl
        inc a
.l3210
        ld l,a
        ld a,h
        ld h,#00
        call FLO_KONV_HLA_TO_FLO
        ex de,hl
        pop hl
        call FLO_ADD
        pop de
        jp FLO_MULT

;### FLO_POT_E -> (HL)=E^(HL)
;### Input      (HL)=value
;### Output     (HL)=E^(HL)
;###            CF=0 Overflow
;### Unchanged  HL
.FLO_POT_E
        ld b,#e1
        call l3492
        jp nc,l2f7d
        ld de,FLO_CONST_POTE2
        call FLO_VGL
        jp p,l37e8
        ld de,FLO_CONST_POTE3
        call FLO_VGL
        jp m,l37e2
        ld de,FLO_CONST_POTE1
        call l3469
        ld a,e
        jp p,l3255
        neg
.l3255
        push af
        call l3570
        call l2f8d
        push de
        call l3443
        db #03
        db #f4,#32,#eb,#0f,#73
        db #08,#b8,#d5,#52,#7b
.FLO_CONST_HALF                     ;=1/2
        db #00,#00,#00,#00,#80

.l3270
        ex (sp),hl
        call l3443
        db #02
        db #09,#60,#de,#01,#78
        db #f8,#17,#72,#31,#7e

.l327f
        call FLO_MULT
        pop de
        push hl
        ex de,hl
        call FLO_SUB
        ex de,hl
        pop hl
        call FLO_DIV
        ld de,FLO_CONST_HALF
        call FLO_ADD
        pop af
        scf
        adc (ix+#04)
        ld (ix+#04),a
        scf
        ret

;### FLO_SQR -> Extracts the root of (HL)
;### Input      (HL)=value
;### Output     (HL)=sqr(HL)
;###            CF=0 error, negative value
;### Unchanged  HL
.FLO_SQR
        ld de,FLO_CONST_HALF

;### FLO_POT -> Raises (HL) to the power of (DE) and copies the result in (HL)
;### Input      (HL)=first value, (DE)=second value
;### Output     (HL)=(HL)^(DE)
;###            CF=0 Error [S=1 invalid parameter -X^(z/n), P=1 Overflow]
;### Unchanged  HL,FLO(DE)
.FLO_POT
        ex de,hl
        call FLO_SGN
        ex de,hl
        jp z,l2f7d
        push af
        call FLO_SGN
        jr z,l32e2
        ld b,a
        call m,l3734
        push hl
        call l3324
        pop hl
        jr c,l32ed
        ex (sp),hl
        pop hl
        jp m,l32ea
        push bc
        push de
        call FLO_LOG_NAT
        pop de
        call c,FLO_MULT
        call c,FLO_POT_E
.l32d9
        pop bc
        ret nc
        ld a,b
        Or a
        call m,FLO_VZW
        scf
        ret
.l32e2
        pop af
        scf
        ret p
        call l37e8
        Xor a
        ret
.l32ea
        Xor a
        inc a
        ret
.l32ed
        ld c,a
        pop af
        push bc
        push af
        ld a,c
        scf
.l32f3
        adc a
        jr nc,l32f3
        ld b,a
        call l2f8d
        ex de,hl
        ld a,b
.l32fc
        add a
        jr z,l3314
        push af
        call l3570
        jr nc,l331b
        pop af
        jr nc,l32fc
        push af
        ld de,#b104
        call FLO_MULT
        jr nc,l331b
        pop af
        jr l32fc
.l3314
        pop af
        scf
        call m,l35fb
        jr l32d9
.l331b
        pop af
        pop af
        pop bc
        jp m,l37e2
        jp l37ea
.l3324
        push bc
        call l2f88
        call FLO_FIX_FLO_TO_LW
        ld a,c
        pop bc
        jr nc,l3331
        jr z,l3334
.l3331
        ld a,b
        Or a
        ret
.l3334
        ld c,a
        ld a,(hl)
        rra
        sbc a
        And b
        ld b,a
        ld a,c
        cp #02
        sbc a
        ret nc
        ld a,(hl)
        cp #27
        ret c
        Xor a
        ret

;### FLO_DEGRAD -> Set Deg/Rad
;### Input      A=Typ (=0 -> Rad, >0 -> Deg)
;### Unchanged  AF,BC,DE,HL,IX,IY
.FLO_DEGRAD    
        ld (FLO_VALUE_DEGRAD),a
        ret

;### FLO_COS -> Calculates the cosinus of (HL)
;### Input      (HL)=value
;### Output     (HL)=cos(HL)
;###            CF=0 value too big
;### Unchanged  HL
.FLO_COS
        call FLO_SGN
        call m,l3734
        Or #01
        jr l3354

;### FLO_SIN -> Calculates the sinus of (HL)
;### Input      (HL)=value
;### Output     (HL)=sin(HL)
;###            CF=0 value too big
;### Unchanged  HL
.FLO_SIN
        Xor a
.l3354
        push af
        ld de,FLO_CONST_SINA
        ld b,#f0
        ld a,(FLO_VALUE_DEGRAD)
        Or a
        jr z,l3365
        ld de,FLO_CONST_SINB
        ld b,#f6
.l3365
        call l3492
        jr nc,l33a4
        pop af
        call l346a
        ret nc
        ld a,e
        rra
        call c,l3734
        ld b,#e8
        call l3492
        jp nc,l37e2
        inc (ix+#04)
        call l3440
        db #06
        db #1b,#2d,#1a,#e6,#6e
        db #f8,#fb,#07,#28,#74
        db #01,#89,#68,#99,#79
        db #e1,#df,#35,#23,#7d
        db #28,#e7,#5d,#a5,#80
.FLO_CONST_F
        db #a2,#da,#0f,#49,#81

.l33a1
        jp FLO_MULT
.l33a4
        pop af
        jp nz,l2f7d
        ld a,(FLO_VALUE_DEGRAD)
        cp #01
        ret c
        ld de,FLO_CONST_SINC
        jp FLO_MULT

;### FLO_TAN -> Calculates the tangent of (HL)
;### Input      (HL)=value
;### Output     (HL)=tan(HL)
;###            CF=0 error [Z=1 division by zero, S=1 value too big]
;### Unchanged  HL
.FLO_TAN
        call l2f8d
        push de
        call FLO_COS
        ex (sp),hl
        call c,FLO_SIN
        pop de
        jp c,FLO_DIV
        ret

;### FLO_ARC_TAN -> Calculates the arcus tangent of (HL)
;### Input      (HL)=value
;### Output     (HL)=atn(HL)
;### Unchanged  HL
.FLO_ARC_TAN
        call FLO_SGN
        push af
        call m,l3734
        ld b,#f0
        call l3492
        jr nc,l3430
        dec a
        push af
        call p,l35fb
        call l3440
        db #0b
        db #ff,#c1,#03,#0f,#77
        db #83,#fc,#e8,#eb,#79
        db #6f,#ca,#78,#36,#7b
        db #d5,#3e,#b0,#b5,#7c
        db #b0,#c1,#8b,#09,#7d
        db #af,#e8,#32,#b4,#7d
        db #74,#6c,#65,#62,#7d
        db #d1,#f5,#37,#92,#7e
        db #7a,#c3,#cb,#4c,#7e
        db #83,#a7,#aa,#aa,#7f
        db #fe,#ff,#ff,#7f,#80

.l3426
        call FLO_MULT
        pop af
        ld de,FLO_CONST_F
        call p,FLO_SUBX
.l3430
        ld a,(FLO_VALUE_DEGRAD)
        Or a
        ld de,FLO_CONST_TAN
        call nz,FLO_MULT
        pop af
        call m,l3734
        scf
        ret
.l3440
        call l3570
.l3443
        call l2f87
        pop hl
        ld b,(hl)
        inc hl
        call l2f90
.l344c
        inc de
        inc de
        inc de
        inc de
        inc de
        push de
        ld de,#b109
        dec b
        ret z
        push bc
        ld de,#b10e
        call FLO_MULT
        pop bc
        pop de
        push de
        push bc
        call FLO_ADD
        pop bc
        pop de
        jr l344c
.l3469
        Xor a
.l346a
        push af
        call FLO_MULT
        pop af
        ld de,FLO_CONST_HALF
        call nz,FLO_ADD
        push hl
        call FLO_ROUND_FLO_TO_HLA
        jr nc,l348e
        pop de
        push hl
        push af
        push de
        ld de,#b109
        call FLO_KONV_HLA_TO_FLO
        ex de,hl
        pop hl
        call FLO_SUB
        pop af
        pop de
        scf
        ret
.l348e
        pop hl
        Xor a
        inc a
        ret
.l3492
        call l36d3
        ret p
        cp b
        ret z
        ccf
        ret

;### FLO_SUB -> Substracts (DE) from (HL) and copies the result in (HL)
;### Input      (HL)=first value, (DE)=second value
;### Output     (HL)=(HL)-(DE)
;###            CF=0 Overflow
;### Unchanged  HL,FLO(DE)
.FLO_SUB
        ld a,#01
        jr l34a3

;### FLO_SUBX -> Substracts (HL) from (DE) and copies the result in (HL)
;### Input      (DE)=first value, (HL)=second value
;### Output     (HL)=(DE)-(HL)
;###            CF=0 Overflow
;### Unchanged  HL,FLO(DE)
.FLO_SUBX
        ld a,#80
        jr l34a3

;### FLO_ADD -> Adds (HL) and (DE) and copies the result in (HL)
;### Input      (HL)=first value, (DE)=second value
;### Output     (HL)=(HL)+(DE)
;###            CF=0 Overflow
;### Unchanged  HL,FLO(DE)
.FLO_ADD
        Xor a
.l34a3
        push hl
        pop ix
        push de
        pop iy
        ld b,(ix+#03)
        ld c,(iy+#03)
        Or a
        jr z,l34bc
        jp m,l34ba
        rrca
        Xor c
        ld c,a
        jr l34bc
.l34ba
        Xor b
        ld b,a
.l34bc
        ld a,(ix+#04)
        cp (iy+#04)
        jr nc,l34d8
        ld d,b
        ld b,c
        ld c,d
        Or a
        ld d,a
        ld a,(iy+#04)
        ld (ix+#04),a
        jr z,l3525
        sub d
        cp #21
        jr nc,l3525
        jr l34e9
.l34d8
        Xor a
        sub (iy+#04)
        jr z,l3537
        add (ix+#04)
        cp #21
        jr nc,l3537
        push hl
        pop iy
        ex de,hl
.l34e9
        ld e,a
        ld a,b
        Xor c
        push af
        push bc
        ld a,e
        call l3743
        ld a,c
        pop bc
        ld c,a
        pop af
        jp m,l353c
        ld a,(iy+#00)
        add l
        ld l,a
        ld a,(iy+#01)
        adc h
        ld h,a
        ld a,(iy+#02)
        adc e
        ld e,a
        ld a,(iy+#03)
        set 7,a
        adc d
        ld d,a
        jp nc,l37b7
        rr d
        rr e
        rr h
        rr l
        rr c
        inc (ix+#04)
        jp nz,l37b7
        jp l37ea
.l3525
        ld a,(iy+#02)
        ld (ix+#02),a
        ld a,(iy+#01)
        ld (ix+#01),a
        ld a,(iy+#00)
        ld (ix+#00),a
.l3537
        ld (ix+#03),b
        scf
        ret
.l353c
        Xor a
        sub c
        ld c,a
        ld a,(iy+#00)
        sbc l
        ld l,a
        ld a,(iy+#01)
        sbc h
        ld h,a
        ld a,(iy+#02)
        sbc e
        ld e,a
        ld a,(iy+#03)
        set 7,a
        sbc d
        ld d,a
        jr nc,l356d
        ld a,b
        cpl
        ld b,a
        Xor a
        sub c
        ld c,a
        ld a,#00
        sbc l
        ld l,a
        ld a,#00
        sbc h
        ld h,a
        ld a,#00
        sbc e
        ld e,a
        ld a,#00
        sbc d
        ld d,a
.l356d
        jp l37ac
.l3570
        ld de,#b109
        call l2f90
        ex de,hl

;### FLO_MULT -> Multiplicates (HL) with (DE) and copies the result in (HL)
;### Input      (HL)=first value, (DE)=second value
;### Output     (HL)=(HL)*(DE)
;###            CF=0 Overflow
;### Unchanged  HL,FLO(DE)
.FLO_MULT
        push de
        pop iy
        push hl
        pop ix
        ld a,(iy+#04)
        Or a
        jr z,l35ad
        dec a
        call l36af
        jr z,l35ad
        jr nc,l35aa
        push af
        push bc
        call l35b0
        ld a,c
        pop bc
        ld c,a
        pop af
        bit 7,d
        jr nz,l35a3
        dec a
        jr z,l35ad
        sla c
        adc hl,hl
        rl e
        rl d
.l35a3
        ld (ix+#04),a
        Or a
        jp nz,l37b7
.l35aa
        jp l37ea
.l35ad
        jp l37e2
.l35b0
        ld hl,#0000
        ld e,l
        ld d,h
        ld a,(iy+#00)
        call l35f3
        ld a,(iy+#01)
        call l35f3
        ld a,(iy+#02)
        call l35f3
        ld a,(iy+#03)
        Or #80
.l35cc
        ld b,#08
        rra
        ld c,a
.l35d0
        jr nc,l35e6
        ld a,l
        add (ix+#00)
        ld l,a
        ld a,h
        adc (ix+#01)
        ld h,a
        ld a,e
        adc (ix+#02)
        ld e,a
        ld a,d
        adc (ix+#03)
        ld d,a
.l35e6
        rr d
        rr e
        rr h
        rr l
        rr c
        djnz l35d0
        ret
.l35f3
        Or a
        jr nz,l35cc
        ld l,h
        ld h,e
        ld e,d
        ld d,a
        ret
.l35fb
        call l2f87
        ex de,hl
        push de
        call l2f7d
        pop de

;### FLO_DIV -> Divides (HL) by (DE) and copies the result in (HL)
;### Input      (HL)=first value, (DE)=second value
;### Output     (HL)=(HL)/(DE)
;###            CF=0 Overflow (and ZF=1 -> division by zero)
;### Unchanged  HL,FLO(DE)
.FLO_DIV
        push de
        pop iy
        push hl
        pop ix
        Xor a
        sub (iy+#04)
        jr z,l366a
        call l36af
        jp z,l37e2
        jr nc,l3667
        push bc
        ld c,a
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ex de,hl
        ld b,(iy+#03)
        set 7,b
        call l369d
        jr c,l3633
        ld a,c
        Or a
        jr nz,l3639
        jr l3666
.l3633
        dec c
        add hl,hl
        rl e
        rl d
.l3639
        ld (ix+#04),c
        call l3672
        ld (ix+#03),c
        call l3672
        ld (ix+#02),c
        call l3672
        ld (ix+#01),c
        call l3672
        ccf
        call c,l369d
        ccf
        sbc a
        ld l,c
        ld h,(ix+#01)
        ld e,(ix+#02)
        ld d,(ix+#03)
        pop bc
        ld c,a
        jp l37b7
.l3666
        pop bc
.l3667
        jp l37ea
.l366a
        ld b,(ix+#03)
        call l37ea
        Xor a
        ret
.l3672
        ld c,#01
.l3674
        jr c,l367e
        ld a,d
        cp b
.l3678
        call z,l36a0
        ccf
        jr nc,l3691
.l367e
        ld a,l
        sub (iy+#00)
        ld l,a
        ld a,h
        sbc (iy+#01)
        ld h,a
        ld a,e
        sbc (iy+#02)
        ld e,a
        ld a,d
        sbc b
        ld d,a
        scf
.l3691
        rl c
        sbc a
        add hl,hl
        rl e
        rl d
        inc a
        jr nz,l3674
        ret
.l369d
        ld a,d
        cp b
        ret nz
.l36a0
        ld a,e
        cp (iy+#02)
        ret nz
        ld a,h
        cp (iy+#01)
        ret nz
        ld a,l
        cp (iy+#00)
        ret
.l36af
        ld c,a
        ld a,(ix+#03)
        Xor (iy+#03)
        ld b,a
        ld a,(ix+#04)
        Or a
        ret z
        add c
        ld c,a
        rra
        Xor c
        ld a,c
        jp p,l36cf
        set 7,(ix+#03)
        sub #7f
        scf
        ret nz
        cp #01
        ret
.l36cf
        Or a
        ret m
        Xor a
        ret
.l36d3
        push hl
        pop ix
        ld a,(ix+#04)
        Or a
        ret z
        sub #80
        scf
        ret

;### FLO_VGL -> Compares (HL) with (DE)
;### Input      (HL)=first value, (DE)=second value
;### Output     A=Result [-1 -> (HL)<(DE), 0 -> (HL)=(DE), 1 -> (HL)>(DE)]
;###            ZF=1 -> (HL)=(DE), CF=1 -> (HL)<(DE)
;### Unchanged  BC,DE,HL,FLO(HL),FLO(DE)
.FLO_VGL
        push hl
        pop ix
.l36e2
        push de
        pop iy
        ld a,(ix+#04)
        cp (iy+#04)
        jr c,l3719
        jr nz,l3722
        Or a
        ret z
        ld a,(ix+#03)
        Xor (iy+#03)
        jp m,l3722
        ld a,(ix+#03)
        sub (iy+#03)
        jr nz,l3719
        ld a,(ix+#02)
        sub (iy+#02)
        jr nz,l3719
        ld a,(ix+#01)
        sub (iy+#01)
        jr nz,l3719
        ld a,(ix+#00)
        sub (iy+#00)
        ret z
.l3719
        sbc a
        Xor (iy+#03)
.l371d
        add a
        sbc a
        ret c
        inc a
        ret
.l3722
        ld a,(ix+#03)
        jr l371d

;### FLO_SGN -> Tests the sign of (HL)
;### Input      (HL)=value
;### Output     A=sign [-1 -> (HL)<0, 0 -> (HL)=0, 1 -> (HL)>0]
;###            ZF=1 -> (HL)=0, CF=1 -> (HL)<0
;### Unchanged  BC,DE,HL,IY,FLO(HL)
.FLO_SGN
        push hl
        pop ix
        ld a,(ix+#04)
        Or a
        ret z
        jr l3722

;### FLO_VZW -> Changes the sign of (HL)
;### Input      (HL)=value
;### Output     (HL)=-(HL)
;### Unchanged  BC,DE,HL,IY
.FLO_VZW
        push hl
        pop ix
.l3734
        ld a,(ix+#03)
        Xor #80
        ld (ix+#03),a
        ret
.l373d
        cp #21
        jr c,l3743
        ld a,#21
.l3743
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        ld c,(hl)
        inc hl
        ld h,(hl)
        ld l,c
        ex de,hl
        set 7,d
        ld bc,#0000
        jr l375e
.l3753
        ld c,a
        ld a,b
        Or l
        ld b,a
        ld a,c
        ld c,l
        ld l,h
        ld h,e
        ld e,d
        ld d,#00
.l375e
        sub #08
        jr nc,l3753
        add #08
        ret z
.l3765
        srl d
        rr e
        rr h
        rr l
        rr c
        dec a
        jr nz,l3765
        ret
.l3773
        jr nz,l378c
        ld d,a
        ld a,e
        Or h
        Or l
        Or c
        ret z
        ld a,d
.l377c
        sub #08
        jr c,l379a
        ret z
        ld d,e
        ld e,h
        ld h,l
        ld l,c
        ld c,#00
        inc d
        dec d
        jr z,l377c
        ret m
.l378c
        dec a
        ret z
        sla c
        adc hl,hl
        rl e
        rl d
        jp p,l378c
        ret
.l379a
        Xor a
        ret
.l379c
        push hl
        pop ix
        ld (ix+#04),b
        ld b,a
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ex de,hl
.l37ac
        ld a,(ix+#04)
        dec d
        inc d
        call p,l3773
        ld (ix+#04),a
.l37b7
        sla c
        jr nc,l37cd
        inc l
        jr nz,l37cd
        inc h
        jr nz,l37cd
        inc de
        ld a,d
        Or e
        jr nz,l37cd
        inc (ix+#04)
        jr z,l37ea
        ld d,#80
.l37cd
        ld a,b
        Or #7f
        And d
        ld (ix+#03),a
        ld (ix+#02),e
        ld (ix+#01),h
        ld (ix+#00),l
.l37dd
        push ix
        pop hl
        scf
        ret
.l37e2
        Xor a
        ld (ix+#04),a
        jr l37dd
.l37e8
        ld b,#00
.l37ea
        push ix
        pop hl
        ld a,b
        Or #7f
        ld (ix+#03),a
        Or #ff
        ld (ix+#04),a
        ld (hl),a
        ld (ix+#01),a
        ld (ix+#02),a
        ret

;--- begin variables ----------------------------------------------------------

FLO_VALUE_DEGRAD    db 0
FLO_VALUE_RND       ds 4

;--- begin constants ----------------------------------------------------------

.Pi:
.Symbasic_FLO_CONST_PI		                    ;=PI
        db #a2,#da,#0f,#49,#82,0				;**** Padded out with a Zero

.FLO_CONST_LOG
        db #34,#f3,#04,#35,#80
.FLO_CONST_LOGNAT
        db #f8,#17,#72,#31,#80
.FLO_CONST_LOGDEC
        db #85,#9a,#20,#1a,#7f

.FLO_CONST_POTE1
        db #29,#3b,#aa,#38,#81
.FLO_CONST_POTE2
        db #c7,#33,#0f,#30,#87
.FLO_CONST_POTE3
        db #f8,#17,#72,#b1,#87

.FLO_CONST_SINA
        db #6e,#83,#f9,#22,#7f
.FLO_CONST_SINB
        db #b6,#60,#0b,#36,#79
.FLO_CONST_SINC
        db #13,#35,#fa,#0e,#7b
.FLO_CONST_TAN
        db #d3,#e0,#2e,#65,#86

.FLO_CONST_A
        db #f0,#1f,#bc,#3e,#96
.FLO_CONST_B
        db #fe,#27,#6b,#6e,#9e
.FLO_CONST_C
        db #00,#00,#00,#00,#81

.FLO_CONST_D1
        db #00,#00,#00,#20,#84
        db #00,#00,#00,#48,#87
        db #00,#00,#00,#7a,#8a
        db #00,#00,#40,#1c,#8e
        db #00,#00,#50,#43,#91
        db #00,#00,#24,#74,#94
        db #00,#80,#96,#18,#98
        db #00,#20,#bc,#3e,#9b
        db #00,#28,#6b,#6e,#9e
        db #00,#f9,#02,#15,#a2
        db #40,#b7,#43,#3a,#a5
        db #10,#a5,#d4,#68,#a8
.FLO_CONST_D2
        db #2a,#e7,#84,#11,#ac
			
Global Loop,ObjId,FileName$
Global a

;**** Code called on event occuring on Timer1
FUNCTION Timer1_Event
	If MouseOver(Super1_ID) Then
		Label2_Text="x -"+Str$(MouseX())
		Label3_Text="y -"+Str$(MouseY())
	else
		Label2_Text="x -"
		Label3_Text="y -"
	endif
	RefreshObj Label2_Id
	RefreshObj Label3_Id
ENDF
;**** Main loop of Form Form1
FUNCTION Form1_Main
	If MouseOver(Super1_ID) and MouseKey()=1 then
		SetObjPos Paint1_Id,MouseX()-(Form1_Left+2),MouseY()-(Form1_Top+20)
		RefreshObj Paint1_Id
	else
		for loop=3 to 18
			ObjId=GetObjId(1,Loop)						;First ID is Number 3 and Form is 1
			If MouseOver(ObjId) and MouseKey()=1 then
				Label1_Text="Pen: "+str$(Loop-3)
				Paint1_Appearance=Loop-3
				RefreshObj Label1_ID
			endif
		next
	endif
ENDF
;****

Function Mnu_Open_Event
	FileName$=opendialog("","")
endf

Function Mnu_Exit_Event
	a=Dialog("See ya laterz",1,1)
	closeform 1
endf




;**********************
;**** Data Section ****
;**********************
CODE Z80
.AppDatBeg
;**** Define User Variables ****
.SyB_Dialog_Info_Text_1:   ds 32
.SyB_Dialog_Info_Text_2:   ds 32
.SyB_Dialog_Info_Text_3:   ds 32
.Loop:   dw 0
.ObjId:   dw 0
.FileName:   dw FileName_Data+3
.a:   dw 0
.SyB_StringTopAddr:      dw SyB_StringTop
;**** String Data ***
.FileName_Data:                 dw FileName:db 0:db 0
.Form1_Text_Data:               dw Form1_Text:db 12:db "PaintPot 1.0",0
.Form1_StatusText_Data:         dw Form1_StatusText:db 26:db "(Not a real paint package)",0
.Frame1_Text_Data:              dw Frame1_Text:db 8:db "Controls",0
.Label1_Text_Data:              dw Label1_Text:db 4:db "Pen:",0
.Label2_Text_Data:              dw Label2_Text:db 3:db "x -",0
.Label3_Text_Data:              dw Label3_Text:db 3:db "y -",0
.Mnu_File_Text_Data:            dw Mnu_File_Text:db 4:db "File",0
.Mnu_Open_Text_Data:            dw Mnu_Open_Text:db 4:db "Open",0
.Mnu_Exit_Text_Data:            dw Mnu_Exit_Text:db 4:db "Exit",0
.SyB_StringTop:       ds 1940,0
.SyB_StringTopMem:
;**** Define User Graphics ****
.Sheet_Data:                    
.AppFormLists




    dw Form1_ControlWindowData
;**** Form Icon ***
.Form1_Icon:
        db 2,8,8
    db 0,0,0,0,0,0,0,0
.Frame1_TextMaxLen:             db  8
.Label1_TextMaxLen:             db  4

.Label2_TextMaxLen:             db  3

.Label3_TextMaxLen:             db  3

.Timer1_Data:                   
.Timer1_Active:                 db  1
.Timer1_Status:                 db  0
.Timer1_Value:                  dw  10
.Timer1_Max:                    dw  10
.Timer1_Addr:                   dw  Timer1_Event
.SyStud_TimerRoutines    dw Timer1_Data,0

;**************************
;**** Transfer Section ****
;**************************
.AppTrnBeg
          ds    128
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB
.Event_Message       db 0         ;Message No 16
.Event_Form_ID       db 0         ;Event happned on which Form
.Event_Type          db 0         ;Type of Event
.Event_UserInput     db 0         ;Key or Mouse Event
.Event_Key_ASCII                  ;Key ASCII - Shared Byte with next
.Event_MouseX        dw 0         ;MouseX when event happens
.Event_MouseY        dw 0         ;MouseY when event happens
.Event_Control_ID    dw 0         ;Control ID No
                     db 0,0,0,0,0,0,0
;**** Dialog Transfer ****
.SyB_Dialog_Info_1:    dw SyB_Dialog_Info_Text_1,6
.SyB_Dialog_Info_2:    dw SyB_Dialog_Info_Text_2,6
.SyB_Dialog_Info_3:    dw SyB_Dialog_Info_Text_3,6
.SyB_Dialog_Info_4:    dw 0
;******************************
;**** SymStudio Timer Stack ***
;******************************
           ds 128              ;Stack buffer
.SyStudio_TimerStack
           dw 0                    ;IY
           dw 0                    ;IX
           dw 0                    ;HL
           dw 0                    ;DE
           dw 0                    ;BC
           dw 0                    ;AF
           dw Sys_Timer_Code       ;Start of Timer Routine
           db 0
.App_Form_List
       dw  Form1_Begin,0,0,0,Form1_Main,0,0,0
.ControWindowDataList
     dw Form1_ControlWindowData
;***
;**** Z80 version of Form Form1 ***
;***
.Form1
.Form1_Addr:                    db 0,0
.Form1_Begin:                   
.Form1_Status:                  db 1
.Form1_Display:                 db 118
.Form1_SizeAdjust:              db 0
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 4
.Form1_Top:                     dw 10
.Form1_Width:                   dw 200
.Form1_Height:                  dw 113
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 191
.Form1_ContentHeight:           dw 112
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 320
.Form1_MaxHeight:               dw 192
.Form1_IconAddr:                dw Form1_Icon
.Form1_Text:                    dw Form1_Text_Data+3
.Form1_StatusText:              dw Form1_StatusText_Data+3
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw 0 ;Form1_ControlTool
.Form1_ToolBarHeight:           dw 8
     db 0,0,0,0,0,0,0,0,0       ;Symbos Reserved
.Form1_SuperWindow:             db  2
     ds 140,0                   ;Symbos Reserved
.Form1_Menu:                    
.Form1_Menu_Entries:            dw 1
.Mnu_File_Appearance:           dw 5
.Mnu_File_Text:                 dw Mnu_File_Text_Data+3
.Mnu_File_Data:                 dw Mnu_File_Entries
:                               dw 0
.Mnu_File_Entries:              dw 3
.Mnu_Open_Appearance:           dw 1
.Mnu_Open_Text:                 dw Mnu_Open_Text_Data+3
.Mnu_Open_Data:                 dw Mnu_Open_Event
:                               dw 0
        dw  1+8,#8000,0,0
.Mnu_Exit_Appearance:           dw 1
.Mnu_Exit_Text:                 dw Mnu_Exit_Text_Data+3
.Mnu_Exit_Data:                 dw Mnu_Exit_Event
:                               dw 0
;****
;**** Data Control Record (ControlWindow) ****
;****
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 22
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
;****
;****
;**** Data Control Record (ControlWindow) ****
;****
.Super1_ControlWindow:          
.Super1_ControlWindowCount:     db 2
.Super1_ControlWindowOwnerID:   db 19
.Super1_ControlWindowDataAddr:  dw Super1_ControlWindowData
.Super1_ControlWindowCalcAddr:  dw 0; Super1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Super1_ControlWindowFocus:     db 0
     db 0
;****
.Form1_ControlWindowData:       
;**** Object Window Background Data Record ****
dw 0,255*256+0,2,  0,0,1000,1000,0
;**** Object (Frame1) Data Record ****
.Frame1_Display     Equ 1
.Frame1_ID:                     dw 1
.Frame1_Type:                   db 3   ;* Button
.Frame1_ExtDataBank:            db 255
.Frame1_ExtDataAddr:            dw Frame1_ExtData
.Frame1_Left:                   dw 3
.Frame1_Top:                    dw 3
.Frame1_Width:                  dw 62
.Frame1_Height:                 dw 109
.Frame1_Code:                   dw 0
;**** Object (Label1) Data Record ****
.Label1_Display     Equ 2
.Label1_ID:                     dw 2
.Label1_Type:                   db 1   ;* Form
.Label1_ExtDataBank:            db 255
.Label1_ExtDataAddr:            dw Label1_ExtData
.Label1_Left:                   dw 11
.Label1_Top:                    dw 18
.Label1_Width:                  dw 50
.Label1_Height:                 dw 8
.Label1_Code:                   dw 0
;**** Object (Box1) Data Record ****
.Box1_Display     Equ 3
.Box1_ID:                       dw 3
.Box1_Type:                     db 2   ;* Frame
.Box1_ExtDataBank:              db 255
.Box1_Appearance:               db  192,17
.Box1_Left:                     dw 11
.Box1_Top:                      dw 30
.Box1_Width:                    dw 10
.Box1_Height:                   dw 10
.Box1_Code:                     dw 0
;**** Object (Box2) Data Record ****
.Box2_Display     Equ 4
.Box2_ID:                       dw 4
.Box2_Type:                     db 2   ;* Frame
.Box2_ExtDataBank:              db 255
.Box2_Appearance:               db  193,17
.Box2_Left:                     dw 23
.Box2_Top:                      dw 30
.Box2_Width:                    dw 10
.Box2_Height:                   dw 10
.Box2_Code:                     dw 0
;**** Object (Box3) Data Record ****
.Box3_Display     Equ 5
.Box3_ID:                       dw 5
.Box3_Type:                     db 2   ;* Frame
.Box3_ExtDataBank:              db 255
.Box3_Appearance:               db  194,17
.Box3_Left:                     dw 35
.Box3_Top:                      dw 30
.Box3_Width:                    dw 10
.Box3_Height:                   dw 10
.Box3_Code:                     dw 0
;**** Object (Box4) Data Record ****
.Box4_Display     Equ 6
.Box4_ID:                       dw 6
.Box4_Type:                     db 2   ;* Frame
.Box4_ExtDataBank:              db 255
.Box4_Appearance:               db  195,17
.Box4_Left:                     dw 47
.Box4_Top:                      dw 29
.Box4_Width:                    dw 10
.Box4_Height:                   dw 10
.Box4_Code:                     dw 0
;**** Object (Box5) Data Record ****
.Box5_Display     Equ 7
.Box5_ID:                       dw 7
.Box5_Type:                     db 2   ;* Frame
.Box5_ExtDataBank:              db 255
.Box5_Appearance:               db  196,17
.Box5_Left:                     dw 11
.Box5_Top:                      dw 41
.Box5_Width:                    dw 10
.Box5_Height:                   dw 10
.Box5_Code:                     dw 0
;**** Object (Box6) Data Record ****
.Box6_Display     Equ 8
.Box6_ID:                       dw 8
.Box6_Type:                     db 2   ;* Frame
.Box6_ExtDataBank:              db 255
.Box6_Appearance:               db  197,17
.Box6_Left:                     dw 23
.Box6_Top:                      dw 41
.Box6_Width:                    dw 10
.Box6_Height:                   dw 10
.Box6_Code:                     dw 0
;**** Object (Box7) Data Record ****
.Box7_Display     Equ 9
.Box7_ID:                       dw 9
.Box7_Type:                     db 2   ;* Frame
.Box7_ExtDataBank:              db 255
.Box7_Appearance:               db  198,17
.Box7_Left:                     dw 35
.Box7_Top:                      dw 42
.Box7_Width:                    dw 10
.Box7_Height:                   dw 10
.Box7_Code:                     dw 0
;**** Object (Box8) Data Record ****
.Box8_Display     Equ 10
.Box8_ID:                       dw 10
.Box8_Type:                     db 2   ;* Frame
.Box8_ExtDataBank:              db 255
.Box8_Appearance:               db  199,17
.Box8_Left:                     dw 47
.Box8_Top:                      dw 41
.Box8_Width:                    dw 10
.Box8_Height:                   dw 10
.Box8_Code:                     dw 0
;**** Object (Box9) Data Record ****
.Box9_Display     Equ 11
.Box9_ID:                       dw 11
.Box9_Type:                     db 2   ;* Frame
.Box9_ExtDataBank:              db 255
.Box9_Appearance:               db  200,17
.Box9_Left:                     dw 11
.Box9_Top:                      dw 53
.Box9_Width:                    dw 10
.Box9_Height:                   dw 10
.Box9_Code:                     dw 0
;**** Object (Box10) Data Record ****
.Box10_Display     Equ 12
.Box10_ID:                      dw 12
.Box10_Type:                    db 2   ;* Frame
.Box10_ExtDataBank:             db 255
.Box10_Appearance:              db  201,17
.Box10_Left:                    dw 23
.Box10_Top:                     dw 53
.Box10_Width:                   dw 10
.Box10_Height:                  dw 10
.Box10_Code:                    dw 0
;**** Object (Box11) Data Record ****
.Box11_Display     Equ 13
.Box11_ID:                      dw 13
.Box11_Type:                    db 2   ;* Frame
.Box11_ExtDataBank:             db 255
.Box11_Appearance:              db  202,17
.Box11_Left:                    dw 35
.Box11_Top:                     dw 53
.Box11_Width:                   dw 10
.Box11_Height:                  dw 10
.Box11_Code:                    dw 0
;**** Object (Box12) Data Record ****
.Box12_Display     Equ 14
.Box12_ID:                      dw 14
.Box12_Type:                    db 2   ;* Frame
.Box12_ExtDataBank:             db 255
.Box12_Appearance:              db  203,17
.Box12_Left:                    dw 47
.Box12_Top:                     dw 54
.Box12_Width:                   dw 10
.Box12_Height:                  dw 10
.Box12_Code:                    dw 0
;**** Object (Box13) Data Record ****
.Box13_Display     Equ 15
.Box13_ID:                      dw 15
.Box13_Type:                    db 2   ;* Frame
.Box13_ExtDataBank:             db 255
.Box13_Appearance:              db  204,17
.Box13_Left:                    dw 11
.Box13_Top:                     dw 65
.Box13_Width:                   dw 10
.Box13_Height:                  dw 10
.Box13_Code:                    dw 0
;**** Object (Box14) Data Record ****
.Box14_Display     Equ 16
.Box14_ID:                      dw 16
.Box14_Type:                    db 2   ;* Frame
.Box14_ExtDataBank:             db 255
.Box14_Appearance:              db  205,17
.Box14_Left:                    dw 23
.Box14_Top:                     dw 66
.Box14_Width:                   dw 10
.Box14_Height:                  dw 10
.Box14_Code:                    dw 0
;**** Object (Box15) Data Record ****
.Box15_Display     Equ 17
.Box15_ID:                      dw 17
.Box15_Type:                    db 2   ;* Frame
.Box15_ExtDataBank:             db 255
.Box15_Appearance:              db  206,17
.Box15_Left:                    dw 35
.Box15_Top:                     dw 66
.Box15_Width:                   dw 10
.Box15_Height:                  dw 10
.Box15_Code:                    dw 0
;**** Object (Box16) Data Record ****
.Box16_Display     Equ 18
.Box16_ID:                      dw 18
.Box16_Type:                    db 2   ;* Frame
.Box16_ExtDataBank:             db 255
.Box16_Appearance:              db  207,17
.Box16_Left:                    dw 47
.Box16_Top:                     dw 66
.Box16_Width:                   dw 10
.Box16_Height:                  dw 10
.Box16_Code:                    dw 0
;**** Object (Super1) Data Record ****
.Super1_Display     Equ 19
.Super1_ID:                     dw 19
.Super1_Type:                   db 25   ;* 
.Super1_ExtDataBank:            db 255
.Super1_ExtDataAddr:            dw Super1_ExtData
.Super1_Left:                   dw 67
.Super1_Top:                    dw 13
.Super1_Width:                  dw 128
.Super1_Height:                 dw 97
.Super1_Code:                   dw 0
;**** Object (Label2) Data Record ****
.Label2_Display     Equ 20
.Label2_ID:                     dw 20
.Label2_Type:                   db 1   ;* Form
.Label2_ExtDataBank:            db 255
.Label2_ExtDataAddr:            dw Label2_ExtData
.Label2_Left:                   dw 68
.Label2_Top:                    dw 3
.Label2_Width:                  dw 28
.Label2_Height:                 dw 8
.Label2_Code:                   dw 0
;**** Object (Label3) Data Record ****
.Label3_Display     Equ 21
.Label3_ID:                     dw 21
.Label3_Type:                   db 1   ;* Form
.Label3_ExtDataBank:            db 255
.Label3_ExtDataAddr:            dw Label3_ExtData
.Label3_Left:                   dw 104
.Label3_Top:                    dw 3
.Label3_Width:                  dw 39
.Label3_Height:                 dw 8
.Label3_Code:                   dw 0
;**** Object (Timer1) Data Record ****
.Super1_ControlWindowData:      
;**** Object Window Background Data Record ****
dw 0,255*256+0,0,  0,0,1000,1000,0
;**** Object (Paint1) Data Record ****
.Paint1_Display     Equ 23
.Paint1_ID:                     dw 279
.Paint1_Type:                   db 0   ;* 
.Paint1_ExtDataBank:            db 255
.Paint1_Appearance:             db  3,0
.Paint1_Left:                   dw 113
.Paint1_Top:                    dw 88
.Paint1_Width:                  dw 5
.Paint1_Height:                 dw 4
.Paint1_Code:                   dw 0
;**** Object (Frame1) Extra Data Record ****
.Frame1_ExtData:                
.Frame1_Text:                   dw  Frame1_Text_Data+3
.Frame1_Appearance:             db  6
;**** Object (Label1) Extra Data Record ****
.Label1_ExtData:                
.Label1_Text:                   dw  Label1_Text_Data+3
.Label1_TextAppearance:         db  134
.Label1_TextAlignment:          db  0
;**** Object (Super1) Extra Data Record ****
.Super1_ExtData:                
.Super1_ControlWindowAddr:      dw  Super1_ControlWindow
.Super1_ScrollWidth:            dw  128
.Super1_ScrollHeight:           dw  97
.Super1_OffsetLeft:             dw  0
.Super1_OffsetTop:              dw  0
.Super1_ScrollBars:             db  0
;**** Object (Label2) Extra Data Record ****
.Label2_ExtData:                
.Label2_Text:                   dw  Label2_Text_Data+3
.Label2_TextAppearance:         db  134
.Label2_TextAlignment:          db  0
;**** Object (Label3) Extra Data Record ****
.Label3_ExtData:                
.Label3_Text:                   dw  Label3_Text_Data+3
.Label3_TextAppearance:         db  134
.Label3_TextAlignment:          db  0
;*******************************
;***** Symbos Code Library *****
;*******************************

Library SyStr_LenMax
;*********************************************
;**** Get the Maximum Length of a System String
;**** IN - HL = Start of Text
		dec		hl
		ld		a,(hl)
		inc		hl
		ret
;*********************************************
EndLib

Library SyStr_Len
;*********************************************
;**** Get the Length of a System String
;**** IN - HL = Address Start of Text
;**** OUT - HL = Address End of Text
;****       B = Length
		ld		b,0
.SyStr_Len2
		ld		a,(hl)
		And		a
		ret		z
		inc		hl
		inc		b
		jr		SyStr_Len2	
;*********************************************
EndLib

Library SyStr_Copy
;*********************************************
;**** Copy a String to Another String (without exceeeding Destingation string size)
;**** IN - DE = Addr of Source String
;****      HL = Addr of Destination String
		dec		hl
		ld		a,(hl)
		And		a
		jr		z,SyStr_Copy_2
		ld		b,a
		inc		hl
.SyStr_Copy_1
		ld		a,(de)
		ld		(hl),a
		inc		hl
		inc		de
		And		a
		jr		z,SyStr_Copy_2
		djnz	SyStr_Copy
.SyStr_Copy_2
		ret
;*********************************************
EndLib

Library SyMath_RND16
;*********************************************
;**** Random number generator 16 bit
;**** IN - Nowt
;**** OUT - HL = Random
;**** Corrupts A,DE,F 
		ld		de,(SyMath_RndSeed)		; Seed is usually 0
		ld		a,d
		ld		h,e
		ld		l,253
		Or		a
		sbc		hl,de
		sbc		a,0
		sbc		hl,de
		ld		d,0
		sbc		a,d
		ld		e,a
		sbc		hl,de
		jr		nc,SyMath_Rand
		inc		hl
.SyMath_Rand
		ld		(SyMath_RndSeed),hl
		ret
EndL		
;*******************************************
Library SyMath_RndSeed
;*******************************************
;**** Just the Seeding Word 
		dw	0	
;*******************************************
EndL

;Library SyVar_Num2Str
;*******************************************
;### CLCNUM -> Converts 16Bit-number into an ASCII-string (terminated by 0)
;### Input      IX=Value, E=maximum number of digits
;### Output     IY=points to last char of the string (before 0)
;### Changed    AF,BC,DE,HL,IX,IY
;.SyVar_clcnumt
;		dw 1,10,100,1000,10000
;.SyVar_Num2Str
;		ld d,0
;       ld b,e
;      dec e
;        push ix
;        pop hl
;        ld ix,clcnumt
;        add ix,de
;        add ix,de               ;IX=erster Teiler
;        dec b
;        jr z,clcnum4
;        ld c,0
;clcnum1 ld e,(ix)
;        ld d,(ix+1)
;        dec ix
;        dec ix
;        ld a,"0"
;        Or a
;clcnum2 sbc hl,de
;        jr c,clcnum5
;        inc c
;        inc a
;        jr clcnum2
;clcnum5 add hl,de
;        inc c
;        dec c
;        jr z,clcnum3
;        ld (iy+0),a
;        inc iy
;clcnum3 djnz clcnum1
;clcnum4 ld a,"0"
;        add l
;        ld (iy+0),a
;        ld (iy+1),0
;        ret
;EndLib

Library SyMath_Mult32
;*******************************************
; In: IY/IX: eerste getal (low/high)
;     HL/BC: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				exx
                ld      hl,0
                ld      de,0
                exx
SyMath_Multi32_lp:
				srl     b
                rr      c
                rr      h
                rr      l
                jp      nc,SyMath_multi32_2
                exx
                push    iy
                pop     bc
                add     hl,bc
                ex      de,hl
                push    ix
                pop     bc
                adc     hl,bc
                ex      de,hl
                exx
SyMath_multi32_2:
				ld      a,h
                Or      l
                jp      nz,SyMath_Multi32_3
                ld      a,b
                Or      c
                jp      z,SyMath_multi32_5
SyMath_multi32_3:
				add     iy,iy
                jp      nc,SyMath_multi32_4
                add     ix,ix
                inc     ix
                jp      SyMath_multi32_lp
SyMath_multi32_4:
				add     ix,ix
                jp      SyMath_multi32_lp
SyMath_multi32_5:
				exx
                ret
;**************************************
EndLib

Library SyMath_Div32
;**************************************
; In: HL/DE: teller (low/high)
;     IX/IY: noemer (low/high)
; Uit: HL/DE: resultaat (low/high)
		        push    hl
                push    de
                push    ix
                push    iy
                pop     de
                exx
                pop     de
                pop     bc
                pop     iy
                ld      hl,0
                exx
                ld      hl,0
                ld      b,32
.SyMath_divide32_1
				exx
                add     iy,iy
                rl      c
                rl      b
                adc     hl,hl
                exx
                adc     hl,hl
                exx
                sbc     hl,de
                exx
                sbc     hl,de
                inc     iy
                jp      nc,SyMath_divide32_2
                dec     iy
                exx
                add     hl,de
                exx
                adc     hl,de
.SyMath_divide32_2
				djnz    SyMath_divide32_1
                exx
                push    bc
                exx
                pop     de
                push    iy
                pop     hl
                ret
;*************************************
EndLib

Library SyMath_Add32
;*************************************
; In: HL/DE: eerste getal (low/high)
;     IX/IY: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				push    ix
                pop     bc
                add     hl,bc
                ex      de,hl
                push    iy
                pop     bc
                adc     hl,bc
                ex      de,hl
                ret
;************************************
EndLib

Library SyMath_Sub32
;************************************
; In: HL/DE: eerste getal (low/high)
;     IX/IY: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				push    ix
                pop     bc
                Xor     a
                sbc     hl,bc
                ex      de,hl
                push    iy
                pop     bc
                sbc     hl,bc
                ex      de,hl
                ret
;************************************
EndLib
;*******************************
;**** SymBasic Code Library ****
;*******************************


;****      ABS       ****
;**** Do Integer ABS ****
;****                ****
Library SyB_Abs_Int
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)
		bit		7,a
		ret		z
		ld		a,(iy+7)
		Xor		255
		ld		l,a
		ld		a,(iy+8)
		Xor		255
		ld		h,a
		inc		hl
		ld		(iy+7),l
		ld		(iy+8),h
		ret		
EndLib

;****     ABS      ****
;**** Do Float ABS ****
;****              ****
Library SyB_Abs_Flo
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+10)
		res		7,a							;**** Alter Sgn Bit
		ld		(iy+10),a
		ret
EndLib

;****      ADD       ****
;**** Do Integer Add ****
;****                ****
Library SyB_INT_Add
		ld		iy,(SyB_StackAddr)
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,de						;***** Add Integers Together
		ld		(iy+13),l
		ld		(iy+14),h
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib
			
;****     ADD      ****
;**** Do Float Add ****
;****              ****
Library SyB_FLO_Add
		call	SyB2_STACK_2_FLO
		call 	FLO_ADD
		jp		SyB_DecStack
EndLib

;****      AND       ****
;**** Do Integer AND ****
;****                ****
Library SyB_INT_And
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		And		(iy+13)
		ld		(iy+13),a
		ld		a,(iy+8)
		And		(iy+14)
		ld		(iy+14),a
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****   ASC  ****
;**** Do ASC ****
;****        ****
Library SyB_ASC
		ld		iy,(SyB_StackAddr)
		ld		e,(iy+7)					;**** Address of Text
		ld		d,(iy+8)					;**** Address of Text
		ld		c,(iy+9)					;**** Len of text
		ld		a,(de)
		ld		(iy+7),a
		ld		(iy+8),0
		Xor		a
		ld		hl,(SyB_StrStackAddr)
		ld		b,0
		sbc		hl,bc
		ld		(syB_StrStackAddr),hl
		ret
EndLib

;****   ATAN  ****
;**** Do ATAN ****
;****         ****
Library SyB_ATAN
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_ARC_TAN
EndLib

;****     BANKSIZE       ****
;**** Bank Size Function ****
;****                    ****
Library SyB_BankSize
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_BankSize_Error
		ld		de,4
		add		hl,de
		ld		a,(hl)
		inc		hl
		ld		(iy+7),a
		ld		a,(hl)
		ld		(iy+8),a
		ret
.SyB_BankSize_Error			
		ld		(iy+7),0
		ld		(iy+8),0
		ret
EndLib		

;****   CHR   ****
;**** Do CHR$ ****
;****         ****
Library SyB_Chr
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		ld		hl,(SyB_StrStackAddr)
		;ld		(iy+6),5
		ld		(iy+7),l
		ld		(iy+8),h
		ld		(iy+9),1
		ld		(hl),a
		inc		hl
		ld		(SyB_StrStackAddr),hl
		ret
EndLib

;****      CLEARBANK     ****
;**** Clear Bank Command ****
;****                    ****
Library SyB_ClearBank
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)			
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ld		a,(hl)
		cp		172
		jp		nz,SyB_ClearBank_3
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		ex		de,hl
		ld		e,c
		ld		d,b
.SyB_ClearBank_2		
		ld		b,0
		rst		#20:	dw #812D
		dec		e
		jp		nz,SyB_ClearBank_2
		dec		d
		jp		nz,SyB_ClearBank_2		
.SyB_ClearBank_3
		ret
EndLib

;****     DIRDIALOG      ****
;**** DirDialog function ****
;****                     ****
Library SyB_DirDialog:
		ld		a,(AppBnkNum)
		set		7,a
		ld		(SyB_FileDialog_Extra),a
		jp		SyB_FileDialog
EndLib

;****       DIVIDE        ****
;**** Do Integer Division ****
;****                     ****
Library SyB_INT_Div
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		e,(iy+13)
		ld		d,(iy+14)
		call	SyB_N_Div16
		ld		(iy+13),l
		ld		(iy+14),h
		ld 		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib		
		
;****      DIVIDE       ****
;**** Do Float Division ****
;****                   ****		
Library SyB_FLO_DIV
		call	SyB2_STACK_2_FLO
		call	FLO_DIV
		jp		SyB_DecStack
EndLib

;****      EOF     ****
;**** EOF Function ****
;****              ****
Library SyB_Eof
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_Eof_OK_1
		cp		174						;ReadFile
		jp		z,SyB_Eof_OK_1
		cp		175						;WriteFile
		jp		z,SyB_Eof_OK_1		
		;*** Failed
		ld		(iy+7),0
		ld		(iy+8),0
		ld		bc,0
		ld		de,288					;1 / 32
		jp		SyB_Mark_Error
.SyB_Eof_OK_1:
		push	hl
		pop		ix
		ld		e,(ix+8)
		ld		d,(ix+9)
		;Check if de=0 - If it is then EOF true
		Xor		a
		cp		e
		jp		nz,SyB_Eof_OK_2
		cp		d
		jp		z,SyB_Eof_True7
.SyB_Eof_OK_2:
		ld		l,(ix+4)
		ld		a,(ix+5)
		And		%1
		ld		h,a
		Xor		a
		sbc		hl,de
		jp		c,SyB_Eof_False
.SyB_Eof_True:
		ld		a,1		
.SyB_Eof_False:
		

		ld		(iy+7),a
		ld		(iy+8),0		
		ret
		
.SyB_Eof_True7
		di
.fjtt	jr		fjtt		
		
Endlib


;****     CLOSEFILE      ****
;**** CloseFile Function ****
;****                    ****
Library SyB_CloseFile
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_CloseFile_OK_1
		cp		174						;ReadFile
		jp		z,SyB_CloseFile_OK_1
		cp		175						;WriteFile
		jp		z,SyB_CloseFile_OK_1		
		;*** Failed
		ld		de,288					;1 / 32
		jp		SyB_Mark_Error

		ret
.SyB_CloseFile_OK_1:
		push	hl
		pop		ix
		ld		a,(ix+1)
		cp		1
		jp		nz,SyB_CloseFile_OK_2
		;*** Must write file
		call	SyB_Write_512_Bytes
.SyB_CloseFile_OK_2:
		ld		(ix+0),0
		ld		a,(ix+3)
		call	SyFile_FILCLO
		ld		iy,(Syb_StackAddr)
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****     CLOSEFORM      ****
;**** CloseForm Function ****
;****                    ****		
Library SyB_CloseForm:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		dec		a
		And		%111
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		call	SyB_Studio_CloseForm
		ld		a,(SyB_Studio_FormOS)
		call	SyDesktop_WINCLS
		ret
EndLib

;****      CREATEBANK      ****
;**** Create Bank Function ****
;****                      ****
Library SyB_CreateBank
		ld		iy,(SyB_StackAddr)
		ld		hl,SyB_RamBankInfo				;Start of Bank Info
		ld		b,15							;Number of Banks Possible-1
		ld		de,8							;Bytes to jump (Each Bank Ref is 6 bytes)
		Xor		a								;A=0
.SyB_CreateBank_1			
		cp		(hl)
		jr		z,SyB_CreateBank_FoundSlot		;Until (hl)<>0
		add		hl,bc							;Jump over next
		djnz	SyB_CreateBank_1				;Repeat until Empty bank found or 15 are used
		jp		SyB_CreateBank_Error
SyB_CreateBank_FoundSlot
		ld		c,(iy+7)
		ld		b,(iy+8)
		push	bc
		push	hl
		Xor		a
		ld		e,a
		rst		#20
		dw		#8118
		pop		de
		jp		c,SyB_CreateBank_Error		
		ex		de,hl
		ld		c,172
		ld		(iy+7),l
		ld		(iy+8),h
		ld		(hl),c
		inc		hl
		ld		(hl),a							;Stores Bank
		inc		hl
		ld		(hl),e
		inc		hl
		ld		(hl),d
		inc		hl
		pop		bc
		ld		(hl),c
		inc		hl
		ld		(hl),b		
		ret
		
SyB_CreateBank_Error
		pop		hl
		ld		(iy+7),0
		ld		(iy+8),0
		ret
Endlib

;****     COLOURDEPTH      ****		
;**** ColourDepth Function ****		
;****                      ****
Library SyB_ColourDepth:
		ld 		hl,#8139
		rst 	#28
		ld		a,d
		And		%1111
		ld		d,a
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),d
		ld		(iy+2),a
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****   COS  ****
;**** Do COS ****
;****        ****
Library SyB_COS
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_COS
EndLib

;****          DEG          ****
;**** DEG - Set Degree Mode ****
;****                       ****
Library SyB_Deg:
		ld		a,1
		ld		(FLO_VALUE_DEGRAD),a
		ret
EndLib		

;****       DIALOG       ****
;**** Dialog Box Command ****
;****                    ****
Library SyB_Dialog
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		And		%1111
		add		a
		add		a
		add		2
		ld		(SyB_Dialog_Info_1+2),a
		ld		(SyB_Dialog_Info_2+2),a
		ld		(SyB_Dialog_Info_3+2),a				
		ld		e,(iy+21)				;Originals stack length
		ld		hl,(SyB_StrStackAddr)
		ld		d,0
		add		hl,de
		ld		(SyB_StrStackAddr),hl
		ld		c,e
		
		ld		e,(iy+19)				;DE = Address of Text
		ld		d,(iy+20)		
		ld		hl,SyB_Dialog_Info_Text_1	
		
		call	SyB_Dialog_Text_Copier
		ld		hl,SyB_Dialog_Info_Text_2
		call	SyB_Dialog_Text_Copier
		ld		hl,SyB_Dialog_Info_Text_3
		call	SyB_Dialog_Text_Copier					
		
		ld		hl,SyB_Dialog_Info_1
		ld		a,(iy+13)
		And		%11
		ld		e,a
		push	iy
		ld		a,(appBnkNum)
		call	SySystem_SYSWRN
		
.SyB_Dialog_Control_Loop:
		call	SymStudio_App_Wait_Message	;**** See what Event has occurre
		jr		nc,SyB_Dialog_Control_Loop_0
		cp		157
		jr		nz,SyB_Dialog_Control_Loop_0
		ld		a,(Event_Form_ID)			;Position 1
		jp		SyB_Dialog_Control_Loop_2
		cp		0
		jp		nz,SyB_Dialog_Control_Loop_2
.SyB_Dialog_Control_Loop_0
		Xor		a
		ld		(V_App_In_Use),a
		jr		SyB_Dialog_Control_Loop
.SyB_Dialog_Control_Loop_2
		pop		iy
		ld		(iy+19),a
		ld		(iy+20),0
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	

;**** Copies Text from DE into HL ****
;**** C=Length left
.SyB_Dialog_Text_Copier		
		ld		b,31
.SyB_Dialog_Loop_1		
		ld		a,c
		Or		a
		jp		z,SyB_Dialog_Loop_2
		dec		c
		ld		a,(de)
		inc		de
		cp		"|"			
		jp		z,SyB_Dialog_Loop_2
		ld		(hl),a
		inc		hl
		dec		b
		djnz	SyB_Dialog_Loop_1
.SyB_Dialog_Loop_2
		Xor		a
		ld		(hl),a
		ret
EndLib

;****  EXP   ****		
;**** Do EXP ****
;****        ****
Library SyB_EXP
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_POT_E
EndLib


;****     FOR STARTER       ****
;**** For Command (Integer) ****
;****                       ****
Library SyB_ForStarter_Int
		ld		iy,(SyB_StackAddr)
		pop		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		
		ld		a,(iy+19)		
		ld		(de),a
		ld		(iy+19),e
		inc		de
		ld		a,(iy+20)
		ld		(de),a
		dec		de
		ld		(iy+20),d
		
		;**** Check What sort of step ****
		ld		a,(iy+8)
		bit		7,a
		jp		z,SyB_ForStarter_Int_2
		ld		(iy+21),1
		jp		(hl)
.SyB_ForStarter_Int_2:		
		ld		(iy+21),0
		jp		(hl)
Endlib

;****         FOR           ****
;**** For Command (Integer) ****
;****                       ****
Library SyB_For_Int
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+19)
		ld		h,(iy+20)
		
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ld		a,(iy+21)
		And		a
		jp		z,SyB_For_Int_PositiveStep
		ex		de,hl
		Xor		a
.SyB_For_Int_PositiveStep		
		sbc		hl,de
		jp		c,SyB_ForInt_Exit		
		pop		hl
		inc		hl
		inc		hl
		jp		(hl)
.SyB_ForInt_Exit
		pop		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ex		de,hl
		ld		bc,18
		add		iy,bc
		ld		(SyB_StackAddr),iy	
		jp		(hl)
endlib

;****      FILEPOS     ****
;**** FilePos Function ****
;****                  ****
Library SyB_FilePos
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_FilePos_OK_1
		cp		174						;ReadFile
		jp		z,SyB_FilePos_OK_1
		cp		175						;WriteFile
		jp		z,SyB_FilePos_OK_1		
		;*** Failed
		ld		bc,0					;Stack Change
		ld		de,255					;Error Number
		jp		SyB_Mark_Error
.SyB_FilePos_OK_1:
		ld		bc,4
		add		hl,bc
		push	hl
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		pop		de
		ex		de,hl
		push	de
		ldi
		ldi
		ldi
		ldi
		pop		hl
		Xor		a
		call	FLO_KONV_LW_TO_FLO
		ret
EndLib

;****     FILESIZE      ****
;**** FileSize Function ****
;****                   ****
Library SyB_FileSize
		call	SyB_GetOpenAFile
		jp		c,SyB_FileSize_Fail_1
		push	af
		ld		iy,0
		ld		ix,0
		ld		c,2
		call	SyFile_FILPOI

		push	ix
		push	iy
		pop		de
		pop		bc
		ld		iy,(SyB_StackAddr)
		Xor		a
		ld		(iy+7),c
		ld		(iy+8),b
		ld		(iy+9),e
		ld		(iy+10),d
		ld		hl,(SyB_StackAddr)
		ld		bc,7		
		add		hl,bc
		call	FLO_KONV_LW_TO_FLO
		pop		af
		call	SyFile_FILCLO
		ret
.SyB_FileSize_Fail_1:
		ld		bc,0
		ld		e,a
		ld		d,1
		jp		SyB_Mark_Error
EndLib		

;****     FREEBANK      ****
;**** Free Bank Command ****
;****                   ****
Library SyB_FreeBank
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)			
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ld		a,(hl)
		cp		172
		jp		nz,SyB_FreeBank_3
		Xor		a
		ld		(hl),a
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		ex		de,hl		
		rst 	#20:dw 	#811B
SyB_FreeBank_3
		ret		
EndLib

;****          GARBAGE           ****
;**** Garbage Collection Command ****
;****                            ****
;See bottom of String Text Area

;****      GETSECOND     ****
;**** Function GetSecond ****
;****                    ****
Library SyB_GetSecond
		rst		#20
		dw 		#810c
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),a
		ld		(iy+2),0
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
EndLib

;****      GETMINUTE     ****
;**** Function GetMinute ****
;****                    ****
Library SyB_GetMinute
		rst		#20
		dw 		#810c
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),b
		ld		(iy+2),0
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****      GETHOUR     ****
;**** Function GetHour ****
;****                  ****
Library SyB_GetHour
		rst		#20
		dw 		#810c
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),c
		ld		(iy+2),0
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy		
		ret
EndLib

;****      GETDAY     ****
;**** Function GetDay ****
;****                 ****
Library SyB_GetDay
		rst		#20
		dw 		#810c
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),d
		ld		(iy+2),0
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****      GETMONTH     ****
;**** Function GetMonth ****
;****                   ****
Library SyB_GetMonth
		rst		#20
		dw 		#810c
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),e
		ld		(iy+2),0
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy			
		ret
EndLib

;****      GETYEAR      ****
;**** Function GetYear  ****
;****                   ****
Library SyB_GetYear
		rst		#20
		dw 		#810c
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),l
		ld		(iy+2),h
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib


;****     GETOBJID      ****
;**** Function GetObjID ****
;****                   ****
Library SyB_GetObjID
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+13)
		dec		a
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)
		ld		d,0	
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+0)
		ld		(iy+13),a
		ld		a,(ix+1)
		ld		(iy+14),a
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****     GETOBJLEFT      ****
;**** Function GetObjLeft ****
;****                     ****
Library SyB_GetObjLeft
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+6)
		ld		(iy+7),a
		ld		a,(ix+7)
		ld		(iy+8),a
		ret
EndLib	

;****      GETOBJTOP     ****
;**** Function GetObjTop ****
;****                    ****
Library SyB_GetObjTop
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0		
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+8)
		ld		(iy+7),a
		ld		a,(ix+9)
		ld		(iy+8),a
		ret
EndLib

;****      GETOBJWIDTH     ****
;**** Function GetObjWidth ****
;****                      ****
Library SyB_GetObjWidth
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+10)
		ld		(iy+7),a
		ld		a,(ix+11)
		ld		(iy+8),a
		ret
EndLib

;****      GETOBJHEIGHT     ****
;**** Function GetObjHeight ****
;****                       ****
Library SyB_GetObjHeight
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+12)
		ld		(iy+7),a
		ld		a,(ix+13)
		ld		(iy+8),a
		ret
EndLib
	
;****      GETOBJVISIBLE     ****
;**** Function GetObjVisible ****
;****                        ****
Library SyB_GetObjVisible
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+2)
		And		%10000000
		jp		z,SyB_GetObjVisible_1
		Xor		a
		jp		SyB_GetObjVisible_2
.SyB_GetObjVisible_1		
		ld		a,1
.SyB_GetObjVisible_2		
		ld		(iy+7),a
		ld		(iy+8),0
		ret
EndLib

;****      GETOBJTEXT     ****
;**** Function GetObjText ****
;****                     ****
Library SyB_GetObjText
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		e,(ix+2)
		ld		d,0
		ld		hl,SyB_Obj_Text_Pointer
		add		hl,de
		ld		a,(hl)
		And		a
		jp		z,SyB_GetObjText_Empty
		
		bit		7,a
		jp		z,SyB_GetObjText_2
		ld		l,(ix+4)
		ld		h,(ix+5)
		And		%111111
		jp		SyB_GetObjText_3
.SyB_GetObjText_2:
		push	ix
		pop		hl
.SyB_GetObjText_3:		
		ld		e,a
		ld		d,0
		add		hl,de	
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		hl,(SyB_StrStackAddr)
		ld		(iy+7),l
		ld		(iy+8),h
		ld		b,0
.SyB_GetObjText_5:			
		ld		a,(de)
		And		a
		jp		z,SyB_GetObjText_4
		ld		(hl),a
		inc		de
		inc		hl
		inc		b
		jr		SyB_GetObjText_5
.SyB_GetObjText_4:
		ld		(SyB_StrStackAddr),hl
		ld		(iy+9),b
		ret
.SyB_GetObjText_Empty:
		ld		hl,(SyB_StrStackAddr)
		ld		(iy+7),l
		ld		(iy+8),h
		ld		(iy+9),0
		ret
EndLib

.SyB_Obj_Text_Pointer:
		db			0					;0 - 
		db			0+128				;1 - Label
		db			0					;2 -
		db			0+128				;3 - Frame
		db			0					;4
		db			0					;5
		db			0+128				;6 - CtrLabel
		db			0					;7
		db			0					;8
		db			0					;9
		db			0					;10
		db			0					;11															
		db			0					;12
		db			0					;13
		db			0					;14
		db			0					;15
		db			4					;16 - Button
		db			2+128				;17 - Check
		db			2+128				;18 - Radio
		db			0					;19
		db			0					;20																
		db			0					;21	
		db			0					;22	
		db			0					;23	
		db			0					;24	
		db			0					;25	
		db			0					;26	
		db			0					;27	
		db			0					;28	
		db			0					;29
		db			0					;30	
		db			0					;31	
		db			0+128				;32 - Text Input										
																
;****       IF         ****
;**** Basic IF Command ****
;****                  ****
Library SyB_IF
		ld		bc,7
		ld		hl,(SyB_StackAddr)
		add		hl,bc		
		Xor		a
		cp		(hl)					;7
		jr		nz,SyB_IF_2_1
		inc		hl
		cp		(hl)					;7
		jr		nz,SyB_IF_2
.SyB_IF_1								;So The result was False
		dec		hl
		dec		hl
		ld		(Syb_StackAddr),hl
		pop		hl
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a
		jp		(hl)
.SyB_IF_2
		dec		hl
.SyB_IF_2_1		
		dec		hl
		ld		(Syb_StackAddr),hl
		pop		hl
		inc		hl
		inc		hl
		jp		(hl)		
EndLib		

;****      LEFT     ****
;**** LEFT Function ****
;****               ****
Library SyB_Left
		ld		ix,(SyB_StackAddr)
		ld		b,(ix+7)
		ld		a,(ix+15)				;Originals stack length
		sub		b
		ret		c
		ld		(ix+15),b
		ld		c,a
		ld		b,0
		Xor		a						;Sets no carry flag etc
		ld		hl,(SyB_StrStackAddr)
		sbc		hl,bc
		ld		(SyB_StrStackAddr),hl
		ld		hl,(SyB_StackAddr)
		ld		bc,6
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ret
EndLib

;****  LEN   ****
;**** Do Len ****
;****        ****
Library SyB_LEN
		ld		hl,(SyB_StackAddr)
		ld		bc,9
		add		hl,bc
		ld		c,(hl)
		dec		hl
		Xor		a
		ld		(hl),a
		dec		hl
		ld		(hl),c
		dec		hl
		ld		(hl),a
		ld		hl,(SyB_StrStackAddr)
		Xor		a
		ld		b,0
		sbc		hl,bc
		ld		(SyB_StrStackAddr),hl
		ret
EndLib		

;****  LCASE$   ****
;**** Do LCASE$ ****
;****           ****
Library SyB_LCase
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(iy+9)
		cp		0
		ret		z
		ld		b,a

.SyB_LCase_1
		ld		a,(hl)
		cp 		65
		jr		c,SyB_LCase_3
		cp		91
		jr		nc,SyB_LCase_3
		add		32
		ld		(hl),a
.SyB_LCase_3
		inc		hl
		djnz	SyB_LCase_1
		ret
EndLib		

;****  LOG   ****		
;**** Do LOG ****
;****        ****
Library SyB_LOG
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_LOG_NAT
EndLib
		
;****  LOG10   ****		
;**** Do LOG10 ****
;****          ****
Library SyB_LOG10
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_LOG_DEC
EndLib

;****     MACHINE     ****
;**** Macine Function ****
;****                 ****
Library SyB_Machine:
		ld 		hl,#8139
		rst 	#28
		ld		hl,SyB_Machine_TypeList
		ld		d,0
		add		hl,de
		ld		c,(hl)
		ld		hl,(SyB_StackAddr)
		Xor		a
		ld		(hl),a
		inc		hl
		ld		(hl),c
		inc		hl
		ld		(hl),a
		ld		de,-8
		add		hl,de
		ld		(SyB_StackAddr),hl
		ret
.SyB_Machine_TypeList:		db	0,1,1,2,2,2,2,2,2,2			;0=PCW 1=CPC 2=MSX
EndLib

;****     MID$     ****
;**** Mid Function ****
;****              ****
Library SyB_MID
		ld		ix,(SyB_StackAddr)
		ld		c,(ix+7)				;Length Required
		ld		a,(ix+13)				;From Where
		;Must check A (From Where)>0
		dec 	a
		ld		l,a
		ld		h,0
		ld		a,(ix+21)				;Originals stack length
		ld		e,(ix+19)
		ld		d,(ix+20)
		sub		l
		ld		b,a
		jp		c,SyB_MID_Empty
		add		hl,de
		Xor		a
		ld		(SyB_MidTemp),a

.SyB_MID_2	
		ld		a,(SyB_MidTemp)
		cp		b
		jr		z,SyB_MID_3
		cp		c
		jr		z,SyB_MID_3
		inc		a
		ld		(SyB_MidTemp),a
		ld		a,(hl)
		ld		(de),a
		inc		hl
		inc		de
		jr		SyB_MID_2
.SyB_MID_3	
		ld		e,(ix+19)
		ld		d,(ix+20)
		ld		l,a
		ld		h,0
		add		hl,de
		ld		(SyB_StrStackAddr),hl
		jr		SyB_MID_4
.SyB_MID_Empty
		Xor		a
		ld		(ix+21),a
		ld		(SyB_StrStackAddr),de
.SyB_MID_4
		ld		(ix+21),a
		ld		hl,(SyB_StackAddr)
		ld		bc,12
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ret	
.SyB_MidTemp		db	0
EndLib	

;****       MOD        ****
;**** Do Numerical MOD ****
;****                  ****
.SyB_INT_MOD:
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		e,(iy+13)
		ld		d,(iy+14)
		call	SyB_N_Div16
		ld		(iy+13),e
		ld		(iy+14),d
		ld 		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret



;****    MOUSEOVER       ****
;**** MouseOver Function ****
;****                    ****
Library SyB_MouseOver:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		And		%1110
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		ld		bc,App_Form_List
		add		hl,bc
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		push	bc
		pop		ix
		;**** First bit		
		ld		e,(ix+4)
		ld		d,(ix+5)
		ld		l,(ix+12)
		ld		h,0
		add		hl,de
		ld		(SyB_MouseOver_X_Off),hl
		ld		e,(ix+6)
		ld		d,(ix+7)
		Xor		a
		ld		b,(ix+1)
		bit		4,b
		jp		z,SyB_MouseOver_90
		add		9
.SyB_MouseOver_90		
		bit		5,b
		jp		z,SyB_MouseOver_91
		add		9
.SyB_MouseOver_91
		ld		l,a
		ld		h,0
		add		hl,de
		ld		(SyB_MouseOver_Y_Off),hl		
		;**** Check if Item is in a Super Control
		ld		a,(iy+8)				;**** Upper Byte of ID
		And		%111
		jp		z,SyB_MouseOver_1
		;**** Do SUper control Offset gumph
		ld		l,(ix+36)
		ld		h,(ix+37)
		add		a
		add		a
		add		a
		add		a
		ld		e,a
		ld		d,0
		inc		hl
		push	hl
		add		hl,de
		ld		a,(hl)
		pop		hl
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,hl	
		add		hl,de
		push	hl
		pop		ix
		ld		e,(ix+6)
		ld		d,(ix+7)
		ld		hl,(SyB_MouseOver_X_Off)
		add		hl,de
		ld		(SyB_MouseOver_X_Off),hl
		ld		e,(ix+8)
		ld		d,(ix+9)
		ld		hl,(SyB_MouseOver_Y_Off)
		add		hl,de
		ld		(SyB_MouseOver_Y_Off),hl
		
;		di
;		ld		hl,(SyB_MouseOver_X_Off)
;		ld		de,(SyB_MouseOver_Y_Off)
;.drf	jr		drf		
		
			
.SyB_MouseOver_1		
		rst 	#20
		dw 		#813C
		push	hl						;Protect Y
		ld		hl,(SyB_MouseOver_X_Off)
		ex		de,hl
		Xor		a
		sbc		hl,de
		ld		(SyB_MouseOver_X_Off),hl
		pop		hl
		ld		de,(SyB_MouseOver_Y_Off)		
		Xor		a
		sbc		hl,de
		ld		(SyB_MouseOver_Y_Off),hl
		ld		a,(iy+8)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+7)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		de,(SyB_MouseOver_X_Off)
		ld		l,(ix+6)
		ld		h,(ix+7)
		push	hl
		Xor		a
		sbc		hl,de
		pop		hl
		jp		nc,SyB_MouseOver_1_Fail	
		ld		c,(ix+10)
		ld		b,(ix+11)
		add		hl,bc
		sbc		hl,de
		jp		c,SyB_MouseOver_1_Fail
		
		ld		de,(SyB_MouseOver_Y_Off)
		ld		l,(ix+8)
		ld		h,(ix+9)
		push	hl
		Xor		a
		sbc		hl,de
		pop		hl
		jp		nc,SyB_MouseOver_1_Fail	
		ld		c,(ix+12)
		ld		b,(ix+13)
		add		hl,bc
		sbc		hl,de
		jp		c,SyB_MouseOver_1_Fail			
		
		ld		(iy+7),1
		ld		(iy+8),0
		ret

SyB_MouseOver_1_Fail:
		ld		(iy+7),0
		ld		(iy+8),0
		ret

.SyB_MouseOver_X_Off:	dw	0
.SyB_MouseOver_Y_Off:	dw	0

EndLib

;****    MOUSEX       ****
;**** MouseX Function ****
;****                 ****
Library SyB_MouseX:
		rst 	#20
		dw 		#813C	
		ld		iy,(SyB_StackAddr)		
		ld		(iy+1),e
		ld		(iy+2),d
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
EndLib

;****     MOUSEY      ****
;**** MouseY Function ****
;****                 ****
Library SyB_MouseY:
		rst 	#20
		dw 		#813C
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),l
		ld		(iy+2),h
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
EndLib

;****     MOUSEKEY      ****
;**** MouseKey Function ****
;****                  ****
Library SyB_MouseKey:
		rst 	#20
		dw 		#813F
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),a
		ld		(iy+2),0
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
EndLib

;****      MULTIPLY       ****
;**** Do Integer Multiply ****
;****                     ****
Library SyB_INT_Mul
		ld		iy,(SyB_StackAddr)
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ex		de,hl
		push	hl
		push	hl
		pop		bc
.SyB_INT_Mul_11		
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB_INT_Mul_11
		pop		de
		sbc		hl,de
		ld		(iy+13),l
		ld		(iy+14),h
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib
		
;****     MULTIPLY      ****
;**** Do Float Multiply ****
;****                   ****				
Library SyB2_FLO_Mul
		call	SyB2_STACK_2_FLO		
		call	FLO_MULT
		jp		SyB_DecStack
EndLib


;****       NEG      ****
;**** Do Integer NEG ****
;****                ****
Library SyB_Neg_Int
		ld		iy,(Syb_StackAddr)
.SyB_Neg_Int_10		
		ld		a,(iy+7)
		Xor		255
		ld		l,a
		ld		a,(iy+8)
		Xor		255
		ld		h,a
		inc		hl
		ld		(iy+7),l
		ld		(iy+8),h
		ret
EndLib
		
;****     NEG      ****
;**** Do Float NEG ****
;****              ****
Library SyB_Neg_Flo
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+10)
		Xor		128							;**** Alter Sgn Bit
		ld		(iy+10),a
		ret
Endlib

;****          NEXT              ****
;**** Command NEXT (For Integers ****
;****                            ****

Library SyB_Next_INT
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+19)
		ld		h,(iy+20)
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		c,(iy+7)
		ld		b,(iy+8)
		ex		de,hl
		add		hl,bc
		ex		de,hl
		ld		(hl),d
		dec		hl
		ld		(hl),e	
		pop		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ex		de,hl		
		jp		(hl)
endlib

;****     NOT      ****
;**** NOT Function ****
;****              ****
Library SyB_NOT
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)					
		And		a
		jr		nz,SyB_Not_2
		ld		a,(iy+8)
		And		a
		jr		nz,SyB_Not_2
		ld		(iy+7),1
		jr		SyB_Not_3
.SyB_Not_2		;**** Means <>0 SO Result = 0
		ld		(iy+7),0
.SyB_Not_3
		ld		(iy+8),0
		ret
EndLib

;****     OPENDIALOG      ****
;**** OpenDialog function ****
;****                     ****
Library SyB_OpenDialog:
		ld		a,(AppBnkNum)
		ld		(SyB_FileDialog_Extra),a
		jp		SyB_FileDialog
EndLib


;****     OPENFILE      ****
;**** Openfile function ****
;****                   ****
Library SyB_OpenFile:
		call	SyB_GetOpenAFile
		jp		c,SyB_OpenFile_Fail_1
.SyB_OpenFile_Ok_1
		ld		(SyB_OpenFile_Temp),a			;OS File Number
		call	SyB_FreeFileSlot		
		jp		c,SyB_OpenFile_Fail_2
.SyB_OpenFile_Ok_2
		ld		iy,(SyB_StackAddr)		
		ld		(iy+7),l
		ld		(iy+8),h
		push	hl
		pop		ix
		Xor		a
		ld		b,9
.SyB_OpenFile_Ok_20
		ld		(hl),a
		inc		hl
		djnz	SyB_OpenFile_Ok_20
		ld		(ix+0),173
		ld		a,(SyB_OpenFile_Temp)
		ld		(ix+3),a
		call	SyB_Read_512_Bytes
		ret
.SyB_OpenFile_Fail_1
		ld		e,a
		ld		d,1
		ld		iy,(SyB_StackAddr)
		ld		(iy+7),0
		ld		(iy+8),0
		jp		SyB_Mark_Error
.SyB_OpenFile_Fail_2		
		ld		a,32
		jr		SyB_OpenFile_Fail_1
.SyB_OpenFile_Temp:		db	0		
EndLib

;****     OPENFORM      ****
;**** Openform function ****
;****                   ****
Library SyB_OpenForm:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		dec		a
		And		%111
		
		call	SyB_Studio_WindowOpen
		jp		c,SyB_OpenForm_2
		inc		a
.SyB_OpenForm_2
		ld		iy,(SyB_StackAddr)
		ld		(iy+7),a
		ld		(iy+8),0		
		ret
EndLib		

;****      OR       ****
;**** Do Integer OR ****
;****               ****
Library SyB_INT_Or
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		Or		(iy+13)
		ld		(iy+13),a		
		ld		a,(iy+8)
		Or		(iy+14)
		ld		(iy+14),a
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib			

;****     PEEKBYTE      ****
;**** Peek Byte Command ****
;****                   ****
Library SyB_PeekByte
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_PeekByte_2
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+7)
		ld		h,(iy+8)
		add		hl,de
		rst 	#20
		dw		#812A
		ld		(iy+13),b
		ld		(iy+14),0
.SyB_PeekByte_1		
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
.SyB_PeekByte_2			
		Xor		a
		ld		(iy+7),a
		ld		(iy+8),a
		jp		SyB_PeekByte_1
EndLib

;****     PEEKINT      ****
;**** Peek Int Command ****
;****                  ****
Library SyB_PeekInt
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_PeekInt_2
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+7)
		ld		h,(iy+8)
		add		hl,de
		rst 	#20
		dw		#8124
		ld		(iy+13),c
		ld		(iy+14),b
.SyB_PeekInt_1
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
.SyB_PeekInt_2			
		Xor		a
		ld		(iy+13),a
		ld		(iy+14),a
		jp		SyB_PeekInt_1
EndLib

;****     PEEKFLOAT      ****
;**** Peek Float Command ****
;****                    ****
Library SyB_PeekFloat
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_PeekFloat_2
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+7)
		ld		h,(iy+8)
		add		hl,de		
		rst 	#20
		dw		#8124
		ld		(iy+13),c
		ld		(iy+14),b
		rst 	#20
		dw		#8124
		ld		(iy+15),c
		ld		(iy+16),b
		rst 	#20
		dw		#812A
		ld		(iy+17),b		
.SyB_PeekFloat_1
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
.SyB_PeekFloat_2			
		Xor		a
		ld		(iy+13),a
		ld		(iy+14),a
		ld		(iy+15),a
		ld		(iy+16),a
		ld		(iy+17),a
		jp		SyB_PeekFloat_1
EndLib

;****     POKEBYTE      ****
;**** Poke Byte Command ****
;****                   ****
Library SyB_PokeByte
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+19)
		ld		h,(iy+20)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_PokeByte_1
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,de
		ld		b,(iy+7)
		rst	 	#20
		dw 		#812D
.SyB_PokeByte_1
		ld		hl,(SyB_StackAddr)
		ld		bc,18
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ret
EndLib		
		
;****     POKEFLOAT      ****
;**** Poke Float Command ****
;****                    ****
Library SyB_PokeFloat
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+19)
		ld		h,(iy+20)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_PokeFloat_1
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,de
		ld		c,(iy+7)
		ld		b,(iy+8)		
		rst	 	#20
		dw 		#8127
		ld		c,(iy+9)
		ld		b,(iy+10)
		rst	 	#20
		dw 		#8127
		ld		b,(iy+11)		
		rst	 	#20
		dw 		#812D
.SyB_PokeFloat_1
		ld		hl,(SyB_StackAddr)
		ld		bc,18
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ret			
EndLib
		
;****     POKEINT      ****
;**** Poke Int Command ****
;****                  ****
Library SyB_PokeInt
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+19)
		ld		h,(iy+20)
		ld		a,(hl)
		cp		172
		jp		nz,SyB_PokeInt_1
		inc		hl
		ld		a,(hl)
		inc		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,de
		ld		c,(iy+7)
		ld		b,(iy+8)		
		rst	 	#20
		dw 		#8127
.SyB_PokeInt_1
		ld		hl,(SyB_StackAddr)
		ld		bc,18
		add		hl,bc
		ld		(SyB_StackAddr),hl
		ret		
EndLib

;****        RAD            ****
;**** RAD - Set Radian Mode ****
;****                       ****
Library SyB_Rad:
		Xor		a
		ld		(FLO_VALUE_DEGRAD),a
		ret
EndLib	

;****     RAMFREE      ****
;**** RamFree Function ****			
;****                  ****
Library SyB_RamFree
		ld hl,#8100			;SymBos Function
		rst #28
		ld		l,e
		inc		l
		ld		h,0
		ld		b,6
.SyB_RamFree_1		
		add		hl,hl				;*2
		djnz	SyB_RamFree_1
		push	ix
		pop		de
		ld		a,d
		ld		d,0
		rra
		rra
		And		%111111
		ld		e,a
		add		hl,de
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),l
		ld		(iy+2),h
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
EndLib

;****     RAMSIZE      ****
;**** RamFree Function ****			
;****                  ****
Library SyB_RamSize
		ld 		hl,#8100			;SymBos Function
		rst 	#28
		ld		l,d
		inc		l
		ld		h,0
		ld		b,6
.SyB_RamSize_1		
		add		hl,hl				;*2
		djnz	SyB_RamSize_1
		ld		iy,(SyB_StackAddr)
		ld		(iy+1),l
		ld		(iy+2),h
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib



;****                   ****
;**** Randomize Command ****
;****                   ****
Library SyB_Randomize
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		call	FLO_RANDOMIZE
		ld		hl,(SyB_StackAddr)
		ld		bc,6
		add		hl,bc		
		ld		(SyB_StackAddr),hl
		ret
EndLib

;****     REFRESHALL      ****
;**** Refresh All command ****
;****                     ****
Library SyB_RefreshAll:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		dec		a
		ld		c,a
		ld		b,0
		ld		hl,SyB_Studio_FormIDs
		add		hl,bc
		ld		a,(hl)
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ld		e,255
		jp		SyDesktop_WINDIN
EndLib

;****     REFRESHAREA      ****
;**** Refresh Area Command ****
;****                      ****
Library SyB_RefreshArea
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ld		(AppMsgB+08),hl
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		(AppMsgB+10),hl
		ld		l,(iy+19)
		ld		h,(iy+20)
		ld		(AppMsgB+6),hl
		ld		c,(iy+32)
		ld		b,0
		ld		hl,SyB_Studio_FormIDs
		add		hl,bc
		ld		a,(hl)
		ld		l,(iy+25)
		ld		h,(iy+26)
		ld		e,(iy+31)
		ld		bc,30
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ld 		c,MSC_DSK_WINPIN
        jp 		SyDesktop_SendMessage		
EndLib

;****      REFRESHOBJ     ****
;**** Refresh Obj Command ****
;****                     ****

Library SyB_RefreshObj
		ld		iy,(SyB_StackAddr)
		ld		e,(iy+7)
		ld		a,(iy+8)
		rra
		rra
		rra
		And		%111
		ld		c,a
		ld		b,0
		ld		hl,SyB_Studio_FormIDs
		add		hl,bc
		ld		a,(hl)		
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		SyDesktop_WINDIN
EndLib
		

;****              ****
;**** Refresh Menu ****
;****              ****
Library SyB_RefreshMenu:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		dec		a
		ld		c,a
		ld		b,0
		ld		hl,SyB_Studio_FormIDs
		add		hl,bc
		ld		a,(hl)
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
        ld 		c,MSC_DSK_WINMEN
        jp 		SyDesktop_SendMessage
		ret		
EndLib		
		
;****               ****
;**** Refresh Title ****
;****               ****
Library SyB_RefreshTitle:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		dec		a
		ld		c,a
		ld		b,0
		ld		hl,SyB_Studio_FormIDs
		add		hl,bc
		ld		a,(hl)
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		SyDesktop_WINTIT
EndLib
		
;**** REFRESHSTATUS  ****
;**** Refresh Status ****
;****                ****
Library SyB_RefreshStatus:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		dec		a
		ld		c,a
		ld		b,0
		ld		hl,SyB_Studio_FormIDs
		add		hl,bc
		ld		a,(hl)
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		SyDesktop_WINSTA
EndLib

;****    RESOLUTIONX       ****		
;**** ResolutionX Function ****		
;****                      ****
Library SyB_ResolutionX
		ld 		hl,#8139
		rst 	#28
		ld		hl,(SyB_StackAddr)
		Xor		a		
		ld		(hl),a
		inc		hl
		ld		(SyB_TempByte),ix
		ld		de,(SyB_TempByte)
		ld		(hl),e
		inc		hl
		ld		(hl),d
		ld		de,-8
		add		hl,de
		ld		(SyB_StackAddr),hl
		ret
EndLib

;****    RESOLUTIONY       ****		
;**** ResolutionY Function ****		
;****                      ****
Library SyB_ResolutionY:
		ld 		hl,#8139
		rst 	#28
		ld		hl,(SyB_StackAddr)
		Xor		a		
		ld		(hl),a
		inc		hl
		ld		(SyB_TempByte),iy
		ld		de,(SyB_TempByte)
		ld		(hl),e
		inc		hl
		ld		(hl),d
		ld		de,-8
		add		hl,de
		ld		(SyB_StackAddr),hl
		ret
EndLib

;****   RND  ****
;**** Do RND ****
;****        ****
Library SyB_RND
		ld		hl,(SyB_StackAddr)
		inc		hl
		call	FLO_RND
		ex		de,hl
		ld		hl,6
		add		hl,de
		call 	FLO_MULT
		ret
EndLib	


;****     READBYTE      ****
;**** ReadByte Function ****
;****                   ****
Library SyB_ReadByte
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_ReadByte_OK_1
		cp		174						;ReadFile
		jp		z,SyB_ReadByte_OK_1
		;*** Failed
		di
.jhft	jr		jhft
		ret
		
.SyB_ReadByte_OK_1:
		push	hl
		pop		ix		
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)		
		ld		(iy+7),a
		ld		(iy+8),0
		ret
EndLib

;****      READFLOAT      ****
;**** ReadFloat Function  ****
;****                     ****
Library SyB_ReadFloat
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_ReadFloat_OK_1
		cp		174						;ReadFile
		jp		z,SyB_ReadFloat_OK_1
		;*** Failed
		di
.jhft1	jr		jhft1
		ret
.SyB_ReadFloat_OK_1:
		push	hl
		pop		ix
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+7),a
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+8),a
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+9),a
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+10),a
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+11),a				
		ret
.SyB_ReadFloat_Temp:	dw	0
EndLib					
		
;****     READINT      ****
;**** ReadInt Function ****
;****                  ****
Library SyB_ReadInt
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_ReadInt_OK_1
		cp		174						;ReadFile
		jp		z,SyB_ReadInt_OK_1
		;*** Failed
		di
.jhft2	jr		jhft2
		ret
.SyB_ReadInt_OK_1:
		push	hl
		pop		ix
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+7),a
		call	SyB_Read_BFF
		ld		iy,(SyB_StackAddr)
		ld		(iy+8),a				
		ret
.SyB_ReadInt_Temp:	dw	0
EndLib

;****     READLINE      ****
;**** ReadLine Function  ****
;****                    ****
Library SyB_ReadLine
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_ReadLine_OK_1
		cp		174						;ReadFile
		jp		z,SyB_ReadLine_OK_1
		;*** Failed
		di
.jhft3	jr		jhft3
		ret	
.SyB_ReadLine_OK_1:
		ld		de,(SyB_StrStackAddr)
		ld		(iy+7),e
		ld		(iy+8),d
		ld		b,0
		ld		c,0
		push	hl
		pop		ix
.SyB_ReadLine_OK_2		
		push	de
		push	bc
		call	SyB_Read_BFF
		pop		bc
		pop		de
		cp		13
		jp		z,SyB_ReadLine_FinishedReading		
		cp		10
		jp		nz,SyB_ReadLine_OK_3
		ld		r,a
		Xor		a
		cp		c
		jp		nz,SyB_ReadLine_OK_3
		ld		c,1
		jp		SyB_ReadLine_OK_2		
.SyB_ReadLine_OK_3
		ld		c,1
		inc		b
		ld		(de),a
		inc		de
		ld		a,b
		cp		251
		jp		c,SyB_ReadLine_OK_2
.SyB_ReadLine_FinishedReading
		ld		(SyB_StrStackAddr),de
		ld		iy,(SyB_StackAddr)
		ld		(iy+9),b
		ret	
Endlib
		
;****     RIGHT$     ****
;**** Right Function ****
;****                ****
Library SyB_Right
		ld		iy,(SyB_StackAddr)
		ld		c,(iy+7)				;Length Required
		ld		a,(iy+15)				;Originals stack length
		sub		c
		jp		c,SyB_Right_1
		ld		b,a
		ld		e,(iy+13)				;DE=start of text on stack
		ld		d,(iy+14)	
		ld		(iy+15),c				;Store new length
		ld		a,c
		And		a
		jp		z,SyB_Right_1
		ld		l,b
		ld		h,0
		add		hl,de					;HL = Start of text
		ld		b,0
		ldir
		ld		(SyB_StrStackAddr),hl
.SyB_Right_1
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
EndLib		

;****     SAVEDIALOG      ****
;**** SaveDialog function ****
;****                     ****
Library SyB_SaveDialog:
		ld		a,(AppBnkNum)
		set		6,a
		ld		(SyB_FileDialog_Extra),a
		jp		SyB_FileDialog
EndLib

;****     SCREENMODE      ****
;**** ScreenMode Function ****
;****                     ****
Library SyB_ScreenMode:
		ld 		hl,#8139
		rst 	#28
		ld		hl,(SyB_StackAddr)
		Xor		a
		ld		(hl),a
		inc		hl
		ld		(hl),e
		inc		hl
		ld		(hl),a
		ld		de,-8
		add		hl,de
		ld		(SyB_StackAddr),hl
		ret
EndLib

;****     SETOBJPOS     ****
;**** Command SetObjPos ****
;****                   ****
Library SyB_SetObjPos
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+20)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+19)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		e,(iy+13)
		ld		d,(iy+14)
		di
		ld		(ix+6),e
		ld		(ix+7),d
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		(ix+8),e
		ld		(ix+9),d
		ei
		ld		bc,18
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****     SETOBJWIDTH     ****
;**** Command SetObjWidth ****
;****                     ****
Library SyB_SetObjWidth
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+14)				;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+13)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		(ix+10),e
		ld		(ix+11),d
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****     SETOBJHEIGHT     ****
;**** Command SetObjHeight ****
;****                      ****
Library SyB_SetObjHeight
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+14			;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+13)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		(ix+12),e
		ld		(ix+13),d
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****     SETOBJTEXT     ****
;**** Command SetObjText ****
;****                    ****
Library SyB_SetObjText:
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+14			;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+13)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX	
		ld		a,(ix+2)
		cp		32
		jp		z,SyB_SetObjText_Textline
		ld		e,a
		ld		d,0
		ld		hl,SyB_Obj_Text_Pointer
		add		hl,de
		ld		a,(hl)
		And		a
		jp		z,SyB_SetObjText_Empty	
		bit		7,a
		jp		z,SyB_SetObjText_2
		ld		l,(ix+4)
		ld		h,(ix+5)
		And		%111111		
		jp		SyB_SetObjText_3
		
.SyB_SetObjText_2
		push	ix
		pop		hl
.SyB_SetObjText_3
		ld		e,a
		ld		d,0
		add		hl,de
.SyB_SetObjText_4		
		call	SyB_Str_Store_2_Ram
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy		
		ret
.SyB_SetObjText_Textline:		
		ld		l,(ix+4)
		ld		h,(ix+5)		
		push	hl
		pop		ix
		ld		a,(ix+10)
		ld		e,(iy+9)
		cp		e
		jp		nc,SyB_SetObjText_Textline_2
		ld		(iy+9),a
.SyB_SetObjText_Textline_2:		
		ld		a,(iy+9)
		ld		(ix+8),a
		jp		SyB_SetObjText_4
		
.SyB_SetObjText_Empty:
		ld		l,(iy+7)
		ld		h,(iy+8)
		ld		(SyB_StrStackAddr),hl
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy		
		ret
EndLib

;****     SETOBJVISIBLE     ****
;**** Command SetObjVisible ****
;****                       ****
Library SyB_SetObjVisible
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+14			;**** Upper Byte of ID
		rra
		rra
		rra
		And		%111
		ld		l,a
		ld		h,0
		ld		e,(iy+13)				;**** Lower Byte of Id
		ld		d,0
		call	SyB_ReturnFormDatainIX
		ld		a,(ix+2)
		And		%111111
		ld		b,a
		ld		a,(iy+7)
		Or		a
		jp		z,SyB_SetObjVisible_1
		res		7,b
		jp		SyB_SetObjVisible_2
.SyB_SetObjVisible_1:
		set		7,b
.SyB_SetObjVisible_2	
		ld		(ix+2),b
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****      SGN       ****
;**** Do Integer SGN ****
;****                ****
Library SyB_Sgn_Int
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)
		bit		7,a
		ret		nz
		ld		a,(iy+7)
		Xor		255
		ld		l,a
		ld		a,(iy+8)
		Xor		255
		ld		h,a
		inc		hl
		ld		(iy+7),l
		ld		(iy+8),h
		ret	
endlib

;****     SGN      ****
;**** Do Float SGN ****
;****              ****
Library SyB_Sgn_Flo
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+10)
		set		7,a							;**** Alter Sgn Bit
		ld		(iy+10),a
		ret	
EndLib		

;****   SIN  ****
;**** Do SIN ****
;****        ****
Library SyB_SIN
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_SIN
EndLib

;****      STR     ****
;**** Str Function ****
;****              ****
Library SyB_Str
		



		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		ld		de,(SyB_StrStackAddr)
		call	SyB_Str_2
		ld		ix,(SyB_StackAddr)
		ld		hl,(SyB_StrStackAddr)
		ld		(ix+6),5
		ld		(ix+7),l
		ld		(ix+8),h
		ld		(Syb_StrStackAddr),de
		ex		de,hl
		Xor		a
		sbc		hl,de
		ld		(ix+9),l
		ret
.SyB_Str_2
 		push	de
        ex		de,hl
        call 	dspget
        pop 	hl		
        jp 		dsptxt
EndLib

;****      SUB       ****
;**** Do Integer Sub ****
;****                ****
Library SyB_INT_Sub
		ld		iy,(SyB_StackAddr)
		Xor		a
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		l,(iy+13)
		ld		h,(iy+14)
		sbc		hl,de
		ld		(iy+13),l
		ld		(iy+14),h
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib
		
;****     SUB      ****
;**** Do Float Sub ****
;****              ****
Library SyB_FLO_Sub
		call	SyB2_STACK_2_FLO
		call	FLO_SUB
		jp		SyB_DecStack
EndLib

;****   SQR  ****		
;**** Do SQR ****
;****        ****
Library SyB_SQR
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_SQR
Endlib

;****   TAN  ****
;**** Do TAN ****
;****        ****
Library SyB_TAN
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		jp		FLO_TAN
EndLib

;****     TRIM      ****
;**** Trim Function ****
;****
Library SyB_Trim 
;AFunction LTrim$($)
		ld		ix,(SyB_StackAddr)
		ld		a,(ix+9)
		Or		a
		ret		z
		ld		l,(ix+7)
		ld		h,(ix+8)
		
		ld		e,a				;This is the length
		ld		d,0
		ld		bc,0
.SyB_Trim_3		
		ld		a,(hl)
		cp		#20
		jp		nz,SyB_Trim_2
		inc		bc
		inc		hl
		inc		d
		dec		e
		jp		nz,SyB_Trim_3
.SyB_Trim_2
		ld		a,(ix+9)
		sub		d
		ld		(ix+9),a
		ld		c,a
		ld		b,0
		push	de
		ld		e,(ix+7)
		ld		d,(ix+8)
		Or		a
		jp		z,SyB_Trim_4
		ld		a,e
		cp		l
		jp		z,SyB_Trim_4
		ldir
.SyB_Trim_4		
		pop		de
		ld		c,d
		ld		b,0
		ld		hl,(SyB_StrStackAddr)
		Xor		a
		sbc		hl,bc
		ld		(SyB_StrStackAddr),hl
		ret
EndLib

;****   UCASE$  ****		
;**** Do UCASE$ ****
;****           ****
Library SyB_UCase
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		b,(hl)	
		ex		de,hl
.SyB_UCase_1
		ld		a,(hl)
		cp 		97
		jr		c,SyB_UCase_3
		cp		123
		jr		nc,SyB_UCase_3
		sub		32
		ld		(hl),a
.SyB_UCase_3
		inc		hl
		djnz	SyB_UCase_1
		ret
EndLib

;****     WRITEBYTE      ****
;**** WriteByte Function ****
;****                    ****
Library SyB_WriteByte
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)	
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_WriteByte_OK_1
		cp		175						;WriteFile
		jp		z,SyB_WriteByte_OK_1
		;*** Failed
		ld		de,256+16
		ld		bc,12
		ld		a,0
		jp		SyB_Mark_Error
.SyB_WriteByte_OK_1:
		push	hl
		pop		ix						;IX=Start of File Data
		ld		a,(iy+7)
		call	SyB_Write_Byte_To_File
		ld		iy,(SyB_StackAddr)
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib	

;****     WRITEFILE      ****
;**** Writefile function ****
;****                    ****
Library SyB_WriteFile:
		call	SyB_GetNewFile
		jp		c,SyB_WriteFile_Fail_1
.SyB_WriteFile_Ok_1
		ld		b,a						;OS File Number
		call	SyB_FreeFileSlot		
		jp		c,SyB_WriteFile_Fail_1
.SyB_WriteFile_Ok_2
		ld		iy,(SyB_StackAddr)		
			
		ld		(iy+13),l
		ld		(iy+14),h		
		ld		a,175
		ld		(hl),a
		inc		hl
		Xor		a
		ld		(hl),a			;Set the Write to 0
		inc		hl
		ld		a,1
		ld		(hl),a			;Set Empty to 1
		inc		hl
		ld		(hl),b
		inc		hl
		Xor		a
		ld		b,5
.SyB_WriteFile_Ok_3
		ld		(hl),a
		inc		hl
		djnz	SyB_WriteFile_Ok_3
.SyB_WriteFile_Ok_4
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy		
		ret
.SyB_WriteFile_Fail_1
		ld		(iy+13),0
		ld		(iy+14),0
		jp		SyB_WriteFile_Ok_4
EndLib


;****     WRITEFLOAT      ****
;**** WriteFloat Function ****
;****                     ****
Library SyB_WriteFloat
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)	
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_WriteFloat_OK_1
		cp		175						;WriteFile
		jp		z,SyB_WriteFloat_OK_1
		;*** Failed
		ld		de,256+16
		ld		bc,12
		ld		a,0
		jp		SyB_Mark_Error
.SyB_WriteFloat_OK_1:
		push	hl
		pop		ix						;IX=Start of File Data
		ld		a,(iy+7)
		call	SyB_Write_Byte_To_File
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)
		call	SyB_Write_Byte_To_File
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+9)
		call	SyB_Write_Byte_To_File
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+10)
		call	SyB_Write_Byte_To_File
		ld		iy,(SyB_StackAddr)						
		ld		a,(iy+11)
		call	SyB_Write_Byte_To_File
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****     WRITEINT      ****
;**** WriteInt Function ****
;****                   ****
Library SyB_WriteInt
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)	
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_WriteInt_OK_1
		cp		175						;WriteFile
		jp		z,SyB_WriteInt_OK_1
		;*** Failed
		ld		de,256+16
		ld		bc,12
		ld		a,0
		jp		SyB_Mark_Error
.SyB_WriteInt_OK_1:
		push	hl
		pop		ix						;IX=Start of File Data
		ld		a,(iy+7)
		call	SyB_Write_Byte_To_File
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+8)
		call	SyB_Write_Byte_To_File
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib	

;****     WRITELINE      ****
;**** WriteLine Function ****
;****                    ****
Library SyB_WriteLine
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)	
		ld		a,(hl)
		cp		173						;OpenFile
		jp		z,SyB_WriteLine_OK_1
		cp		175						;WriteFile
		jp		z,SyB_WriteLine_OK_1
		;*** Failed
		ld		de,256+16
		ld		bc,12
		ld		a,0
		jp		SyB_Mark_Error
.SyB_WriteLine_OK_1:
		push	hl
		pop		ix						;IX=Start of File Data
		ld		b,(iy+9)
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		a,b
		And		a
		jp		z,SyB_WriteLine_OK_3	
.SyB_WriteLine_OK_2:
		ld		a,(de)	
		inc		de
		push	bc
		push	de
		call	SyB_Write_Byte_To_File
		pop		de
		pop		bc
		djnz	SyB_WriteLine_OK_2
.SyB_WriteLine_OK_3:		
		ld		a,13
		call	SyB_Write_Byte_To_File		
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****      XOR       ****
;**** Do Integer XOR ****
;****               ****
Library SyB_INT_Xor
		ld		iy,(SyB_StackAddr)
		ld		a,(iy+7)
		Xor		(iy+13)
		ld		(iy+13),a		
		ld		a,(iy+8)
		Xor		(iy+14)
		ld		(iy+14),a
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib	

;****************************************************************************************
;****************************************************************************************
;****************************************************************************************

;****                       ****
;**** 16 Bit Divide Routine ****
;****                       ****
Library SyB_N_Div16:
		ex		de,hl           	; HL = DE \ HL
		ld		a,e             	; Division by zero?
		Or		d
		jr		nz,SyB_N_Div17      ; Continue of not
		ld		hl,0
		ld		de,0
		scf			            	; Set Carry to indicate an error
		ret
.SyB_N_Div17:
		ld		c,l             	; AC = HL
		ld		a,h
		ld		hl,0            	; HL = Modulus
		ld		b,16            	; 16-bit division
		Or		a               	; Start with carry reset
.SyB_N_Div18:
		rl		c               	; AC = AC * 2
		rla  	                	; (set Carry to bit 0)
		rl		l               	; HL = HL * 2
		rl		h               	; (reset Carry again (HL = 0))
		push	hl
		sbc		hl,de
		ccf                     	; Carry set when Ok
		jr		c,SyB_N_Div19       ; Modulus cannot be >= Value
		ex		(sp),hl         	; Restore Modulus
.SyB_N_Div19:
		inc		SP              	; Get Modulus from Stack
        inc		SP
		djnz 	SyB_N_Div18         ; Repeat for all bits
; Shift last Carry-bit to divider
		ex		de,hl           	; DE = Modulus
		rl		c               	; Carry to C
		ld		l,c             	; HL = AC
		rla
		ld		h,a
		Or		a               	; Reset Carry (valid result)
		ret
EndLib

;**** Converts the Stack from a Float to Integer Value
;**** Depending on What Stack needs to be adjusted *****
Library SyB_FLO_2_INT_Stack_1
		ld		bc,7
		jp		SyB_FLO_2_INT_BC
EndLib
Library SyB_FLO_2_INT_Stack_2
		ld		bc,13
		jp		SyB_FLO_2_INT_BC
EndLib
Library SyB_FLO_2_INT_Stack_3
		ld		bc,19
		jp		SyB_FLO_2_INT_BC
Endlib
Library SyB_FLO_2_INT_Stack_4
		ld		bc,25
		jp		SyB_FLO_2_INT_BC
EndLib
Library SyB_FLO_2_INT_Stack_5
		ld		bc,31
		jp		SyB_FLO_2_INT_BC
EndLib
Library SyB_FLO_2_INT_Stack_6
		ld		bc,37
		jp		SyB_FLO_2_INT_BC
EndLib
Library SyB_FLO_2_INT_Stack_7
		ld		bc,43
		jp		SyB_FLO_2_INT_BC		
EndLib
Library SyB_FLO_2_INT_Stack_8
		ld		bc,49
		jp		SyB_FLO_2_INT_BC
EndLib
;**** Converts the Stack from a Float to Integer Value
Library SyB_FLO_2_INT_BC
		ld		hl,(SyB_StackAddr)
		add		hl,bc
.SyB_FLO_2_INT_XTRA		
		push	hl
		call	FLO_ROUND_FLO_TO_HLA
		bit		7,a
		jr		z,SyB_FLO_2_INT_2
		ld		a,l
		Xor		255
		ld		l,a
		ld		a,h
		Xor		255
		ld		h,a
		inc		hl
.SyB_FLO_2_INT_2
		ex		de,hl
		pop		hl
		ld		(hl),e
		inc		hl
		ld		(hl),d
		ret
Endlib		

;****                                     ****
;**** Returns HL as Start of Form & ID No ****
;****                                     ****
Library SyB_ReturnFormDatainIX
		add		hl,hl
		ld		bc,ControWindowDataList
		add		hl,bc
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		ex		de,hl		
		add		hl,hl			;*2
		add		hl,hl			;*4
		add		hl,hl			;*8
		add		hl,hl			;*16
		add		hl,bc
		push	hl
		pop		ix
		ret	
EndLib

;****                          ****
;**** Find Empty Slot for File ****
;****                          ****
Library SyB_FreeFileSlot
		Xor		a
		ld		hl,(SyB_File_Data_Buffer_1)
		cp		(hl)
		ret		z
		ld		hl,(SyB_File_Data_Buffer_2)
		cp		(hl)
		ret		z
		ld		hl,(SyB_File_Data_Buffer_3)
		cp		(hl)
		ret		z
		ld		hl,(SyB_File_Data_Buffer_4)
		cp		(hl)
		ret		z
		scf
		ret


;****                                        ****
;**** Return A file - With Carry set if Fail ****
;****                                        ****
Library SyB_GetOpenAFile
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)				;Start of String
		ld		h,(iy+8)
		ld		(SyB_StrStackAddr),hl
		ld		a,(iy+9)				;Length
		And		a						;If Length Zero
		jp		z,SyB_GetOpenAFile_Fail		;So Fail if zero
		ld		b,0	
		ld		de,(SyB_File_Name_Input)	;DE=Filename/Path		
		ld		c,a						;c=length
		ldir							;repeat
		Xor		a						;put a zero ender in the string
		ld		(de),a					;
		ld		a,(appBnkNum)
		ld		hl,(SyB_File_Name_Input)
		db		#DD,#67
		call	SyFile_FILOPN
		jr		nc,SyB_GetOpenAFile_Ok
		;**** Okay it failed ****
.SyB_GetOpenAFile_Fail:
		di
.fjt	jr		fjt

		scf
.SyB_GetOpenAFile_Ok:		
		ret
EndLib

;****                                            ****
;**** Return A New File - With Carry Set if Fail ****
;****                                            ****
Library SyB_GetNewFile
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		ld		(SyB_StrStackAddr),hl
		ld		a,(iy+15)
		And		a
		jp		z,SyB_GetNewFile_Fail		;So Fail if zero
		ld		b,0	
		ld		de,(SyB_File_Name_Input)	;DE=Filename/Path		
		ld		c,a						;c=length
		ldir							;repeat
		Xor		a						;put a zero ender in the string
		ld		(de),a					;
		ld		a,(appBnkNum)
		ld		hl,(SyB_File_Name_Input)
		db		#DD,#67
		ld		a,(iy+7)
		And		%100111
		call	SyFile_FILNEW		
		jr		nc,SyB_GetNewFile_Ok
		;**** Okay it failed ****
.SyB_GetNewFile_Fail:
		scf
.SyB_GetNewFile_Ok:		
		ret
EndLib		
			

;****                                ****
;**** Write a byte to an opened file ****
;****                                ****
Library SyB_Write_Byte_To_File
		ld		(ix+1),1
		push	ix
		pop		hl
		ld		bc,10
		add		hl,bc
		ld		e,(ix+4)
		ld		d,(ix+5)
		add		hl,de
		ld		(hl),a			;**** Has copied
		
		;**** Check if 511
		ld		a,e
		cp		255
		jp		nz,SyB_Write_Byte_To_File_2
		ld		a,d
		And		%1
		jp		nz,SyB_Write_Byte_To_File_2
		
		;So is a save time!
		ld		(ix+1),0			;Write set to zero
		di
.fajg	jr		fajg
		call	SyB_Write_512_Bytes
		
		
		
;**** Definately not saving (not 511)		
.SyB_Write_Byte_To_File_2
		push	ix
		ld		l,(ix+4)
		ld		h,(ix+5)
		ld		e,(ix+6)
		ld		d,(ix+7)
		ld		ix,1
		ld		iy,0
		call	SyB_Math_Add32
		pop		ix
		ld		(ix+4),l
		ld		(ix+5),h
		ld		(ix+6),e
		ld		(ix+7),d
		;**** Check FilePos against Length
		ld		a,h
		And		%1
		ld		e,(ix+8)
		ld		d,(ix+9)
		cp		d
		jp		c,SyB_Write_Byte_To_File_4
		ld		a,l
		cp		e
		jp		c,SyB_Write_Byte_To_File_3
.SyB_Write_Byte_To_File_4
		ld		(ix+8),l
		ld		(ix+9),h
		ret

.SyB_Write_Byte_To_File_3
		di
.jeer2	jr		jeer2		
	
		
		
EndLib		


	

;****                                   ****
;**** Return a byte from an opened file ****
;****                                   ****
;Input IX = File Data 
Library SyB_Read_BFF
		;**** Lets get the Byte reading ****
		ld		l,(ix+4)
		ld		a,(ix+5)
		And		%1
		ld		h,a
		
		ld		e,(ix+8)
		ld		d,(ix+9)
		push	hl
		sbc		hl,de
		pop		hl
		jp		nc,SyB_Read_Eof
		
		push	ix
		pop		de
		add		hl,de
		ld		bc,10
		add		hl,bc
		ld		a,(hl)
		ld		(SyB_Read_Byte_From_File_Byte),a
		;**** Lets add 1 to filepointer ****
		ld		l,(ix+4)
		ld		h,(ix+5)
		ld		e,(ix+6)
		ld		d,(ix+7)
		push	ix
		ld		ix,1
		ld		iy,0				
		call	SyB_Math_Add32
		pop		ix		
			
		Xor		a
		cp		l
		jp		nz,SyB_Read_BFF_3
		ld		a,h
		And		%1
		jp		nz,SyB_Read_BFF_3
		;**** Check if we need to write the old stuff
		push	hl
		push	de
		ld		a,(ix+1)
		cp		1
		jp		nz,SyB_Read_BFF_99
		call	SyB_Write_512_Bytes
.SyB_Read_BFF_99		
		call	SyB_Read_512_Bytes
		pop		de
		pop		hl		
		
.SyB_Read_BFF_3
		ld		(ix+4),l
		ld		(ix+5),h
		ld		(ix+6),e
		ld		(ix+7),d
		ld		a,(SyB_Read_Byte_From_File_Byte)
		ret
.SyB_Read_Byte_From_File_Byte:		db 	0

.SyB_Read_Eof
		ld		a,0	
		ret	
EndLib

;IX=Address of File Data Header
Library SyB_Write_512_Bytes
		;**** First must reset File Pointer 
		ld		a,(ix+5)				;Get Pointer down to last 512
		And		%11111110
		ld		b,a
		ld		c,0
		ld		e,(ix+6)
		ld		d,(ix+7)
		ld		a,(ix+3)
		push	ix
		ld		c,0
		call	SyFile_FILPOI
		pop		ix
		;**** Back to save
		push	ix
		pop		hl
		ld		bc,10
		add		hl,bc					;HL = Start of Data
		ld		(ix+1),0				;Set write Byte to Zero
		ld		a,(AppBnkNum)
		ld		e,a
		ld		a,(ix+3)				;A= OS Reference
		ld		c,(ix+8)				;BC = Length to write
		ld		b,(ix+9)
		push	ix
		call	SyFile_FILOUT
		pop		ix
		ret
EndLib	

;****                                    ****
;**** Get 512bytes (or whatever) of file ****
;****                                    ****
;IX = Start of file Data
Library SyB_Read_512_Bytes
		push	ix
		pop		hl
		ld		bc,10
		add		hl,bc
		ld		a,(AppBnkNum)
		ld		e,a
		ld		a,(ix+3)
		ld		bc,512
		push	ix
		call	SyFile_FILINP
		pop		ix
		ld		(ix+1),0
		ld		(ix+8),c
		ld		(ix+9),b
		ret
Endlib


;****     OPENDIALOG      ****
;**** OpenDialog function ****
;****                     ****
Library SyB_FileDialog:
		ld		iy,(SyB_StackAddr)
		;**** copy "*  ",0 into file area 
		ld		hl,SyB_FileDialog_Data
		ld		bc,4
		ld		de,(SyB_File_Dialog_Pointer)
		ldir
		push	de
		;**** oopy real stuff
		ld		l,(iy+13)
		ld		h,(iy+14)		
		ld		a,(iy+15)
		And		a
		jp		z,SyB_FileDialog_1
		ld		de,(SyB_File_Dialog_Pointer)		
		cp		3
		jp		c,SyB_FileDialog_2
		ld		a,3
.SyB_FileDialog_2:
		ld		c,a
		ld		b,0
		ldir
.SyB_FileDialog_1:		
		pop		de
		ld		l,(iy+19)
		ld		h,(iy+20)		
		ld		a,(iy+21)		
		ld		(SyB_StrStackAddr),hl			;Reset to begining
		And		a
		jp		z,SyB_FileDialog_3
		ld		c,a
		ld		b,0
		ldir
.SyB_FileDialog_3:
		ld		hl,(SyB_File_Dialog_Pointer)		
		ld		a,(SyB_FileDialog_Extra)
		ld		c,(iy+7)
		ld		ix,128
		ld		iy,6000
;		ld		de,Form1_ControlWindow
		call	SySystem_SELOPN
		ld		iy,(SyB_StackAddr)
		And		a
		jp		nz,SyB_FileDialog_Fail
		ld		hl,(SyB_File_Dialog_Pointer)
		ld		bc,4
		add		hl,bc
		ld		de,(SyB_StrStackAddr)
		ld		(iy+19),e
		ld		(iy+20),d
		ld		b,0
.SyB_FileDialog_4:
		ld		a,(hl)
		And		a
		jp		z,SyB_FileDialog_5
		ld		(de),a
		inc		hl
		inc		de
		inc		b
		jr		SyB_FileDialog_4
.SyB_FileDialog_5:
		ld		(iy+21),b
		ld		(SyB_StrStackAddr),de
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret	
.SyB_FileDialog_Fail:
		ld		de,(SyB_StrStackAddr)
		ld		(iy+19),e
		ld		(iy+20),d
		ld		(iy+21),0
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret				
SyB_FileDialog_Data:	db "*  ",0
SyB_FileDialog_Extra:	db	0
EndLib


Library SyB_Math_Add32
;*************************************
; In: HL/DE: eerste getal (low/high)
;     IX/IY: tweede getal (low/high)
; Uit: HL/DE: resultaat (low/high)
				push    ix
                pop     bc
                add     hl,bc
                ex      de,hl
                push    iy
                pop     bc
                adc     hl,bc
                ex      de,hl
                ret
;************************************
EndLib

;****            ****
;**** Mark Error ****
;****            ****
;DE = Error Number
Library SyB_Mark_Error
		ld		(ErrorNum),de
		pop		hl						;Gets Return Stack
		ld		(ErrorPC),hl
		ld		a,d
		cp		8
		jp		c,SyB_Mark_Error_1
		di
.SyB_Mark_Error_2		
		jr		.SyB_Mark_Error_2
.SyB_Mark_Error_1
		jp		(hl)
EndLib		

;*************************************************
;*********** PUSHING VALUES TO STACK *************
;*************************************************

;****                          ****
;**** Push Var Byte onto Stack ****
;****                          ****
Library SyB_Push_V_Byt
		pop		hl							;10
		ld		e,(hl)						;7
		inc		hl							;6
		ld		d,(hl)						;7
		inc		hl							;6
		ld		a,(de)						;7
		exx									;4
		ld		hl,(SyB_StackAddr)			;16
		inc		hl							;6
		ld		(hl),a						;7
		inc		hl							;6
		Xor		a							;7
		ld		(hl),a						;7
		ld		bc,-8						;10
		add		hl,bc						;11
		ld		(SyB_StackAddr),hl			;16
		exx									;4
		jp		(hl)
endlib		

;****                        ****
;**** Push HL INT onto Stack ****
;****                        ****
Library SyB_Push_V_Int_Direct
		ex		de,hl					;4
		ld		hl,(SyB_StackAddr)		;16
		inc		hl						;6
		ld		(hl),e					;7
		inc		hl						;6
		ld		(hl),d					;7
		ld		bc,-8					;16
		add		hl,bc					;11
		ld		(SyB_StackAddr),hl		;16
		ret								;10
EndLib

;****                           ****
;**** Push INT Array onto Stack ****
;****                           ****
;DE = Array Address + 2
Library SyB_Push_V_Int_Array_1_Direct
		ld		ix,(SyB_StackAddr)
		ld		l,(ix+7)
		ld		h,(ix+8)
		add		hl,hl					;**** Times 2
		add		hl,de
		ld		a,(hl)
		ld		(ix+7),a
		inc		hl
		ld		a,(hl)
		ld		(ix+8),a
		ret
Endlib

;****                           ****
;**** Push FLO Array onto Stack ****
;****                           ****
;DE = Array Address + 2
Library SyB_Push_V_Flo_Array_1_Direct
		ld		hl,(SyB_StackAddr)
		ld		bc,7
		add		hl,bc
		push	hl
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		ld		l,c
		ld		h,b
		add		hl,hl
		add		hl,hl
		add		hl,bc
		add		hl,de
		pop		de
		ldi
		ldi
		ldi
		ldi
		ldi
		ret
EndLib		

;****                                 ****
;**** Push Numeric Integer onto Stack ****
;****                                 ****		
Library SyB_Push_N_Int
		pop		hl							;11
		ld		de,(SyB_StackAddr)			;20 ;**** Get Address of Data Stack		
		inc		de							;6	;**** Modes up Stack 1
		ldi									;16	;**** Copies (HL)-(DE)
		ldi									;16	;**** Copies (HL)-(DE)
		ex		de,hl
		ld		hl,(SyB_StackAddr)			;16
		ld		bc,-6						;10
		add		hl,bc						;11
		ld		(SyB_StackAddr),hl			;16
		ex		de,hl						;4
		jp		(hl)						;4		
EndLib		

;****                              ****
;**** PUSH 1 Onto Stack as Integer ****
;****                              ****		
Library SyB_Push_Int_1
		ld		iy,(SyB_StackAddr)
		ld		bc,-6
		add		iy,bc
		ld		(iy+7),1
		ld		(iy+8),0
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****                            ****
;**** PUSH 1 Onto Stack as Float ****
;****                            ****	
Library SyB_Push_Flo_1
		ld		iy,(SyB_StackAddr)
		ld		bc,-6
		add		iy,bc
		ld		(iy+7),0
		ld		(iy+8),0
		ld		(iy+9),0
		ld		(iy+10),0
		ld		(iy+11),#81		
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****                              ****
;**** Push Null Integer onto stack ****
;****                              ****
Library SyB_Push_Null_Int
		Xor		a
		ld		hl,(SyB_StackAddr)
		inc		hl
		ld		(hl),a
		inc		hl
		ld		(hl),a
		ld		bc,-8						;16
		add		hl,bc						;11
		ld		(SyB_StackAddr),hl			;16				
		ret
Endlib		

;****                                    ****
;**** Pushes Double Int Array onto Stack ****
;****                                    ****
Library SyB_Push_V_Int_Array_2
		pop		hl					;Get Return Address
		ld		e,(hl)				;Gets the Following Two Bytes which hold Var Address Base
		inc		hl					;
		ld		d,(hl)				;DE=Var Address Base
		inc		hl					;Moves HL on
		push	hl					;Store the Reurn Position
		ex		de,hl				;HL = Start of Array
		ld		e,(hl)
		inc		hl
		ld		d,(hl)				;DE = Skip multiple
		inc		hl					;HL= Start of Array Data
		push	hl					;Return point
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)	
		push	hl
		push	hl
		pop		bc
.SyB_Push_V_Int_Array_2_Mul_2
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB_Push_V_Int_Array_2_Mul_2
		pop		de
		sbc		hl,de
		push	hl
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,hl				;**** Times 2
		pop		de
		add		hl,de
		pop		de
		add		hl,de
		ld		a,(hl)
		ld		(iy+13),a
		inc		hl
		ld		a,(hl)
		ld		(iy+14),a
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****                                      ****
;**** Pushes Double Float Array onto Stack ****
;****                                      ****
Library SyB_Push_V_Flo_Array_2
		pop		hl					;Get Return Address
		ld		e,(hl)				;Gets the Following Two Bytes which hold Var Address Base
		inc		hl					;
		ld		d,(hl)				;DE=Var Address Base
		inc		hl					;Moves HL on
		push	hl					;Store the Reurn Position
		ex		de,hl				;HL = Start of Array
		ld		e,(hl)
		inc		hl
		ld		d,(hl)				;DE = Skip multiple
		inc		hl					;HL= Start of Array Data
		push	hl					;Return point
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)
		ld		h,(iy+8)	
		push	hl
		push	hl
		pop		bc
.SyB_Push_V_Flo_Array_2_Mul_2
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB_Push_V_Flo_Array_2_Mul_2
		pop		de
		sbc		hl,de
		push	hl
		ld		l,(iy+13)
		ld		h,(iy+14)	
		ld		c,l
		ld		b,h
		add		hl,hl
		add		hl,hl
		add		hl,bc				;**** Times 5
		pop		de
		add		hl,de
		pop		de
		add		hl,de
		ld		a,(hl)
		ld		(iy+13),a
		inc		hl
		ld		a,(hl)
		ld		(iy+14),a
		inc		hl
		ld		a,(hl)
		ld		(iy+15),a
		inc		hl
		ld		a,(hl)
		ld		(iy+16),a
		inc		hl
		ld		a,(hl)
		ld		(iy+17),a
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib





;**************************************************
;*********** TAKING VALUES FROM STACK *************
;**************************************************
;****                                  ****
;**** Function Pass from Stack to Vars ****
;****                                  ****
Library SyB_Function_Pass:
		pop		hl								;Get contents after Call
		ld		b,(hl)							;Number of Parameters to pass
		inc		hl
		ld		iy,(SyB_StackAddr)
.SyB_Function_Pass_1:
		push	bc
		ld		a,(hl)							;Type
		inc		hl
		cp		5
		jp		z,SyB_Function_Pass_Str
		cp		1
		jp		z,SyB_Function_Pass_Int
		cp		3
		jp		z,SyB_Function_Pass_Float
.SyB_Function_Pass_2:
		ld		de,6
		add		iy,de
		pop		bc
		dec		b
		jp		nz,SyB_Function_Pass_1
		ld		(SyB_StackAddr),iy
		jp		(hl)
.SyB_Function_Pass_Int:
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		a,(iy+7)		
		ld		(de),a
		inc		de
		ld		a,(iy+8)
		ld		(de),a
		jp		SyB_Function_Pass_2
.SyB_Function_Pass_Float:
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		ld		a,(iy+7)
		ld		(de),a
		inc		de
		ld		a,(iy+8)
		ld		(de),a
		inc		de
		ld		a,(iy+9)
		ld		(de),a
		inc		de
		ld		a,(iy+10)
		ld		(de),a				
		inc		de
		ld		a,(iy+11)
		ld		(de),a		
		jp		SyB_Function_Pass_2		
.SyB_Function_Pass_Str
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		push	hl
		ex		de,hl
		call	SyB_Str_Store_2_Ram
		pop		hl
		jp		SyB_Function_Pass_2
EndLib

;****                         ****
;**** Store a Byte from Stack ****
;****                         ****
Library SyB_Store_Byt
		pop		hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		push	hl
		ld		hl,(SyB_StackAddr)
		ld		bc,6
		add		hl,bc
		ld		(SyB_StackAddr),hl
		inc		hl
		ldi
		ret
EndLib		

;****                             ****
;**** Store an Integer from Stack ****
;****                             ****
;DE=Address to Store
Library SyB_Store_Int_Direct
		ld		hl,(SyB_StackAddr)						;16
		ld		bc,6									;10
		add		hl,bc									;11
		ld		(SyB_StackAddr),hl						;16
		inc		hl										;6
		ldi												;16
		ldi												;16
		ret												;10				101
EndLib

;****                        ****
;**** Takes Float from Stack ****
;****                        ****
Library SyB_Store_Flo
		pop		hl						;Return Address
		ld		e,(hl)								
		inc		hl
		ld		d,(hl)
		inc		hl
		push	hl
		ld		hl,(SyB_StackAddr)
		ld		bc,6
		add		hl,bc
		ld		(SyB_StackAddr),hl
		inc		hl
		ldi
		ldi
		ldi
		ldi
		ldi
		ret		
EndLib

;****                                     ****
;**** Takes Single Array Float from Stack ****
;****                                     ****
Library SyB_Store_Flo_Array_1
		pop		hl					;Get Return Address
		ld		e,(hl)				;Gets the Following Two Bytes which hold Var Address Base
		inc		hl					;
		ld		d,(hl)				;DE=Var Address Base
		inc		hl					;Moves HL on
		push	hl					;Store the Reurn Position
		inc		de					;Stores Dimension data Ignore
		inc		de					;
		ld		hl,(SyB_StackAddr)
		ld		bc,13
		add		hl,bc
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a
		ld		c,l
		ld		b,h
		add		hl,hl
		add		hl,hl
		add		hl,bc
		add		hl,de
		ex		de,hl
		ld		hl,(SyB_StackAddr)
		ld		bc,6
		add		hl,bc
		inc		hl
		ldi
		ldi
		ldi
		ldi
		ldi
		ld		(SyB_StackAddr),hl
		ret
EndLib

;****                                     ****
;**** Takes Double Array Float from Stack ****
;****                                     ****
Library SyB_Store_Flo_Array_2
		pop		hl					;Get Return Address
		ld		e,(hl)				;Gets the Following Two Bytes which hold Var Address Base
		inc		hl					;
		ld		d,(hl)				;DE=Var Address Base
		inc		hl					;Moves HL on
		push	hl					;Store the Reurn Position
		ex		de,hl				;HL = Start of Array
		ld		e,(hl)
		inc		hl
		ld		d,(hl)				;DE = Skip multiple
		inc		hl					;HL= Start of Array Data
		push	hl					;Return point
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		push	hl
		push	hl
		pop		bc
.SyB_Store_Flo_Array_Mul_2	
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB_Store_Flo_Array_Mul_2
		pop		de
		sbc		hl,de
		push	hl
		ld		l,(iy+19)
		ld		h,(iy+20)
		ld		c,l
		ld		b,h
		add		hl,hl
		add		hl,hl
		add		hl,bc				;**** Times 5
		pop		de
		add		hl,de
		pop		de
		add		hl,de	
		ld		a,(iy+7)
		ld		(hl),a
		inc		hl
		ld		a,(iy+8)
		ld		(hl),a
		inc		hl
		ld		a,(iy+9)
		ld		(hl),a
		inc		hl
		ld		a,(iy+10)
		ld		(hl),a
		inc		hl
		ld		a,(iy+11)
		ld		(hl),a
		ld		bc,18
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****                                   ****
;**** Takes Single Array Int from Stack ****
;****                                   ****
;DE=Base Address of Array +2 (To Skip over word)
Library SyB_Store_Int_Array_1_Direct
		ld		iy,(Syb_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,hl
		add		hl,de
		ld		e,(iy+7)
		ld		d,(iy+8)
		ld		(hl),e
		inc		hl
		ld		(hl),d
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;****                                   ****
;**** Takes Double Array Int from Stack ****
;****                                   ****
Library SyB_Store_Int_Array_2
		pop		hl					;Get Return Address
		ld		e,(hl)				;Gets the Following Two Bytes which hold Var Address Base
		inc		hl					;
		ld		d,(hl)				;DE=Var Address Base
		inc		hl					;Moves HL on
		push	hl					;Store the Reurn Position
		ex		de,hl
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		push	hl					;Return point
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)
		ld		h,(iy+14)
		push	hl
		push	hl
		pop		bc
.SyB2_Store_Int_Array_Mul_2	
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB2_Store_Int_Array_Mul_2
		pop		de
		sbc		hl,de
		push	hl
		ld		l,(iy+19)
		ld		h,(iy+20)
		add		hl,hl				;**** Times 2
		pop		de
		add		hl,de
		pop		de
		add		hl,de	
		ld		a,(iy+7)
		ld		(hl),a
		inc		hl
		ld		a,(iy+8)
		ld		(hl),a
		ld		bc,18
		add		iy,bc
		ld		(SyB_StackAddr),iy
		ret
EndLib

;*************************************************
;************** STRING ROUTINES ******************
;*************************************************

;****                                           ****
;**** Push String from Memory onto String Stack ****
;****                                           ****
Library SyB_Push_N_Str
		pop		hl
		ld		a,(hl)
		inc		hl
		ld		iy,(SyB_StackAddr)
		ld		de,(SyB_StrStackAddr)
		ld		(iy+1),e
		ld		(iy+2),d
		ld		(iy+3),a
		ld		bc,-6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		And		a
		jp		z,SyB_Push_N_Str_Finish
		ld		c,a
		ld		b,0
		ldir
		ld		(SyB_StrStackAddr),de
.SyB_Push_N_Str_Finish	
		jp		(hl)
EndLib

;****                                         ****
;**** Push String Var Array onto String Stack ****
;****                                         ****
Library SyB_Push_V_Str_Array_1
		pop		ix							;Return Adress holds Variable Loc
		ld		l,(ix+0)
		ld		h,(ix+1)					;HL=Variable
		inc		ix
		inc		ix							;IX Skip 
		ld		iy,(SyB_StackAddr)
		ld		e,(iy+7)					;DE=Array value
		ld		d,(iy+8)		
		inc		hl							;Skip HL Over 
		inc		hl
		add		hl,de
		add		hl,de						;Add together to get String Pointer Address
		ld		e,(hl)
		inc		hl
		ld		d,(hl)						
		ex		de,hl						;HL=Address of string
		
		dec		hl							;Step Back 1 to Length
		ld		c,(hl)						;Move back to start of Text
		inc		hl
		ld		de,(SyB_StrStackAddr)		;Last Piece of String on Stack
		ld		b,0							;BC=Length to loop down
		;ld		(iy+6),5
		ld		(iy+7),e					;Stack = String Stack location
		ld		(iy+8),d					;ditto
		ld		(iy+9),c					;Stack = String Length
		Xor		a
		cp		c			
		jp		z,SyB_Push_V_Str_Array_1_1	;Do nothing if zero
		ldir								;Copy info to String Stack
		ld		(SyB_StrStackAddr),de		;Update new String Stack 
.SyB_Push_V_Str_Array_1_1
		jp		(ix)
EndLib

;****                                                ****
;**** Push String Var Double Array onto String Stack ****
;****                                                ****
Library SyB_Push_V_Str_Array_2
		pop		ix						;**** Holds Variable
		ld		l,(ix+0)				;HL=Variable Address
		ld		h,(ix+1)
		ld		e,(hl)					;DE=Array size
		inc		hl
		ld		d,(hl)
		inc		hl		
		push	hl
		

		ld		iy,(SyB_StackAddr)
		ld		l,(iy+7)				;**** Get the Second Stacked Integer
		ld		h,(iy+8)				;				
		;****  	Multiply shit ****
		push	hl
		push	hl
		pop		bc
.SyB2_Store_Str_Array_Mul_2		
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB2_Store_Str_Array_Mul_2
		pop		de
		sbc		hl,de
		ex		de,hl
		ld		l,(iy+13)
		ld		h,(iy+14)
		add		hl,hl
		add		hl,de
		pop		de
		add		hl,de
		inc		ix
		inc		ix
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ex		de,hl		
		dec		hl							;Step Back 1 to Length
		ld		c,(hl)						;Move back to start of Text
		inc		hl
			
		ld		de,(SyB_StrStackAddr)		;Last Piece of String on Stack
		ld		b,0							;BC=Length to loop down
		;ld		(iy+6),5
		ld		(iy+13),e					;Stack = String Stack location
		ld		(iy+14),d					;ditto
		ld		(iy+15),c					;Stack = String Length
		Xor		a
		cp		c			
		jp		z,SyB_Push_V_Str_Array_2_1	;Do nothing if zero
		ldir								;Copy info to String Stack
		ld		(SyB_StrStackAddr),de		;Update new String Stack 
.SyB_Push_V_Str_Array_2_1
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		(ix)
EndLib


;****                      ****
;**** Stores String to Ram ****
;****                      ****
Library SyB_Store_Str
		pop		ix
		ld		iy,(SyB_StackAddr)
		ld		l,(ix+0)
		ld		h,(ix+1)
		inc		ix
		inc		ix	
		call	SyB_Str_Store_2_Ram
		ld		bc,6
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		(ix)
EndLib



;****                                   ****
;**** Stores Single Array String to Ram ****
;****                                   ****
Library SyB_Store_Str_Array_1
		pop		ix
		ld		l,(ix+0)
		ld		h,(ix+1)
		inc		hl
		inc		hl
		ld		iy,(SyB_StackAddr)
		ld		e,(iy+13)
		ld		d,(iy+14)
		add		hl,de
		add		hl,de
		inc		ix
		inx		ix
		call	SyB_Str_Store_2_Ram
		ld		bc,12
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		(ix)
EndLib

;****                                   ****
;**** Stores Double Array String to Ram ****
;****                                   ****
Library SyB_Store_Str_Array_2
		pop		ix						;**** Holds Variable
		ld		l,(ix+0)				;HL=Variable Address
		ld		h,(ix+1)
		ld		e,(hl)					;DE=Array size
		inc		hl
		ld		d,(hl)
		inc		hl		
		push	hl
		ld		iy,(SyB_StackAddr)
		ld		l,(iy+13)				;**** Get the Second Stacked Integer
		ld		h,(iy+14)				;
		;****  	Multiply shit ****
		push	hl
		push	hl
		pop		bc
.SyB2_Store_Str_Array_Mul		
		add		hl,de
		dec		bc
		ld		a,b
		Or		c
		jr		nz,SyB2_Store_Str_Array_Mul
		pop		de
		sbc		hl,de
		ex		de,hl
		ld		l,(iy+19)
		ld		h,(iy+20)
		add		hl,hl
		add		hl,de
		pop		de
		add		hl,de
		inc		ix
		inc		ix	
		call	SyB_Str_Store_2_Ram
		ld		bc,18
		add		iy,bc
		ld		(SyB_StackAddr),iy
		jp		(ix)		
EndLib

;****                     ****
;**** SyB_Str_Store_2_Ram ****
;****                     ****
Library SyB_Str_Store_2_Ram		
		ld		(SyB_Where_Pointer_2),hl	
		ld		e,(hl)					;
		inc		hl
		ld		d,(hl)
		ex		de,hl
		dec		hl
		ld		a,(hl)					;Length of Existing Text
		ld		c,(iy+9)				;Length of Text on Stack

		cp		c
		jp		c,SyB_SSN
		;Length shorter or same
		ld		(hl),c
		inc		hl
		sub		c							;A=Remainder
		ld		e,(iy+7)					;HL=Location of Stack Text
		ld		d,(iy+8)
		ld		(SyB_StrStackAddr),de		;Stores the decreased String Stack Pointer Address		
		ex		de,hl
		ld		(SyB_Store_Char_Temp),a
		Xor		a
		cp		c
		jr		z,SyB_SS2R_1
		ld		b,0
		ldir
.SyB_SS2R_1
		ld		a,(SyB_Store_Char_Temp)
		And		a
		jr		z,SyB_SS2R_2
		ld		b,a
		Xor		a
.SyB_SS2R_3
		ld		(de),a
		inc		de
		djnz	SyB_SS2R_3
.SyB_SS2R_2
		Xor		a
		ld		(de),a
		ret

;**** New Placement Store
.SyB_SSN
		dec		hl							;Move to High Pointer
		Xor		a							;Clear A
		ld		(hl),a						;(HL) = 0 (Or High pointer is zero)
		dec		hl							;Move to Low Pointer
		ld		a,1							;A=1
		ld		(hl),a						;(HL)= 1 - So address is 1, 0, Length

		ld		de,(SyB_StringTopAddr)		;HL = Top Of Text Address
		ld		l,c
		ld		h,0
		add		hl,de
		ld		de,SyB_StringTopMem
		Xor		a
		sbc		hl,de
		jp		c,SyB_SSN_2
		call	SyB_Garbage
.SyB_SSN_2		
		ld		b,0
		;Copy from stack to New Position		
		ld		de,(SyB_Where_Pointer_2)	;DE = Pointer Address		
		ld		hl,(SyB_StringTopAddr)		;HL = Top Of Text Address
		ld		(hl),e						;Feed Low Byte of Pointer onto Text Stack
		inc		hl
		ld		(hl),d						;Feed Hi Byte of Pointer onto Text Stack
		inc		hl
		ld		(hl),c						;Feed New Length onto Text Stack
		inc		hl
		;HL = Start of Where New Text Goes
		;DE = Pointer Address
		ex		de,hl						;Swaps For speed
		ld		(hl),e						;Pointer Address = Start of Text HL (Note +3 Not including Address & Len)
		inc		hl							;
		ld		(hl),d						;Pointer Address Hi

		ld		l,(iy+7)					;HL=Location of Stack Text
		ld		h,(iy+8)
		ld		(SyB_StrStackAddr),hl		;Adjust the String Stack Pointer down for next data	
		ldir								;HL -> DE Looping C times
		Xor		a							;A=0 
		ld		(de),a						;0 Terminator on string end
		inc		de							;Pad
		ld		(SyB_StringTopAddr),de		;New StringTop Value
		ret

.SyB_Where_Pointer_2:		dw	0			;Actual 2 Byte Pointer to String
EndLib

;****          GARBAGE           ****
;**** Garbage Collection Command ****
;****                            ****
Library SyB_Garbage
		;**** Okay We need to do a Text clearout
		ld		hl,SyB_StringTopAddr+2		;HL = Where to Start
		ld		(SyB_SSN_Garbage_Last),hl
		
.SyB_SSN_Garbage_3		
		ld		bc,(SyB_StringTopAddr)	
.SyB_SSN_Garbage_1		
		ld		a,(hl)
		And		a
		jp		nz,SyB_SSN_Garbage_10
		inc		hl
.SyB_SSN_Garbage_4				
		ld		a,h
		cp		b
		jp		c,SyB_SSN_Garbage_1
		ld		a,l
		cp		c
		jp		c,SyB_SSN_Garbage_1
		;Done it
		ld		hl,(SyB_SSN_Garbage_Last)
		ld		(SyB_StringTopAddr),hl	
		ret

.SyB_SSN_Garbage_10
		dec		hl
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		inc		hl
		ld		e,b
		ld		d,(hl)
		dec		hl
		;Is DE = 1 - Becuase if so it is a skip
		ld		a,1
		cp		e
		jp		nz,SyB_SSN_Garbage_11
		Xor		a
		cp		d
		jp		nz,SyB_SSN_Garbage_11
		;**** This is a skipper
		inc		hl
		inc		hl				;Now Points at Length
		ld		c,(hl)
		ld		b,0
		inc		bc
		inc		bc
		add		hl,bc
		ld		bc,(SyB_StringTopAddr)
		jp		SyB_SSN_Garbage_4
				
.SyB_SSN_Garbage_11
		ld		(SyB_SSN_Garbage_HL),hl
		ld		(SyB_SSN_Garbage_Check1),bc		
		;Gets Garbage Check 1 (DE) and - 3 to Match
		ex		de,hl
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		dec		bc
		dec		bc
		dec		bc
		;Check DE = BC
		ld		a,e
		cp		c
		jp		nz,SyB_SSN_Garbage_12
		ld		a,d
		cp		b
		jp		nz,SyB_SSN_Garbage_12		
		;**** Tis same so copy This text
		ld		hl,(SyB_SSN_Garbage_HL)
		jp		SyB_SSN_Garbage_CopyDown				
.SyB_SSN_Garbage_12
		;DE = Current pointer + 1
		dec		de
		ld		hl,(SyB_SSN_Garbage_Check1)			;Get Contents of pointer
		ld		c,(hl)
		inc		hl
		ld		b,(hl)
		dec		bc
		dec		bc
		dec		bc
		ld		a,e
		cp		c
		jp		nz,SyB_SSN_Garbage_13		
		ld		a,d
		cp		b
		jp		nz,SyB_SSN_Garbage_13
		ex		de,hl
		jp		SyB_SSN_Garbage_CopyDown
.SyB_SSN_Garbage_13:
		di
.SyB_SSN_Garbage_14:
		jr		SyB_SSN_Garbage_14
		db		"String Error"
	
;HL = Start of Copy	
.SyB_SSN_Garbage_CopyDown:
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		inc		hl
		push	hl	
		ex		de,hl
		ld		de,(SyB_SSN_Garbage_Last)
		inc		de
		inc		de
		inc		de
		ld		(hl),e
		inc		hl
		ld		(hl),d
		ld		de,(SyB_SSN_Garbage_Last)
		pop		hl
		ld		a,(hl)
		add		4
		dec		hl
		dec		hl
		ld		b,0
		ld		c,a
		ldir
		ld		(SyB_SSN_Garbage_Last),de
		ld		bc,(SyB_StringTopAddr)
		jp		SyB_SSN_Garbage_4
		
.SyB_SSN_Garbage_Last:		dw	0		
.SyB_SSN_Garbage_Check1:	dw	0		
.SyB_SSN_Garbage_HL:		dw	0
	
EndLib

;==============================================================================
;### DISPLAY-ROUTINES #########################################################
;==============================================================================
;### DSPGET -> converts 5byte floating point value to display format
;### Input  DE=pointer to 5byte floating point value
Library DspGet
		jr		dspget99
.dspvaltmp   ds 5+1
.dspvalnum   ds 10+1
.dspvallen   db 0
.dspvalsgn   db 0        ;0=positive; display no sign, -1=minus
.dspvalexp   db 0        ;exponent (signed)
.dspvaldig   equ 10      ;maximum amount of displayed mantissa digits
.dspchrflg   db 1        ;flag (input), if 1000 points should be displayed
.dspfeflg    db 0        ;flag (input), if force exponent display
.dspchrcom   db "."      ;symbol for 1000 points
.dspchrpoi   db ","      ;symbol for comma
.dspintflg   db 0        ;flag (result), if displayed number is integer
.dspget99:
		ld 		hl,0
        ld 		(dspvalsgn),hl
        ld 		hl,dspvaltmp
        call 	FLO_MOVE
        call 	FLO_PREPARE		
        ld 		a,b
        Or 		a
        jr 		z,dspget3
        And 	128
        add 	a
        sbc 	0
        ld 		(dspvalsgn),a
        ld 		a,e
        ld 		(dspvalexp),a
        ld 		ix,(dspvaltmp+0)
        ld 		de,(dspvaltmp+2)
        db 		#dd:ld a,l
        db 		#dd:Or h		
        Or 		e
        Or 		d
        jr 		z,dspget3
		ld 		iy,dspvalnum

		call 	clcn32
 
        push 	iy
		pop hl
        ld 		bc,dspvalnum-1
        Or 		a
        sbc 	hl,bc
        ld 		c,l
        ld 		a,"0"
        ld 		hl,dspvalexp

.dspget1
		cp 		(iy+0)
        jr 		nz,dspget2
        ld 		(iy+0),0
        dec 	iy
        inc 	(hl)
        dec 	c
        jr 		nz,dspget1
.dspget2
		ld 		a,c
.dspget3
		ld 		(dspvallen),a
        ret

;### DSPTXT -> converts display format value to text and displays it
.dsptxt
		Xor 	a
        ld 		(dspintflg),a
        ld 		a,(dspvalsgn)        ;*** Sign
        inc 	a
        jr 		nz,dsptxt1
        ld 		(hl),"-"
        inc 	hl
.dsptxt1
		ex 		de,hl
        ld 		a,(dspvallen)        ;*** Test, if value=0
        Or 		a
        jr 		nz,dsptxti
.dsptxty
		ld 		a,"0"                ;display only 0.
        ld 		(de),a
        inc 	de
        jr 		dsptxth
.dsptxti
		ld 		hl,dspvalnum
        ld 		a,(dspfeflg)
        Or 		a
        jr 		nz,dsptxt6           ;display exponent, if in RO mode and F-E on
        ld 		a,(dspvalexp)        ;*** Exponent
        ld 		b,a
        Or 		a
        ld 		a,(dspvallen)
        ld 		c,a
        jp 		m,dsptxta
        add	 	b                   ;*** Exponent positive -> exp display, if dspvallen + dspvalexp <= dspvaldig
        cp 		dspvaldig+1          ;a=length of complete number
        jr 		nc,dsptxt6
        ld 		b,a                  ;*** Display mantissa without comma (a,b=length of mantissa before comma)
        ld 		a,1
        ld 		(dspintflg),a
        ld 		a,b
.dsptxt2
		sub 	3
        jr 		z,dsptxtf
        jr 		nc,dsptxt2
.dsptxtf
		add 	3
        ld 		c,a                  ;c=1000 counter
.dsptxt3
		ld 		a,(hl)
        inc 	hl
        Or 		a
        jr 		nz,dsptxt4
        ld 		a,"0"
        dec 	hl
.dsptxt4
		call 	dsptxt5
        jr 		nz,dsptxt3
.dsptxth
		ld 		a,(dspchrcom)
        ld 		(de),a
        inc 	de
        Xor 	a
        ld 		(de),a
        ret
.dsptxt6
		ld 		a,(hl)               ;**** Display mantissa with exponent
        ld 		(de),a
        inc 	hl
        inc 	de
        ld 		a,(dspchrcom)
        ld 		(de),a
        inc 	de
        ld 		a,(dspvallen)
.dsptxt7
		dec 	a
        jr 		z,dsptxt8
        ldi
        jr 		dsptxt7
.dsptxt8
		ex 		de,hl
        ld 		(hl),"e"
        inc 	hl
        ld 		a,(dspvallen)        ;exp display = -(exp + mantissa length - 1)
        ld 		c,a
        ld 		a,(dspvalexp)
        add 	c
        dec 	a
        ld 		(hl),"+"
        jp 		p,dsptxt9
        ld 		(hl),"-"
        neg
.dsptxt9
		inc 	hl
        ex 		de,hl
        call 	clcdez
        ex 		de,hl
        ld 		(hl),e
        inc 	hl
        ld 		(hl),d
        inc 	hl
        ld 		(hl),0
        ret
.dsptxta
		add 	b                   ;*** Comma negative (a,c=len, b=comma -> a=len-neg comma)
        jr 		c,dsptxtb
        neg                     ;a=-(len+exp) [=distance between comma and first digit]
        ld 		b,a
        add 	c                   ;a=new number of digits-1
        cp 		dspvaldig+1
        jr 		nc,dsptxt6           ;too large -> display with exponent
        call 	dsptxte
        ld 		a,"0"
.dsptxtg
		ld 		(de),a
        inc 	de
        djnz 	dsptxtg
        jr 		dsptxtd
.dsptxtb
		jr 		z,dsptxtc            ;*** Display negative comma without exponent
        ld 		b,a
        call 	dsptxt2
        jr 		dsptxtd
.dsptxtc
		call 	dsptxte
.dsptxtd
		ld 		a,(hl)
        ldi
        Or 		a
        jr 		nz,dsptxtd
        ret
.dsptxte
		ld 		a,"0"
        ld 		(de),a
        inc 	de
        ld 		a,(dspchrcom)
        ld 		(de),a
        inc 	de
        ret
.dsptxt5
		ld 		(de),a               ;adds a digit (in A) and inserts a point, if needed
        inc 	de
        dec 	b
        ret 	z
        dec 	c
        ret 	nz
        ld 		a,(dspchrflg)
        dec 	a
        ret 	nz
        ld 		a,(dspchrpoi)
        ld 		(de),a
        inc 	de
        ld 		c,3+1
        dec 	c
        ret



;==============================================================================
;### SUB-ROUTINES #############################################################
;==============================================================================
;### CLCN32 -> Converts 32Bit-number (unsigned) in ASCII-String (teminated by 0)
;### Input      DE,IX=value, IY=destination address
;### Output     IY=Address of last char
;### Destroyed  AF,BC,DE,HL,IX,IY


.clcn32t
		dw 		1,0,10,0,100,0,1000,0,10000,0
        dw 		#86a0,1,#4240,#f,#9680,#98,#e100,#5f5,#ca00,#3b9a
.clcn32z
		ds 		4,0

		nop
		nop
.clcn32
		ld 		(clcn32z),ix
        ld 		(clcn32z+2),de
        ld 		ix,clcn32t+36
        ld 		b,9
        ld 		c,0
.clcn321
		ld 		a,"0"
        Or 		a
.clcn322
		ld 		e,(ix+0)
		ld 		d,(ix+1)
		ld 		hl,(clcn32z)
		sbc 	hl,de
		ld 		(clcn32z),hl
        ld 		e,(ix+2)
		ld 		d,(ix+3)
		ld 		hl,(clcn32z+2)
		sbc 	hl,de
		ld 		(clcn32z+2),hl
        jr 		c,clcn325
        inc 	c
        inc 	a
        jr 		clcn322
.clcn325
		ld 		e,(ix+0)
		ld 		d,(ix+1)
		ld 		hl,(clcn32z)
		add 	hl,de
		ld 		(clcn32z),hl
        ld 		e,(ix+2)
		ld 		d,(ix+3)
		ld 		hl,(clcn32z+2)
		adc 	hl,de
		ld 		(clcn32z+2),hl
        ld 		de,-4
        add 	ix,de
        inc 	c
        dec 	c
        jr 		z,clcn323
        ld 		(iy+0),a
        inc 	iy
clcn323
		djnz 	clcn321
        ld 		a,(clcn32z)
        add 	"0"
        ld 		(iy+0),a
        ld 		(iy+1),0
        ret
;### CLCDEZ -> Converts 8bit value into two decimal digits
;### Input      A=value
;### Output     L=10.ascii digit, H=1. ascci digit
;### Destroyed  AF
clcdez  ld l,0
clcdez1 sub 10
        jr c,clcdez2
        inc l
        jr clcdez1
clcdez2 add "0"+10
        ld h,a
        ld a,"0"
        add l
        ld l,a
        ret
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                     - SYMBOS MICRO KERNEL FUNCTIONS -                      @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   28.10.2005

;The kernel is the heart of SymbOS and controls the core resources of the
;system.
;This library supports you in using the kernel functions regarding processes
;and timers.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SyKernel_MTADDP
;******************************************************************************
;*** Name           Multitasking_Add_Process_Command
;*** Input          HL = Stack address (see notes below)
;***                A  = Ram bank (0-8)
;***                E  = Priority (1=highest, 7=lowest)
;*** Output         A  = Process ID
;***                CF = Success status
;***                     0 = OK
;***                     1 = the process couldn't been added, as the maximum
;***                         number of processes (32) has been reached
;*** Destroyed      BC,DE,HL,IX,IY
;*** Description    Adds a new process with a given priority and starts it
;***                immediately.
;***                Application processes usually will be started with priority 4.
;***                Note, that the desktop manager process runs with priority 1,
;***                the system manager process with 2. If you start a process,
;***                which should do some long and intensive calculation, you should
;***                choose a priority greater than 4, so that other applications
;***                will not be disturbed.
;***                The stack must always be placed between #C000 and #FFFF
;***                (transfer ram area). It must contain the start address of the
;***                process (or timer) routine at offset 12 and may contain the
;***                initial values of the registers. You can choose the size of the
;***                stack buffer by yourself, just be sure, that it is large
;***                enough.
;***                At offset 13 there must be a free byte. In this byte the kernel
;***                will write the ID of the process (or timer) after it has been
;***                started.
;*** Example(stack)                ds 128              ;Stack buffer
;***                stack_pointer: dw 0                ;initial value for IY
;***                               dw 0                ;initial value for IX
;***                               dw 0                ;initial value for HL
;***                               dw 0                ;initial value for DE
;***                               dw 0                ;initial value for BC
;***                               dw 0                ;initial value for AF
;***                               dw process_start    ;process start address
;***                process_id:    db 0                ;kernel writes the ID here
;******************************************************************************
        ld c,MSC_KRL_MTADDP
        call SyKernel_Message
        Xor a
        cp l
        ld a,h
        ret
EndLib

Library SyKernel_MTDELP
;******************************************************************************
;*** Name           Multitasking_Delete_Process_Command
;*** Input          A  = Process ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Stops an existing process and deletes it.
;******************************************************************************
        ld c,MSC_KRL_MTDELP
        ld l,a
        jp SyKernel_Message
EndLib

Library SyKernel_MTADDT
;******************************************************************************
;*** Name           Multitasking_Add_Timer_Command
;*** Input          HL = Stack address (see notes below)
;***                A  = Ram bank (0-8)
;*** Output         A  = Timer ID
;***                CF = Success status
;***                     0 = OK
;***                     1 = the timer couldn't been added, as the maximum
;***                         number of timers (32) has been reached
;*** Destroyed      BC,DE,HL,IX,IY
;*** Description    Adds a new timer and starts it immediately. Timers will be
;***                called 50times per second. Please see MSC_KRL_MTADDP for
;***                information about the stack.
;******************************************************************************
        ld c,MSC_KRL_MTADDT
        call SyKernel_Message
        Xor a
        cp l
        ld a,h
        ret
EndLib

Library SyKernel_MTDELT
;******************************************************************************
;*** Name           Multitasking_Delete_Timer_Command
;*** Input          A  = Timer ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Stops an existing timer and deletes it.
;******************************************************************************
        ld c,MSC_KRL_MTDELT
        ld l,a
        jp SyKernel_Message
EndLib

Library SyKernel_MTSLPP
;******************************************************************************
;*** Name           Multitasking_Sleep_Process_Command
;*** Input          A  = Process ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Puts an existing process into the sleep mode. It is stopped and
;***                does not run anymore, until it receives a message, or until it
;***                will be wacked up again (see MSC_KRL_MTWAKP).
;***                Usually this command is not needed, as a process can put itself
;***                into the sleep mode with the MSGSLP restart (see above).
;******************************************************************************
        ld c,MSC_KRL_MTSLPP
        ld l,a
        jp SyKernel_Message
EndLib

Library SyKernel_MTWAKP
;******************************************************************************
;*** Name           Multitasking_WakeUp_Process_Command
;*** Input          A  = Process ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Wakes up a process, which was sleeping before. A process will
;***                be wacked up, too, when another process is sending a message to
;***                it.
;******************************************************************************
        ld c,MSC_KRL_MTWAKP
        ld l,a
        jp SyKernel_Message
EndLib

Library SyKernel_TMADDT
;******************************************************************************
;*** Name           Timer_Add_Counter_Command
;*** Input          HL = Counter byte address
;***                E  = Counter byte ram bank (0-8)
;***                A  = Process ID
;***                B  = Speed (counter will be increased every x/50 second)
;*** Output         CF = Success status
;***                     0 = OK
;***                     1 = the timer couldn't been added, as the maximum
;***                         number of counter (16) has been reached
;*** Description    Adds a counter for a process. You need to specify a byte
;***                anywhere in the memory. This byte then will be increased every
;***                B/50 seconds. So if you want, that the kernel increases it once
;***                per second, you have to set B to 50.
;***                As an example you could check this byte regulary, and if it has
;***                been changed you call an event routine. This is much easier and
;***                faster than setting up an own timer.
;******************************************************************************
        ld c,MSC_KRL_TMADDT
        call SyKernel_Message
        Xor a
        cp l
        ret
EndLib

Library SyKernel_TMDELT
;******************************************************************************
;*** Name           Timer_Delete_Counter_Command
;*** Input          HL = Counter byte address
;***                E  = Counter byte ram bank (0-8)
;*** Output         -
;*** Description    Stops the specified counter. Please note, that this will be
;***                done automatically, if the process should be deleted.
;******************************************************************************
        ld c,MSC_KRL_TMDELT
        jp SyKernel_Message
EndLib

Library SyKernel_TMDELP
;******************************************************************************
;*** Name           Timer_Delete_AllProcessCounters_Command
;*** Input          A  = Process ID
;*** Output         -
;*** Description    Stops all counters of one process. Please note, that this will
;***                be done automatically, if the process should be deleted.
;******************************************************************************
        ld c,MSC_KRL_TMDELP
        ld l,a
        jp SyKernel_Message
EndLib


;### SUB ROUTINES #############################################################

Library SyKernel_Message
;******************************************************************************
;*** Input          C        = Command
;***                HL,E,A,B = Additional parameters
;*** Output         HL       = returned parameters
;*** Destroyed      AF,BC,DE,IX,IY
;*** Description    Sends a message to the kernel, waits for the answer and
;***                returns the result
;******************************************************************************
        ld iy,AppMsgB
        ld (iy+0),c
        ld (iy+1),l
        ld (iy+2),h
        ld (iy+3),e
        ld (iy+4),a
        ld (iy+5),b
        ld a,c
        add 128
        ld (SyKMsgN),a
        db #dd:ld h,1       ;1 is the number of the kernel process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #10
SyKMsg1 db #dd:ld h,1       ;1 is the number of the kernel process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #08             ;wait for a kernel message
        db #dd:dec l
        jr nz,SyKMsg1
        ld a,(SyKMsgN)
        cp (iy+0)
        jr nz,SyKMsg1
        ld l,(iy+1)
        ld h,(iy+2)
        ret
SyKMsgN db 0
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                     - SYMBOS FILE MANAGER FUNCTIONS -                      @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   30.04.2006

;This library supports you in using the file manager functions.
;Instead of including the following routines in your application code you may
;use the "SySystem_CallFunction" routine directly, so that you would save some
;overhead. In this case you can see this library just as an example, how to
;access the file manager.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SyFile_FILNEW
;******************************************************************************
;*** Name           File_New
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;***                A    = Attributes
;***                       Bit0 = 1 -> Read only
;***                       Bit1 = 1 -> Hidden
;***                       Bit2 = 1 -> System
;***                       Bit5 = 1 -> Archive
;*** Output         A    = Filehandler ID
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Creates a new file and opens it for read/write access. If the
;***                file was already existing, it will be emptied first. For
;***                additional information see 018 (FILOPN).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILNEW
        ret
EndLib

Library SyFile_FILOPN
;******************************************************************************
;*** Name           File_Open
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;*** Output         A    = Filehandler ID
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Opens an existing file for read/write access. This means, that
;***                you can read and write in the file like you want. You can open
;***                up to 8 different files at the same time.
;***                For more information about the file path see the introduction
;***                of the DIRECTORY MANAGEMENT FUNCTIONS.
;***                The media will be reloaded first, if the device is set to
;***                "removeable media" and there is no other open file on the same
;***                device.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        ret
EndLib

Library SyFile_FILCLO
;******************************************************************************
;*** Name           File_Close
;*** Input          A    = Filehandler ID
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Closes an opened file. If there is unwritten data in the sector
;***                cache, it will be written to disc at once.
;***                This command closes a file in any case, even if an error
;***                occured.
;***                If an error occured during file reading/writing you must close
;***                the file, too, to have the filehandler free again!
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        ret
EndLib

Library SyFile_FILINP
;******************************************************************************
;*** Name           File_Input
;*** Input          A    = Filehandler ID
;***                HL   = Destination address
;***                E    = Destination ram bank (0-8)
;***                BC   = Number of bytes
;*** Output         BC   = Number of read bytes
;***                ZF   = 1 -> All requested bytes have been read
;***                       0 -> The end of the file has been reached, and less
;***                            bytes than requested have been read (check BC)
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,HL,IX,IY
;*** Description    Reads a specified amount of bytes out of an opened file. After
;***                this operation the file pointer will be moved behind the last
;***                read byte. This means, that it is possible to read several
;***                blocks with different sizes out of an opened file. It doesn't
;***                matter, if you already did write operations, too.
;***                If you try to read more bytes than available, the zero flag
;***                will be reset. In any case BC contains the amount of read
;***                bytes.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        ret
EndLib

Library SyFile_FILOUT
;******************************************************************************
;*** Name           File_Output
;*** Input          A    = Filehandler ID
;***                HL   = Source address
;***                E    = Source ram bank (0-8)
;***                BC   = Number of bytes
;*** Output         BC   = Number of written bytes
;***                A    = 0 -> All bytes have been written
;***                       1 -> The device is full, and less bytes have been
;***                            written (check BC)
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,HL,IX,IY
;*** Description    Writes a specified amount of bytes into an opened file. After
;***                this operation the file pointer will be moved behind the last
;***                written byte. If the file pointer has been somewhere in the
;***                middle of the file before this operation, the data at this
;***                place will be overwritten. If you have been at the end of the
;***                file, its length will be extended.
;***                You can write several blocks with different sizes, and it
;***                doesn't matter if you already read from the file before.
;***                It's possible, that not all bytes have been written, if the
;***                device is full. Register A will be 1 in this case. In any case
;***                BC contains the amount of written bytes.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOUT
        ret
EndLib

Library SyFile_FILPOI
;******************************************************************************
;*** Name           File_Pointer
;*** Input          A    = Filehandler ID
;***                IY,IX= Difference
;***                C    = Reference point
;***                       0 = File begin
;***                       1 = Actual pointer position
;***                       2 = File end
;*** Output         IY,IX= new absolute pointer position
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL
;*** Description    Moves the file pointer to another position. The difference is
;***                specified with IY and IX, IY is the high word, IX the low word
;***                (difference = 65536 * IY + IX).
;***                You can also use this function to find out the length of an
;***                opened file. Just set IY,IX to 0 and choose 2 as the reference
;***                point type. The pointer will be placed behind the last byte of
;***                the file, so you will get its length in IY,IX.
;*** Examples       IY = 0,     IX = 1,   C = 1 -> Increases the position by 1
;***                IY = 65535, IX = -10, C = 2 -> Sets the pointer before the last
;***                                               10 bytes of the file
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILPOI
        ret
EndLib

Library SyFile_FILF2T
;******************************************************************************
;*** Name           File_Decode_Timestamp
;*** Input          BC   = Time code
;***                       bit  0- 4 = second/2
;***                       bit  5-10 = minute
;***                       bit 11-15 = hour
;***                DE   = Date code
;***                       bit  0- 4 = day (starting from 1)
;***                       bit  5- 8 = month (starting from 1)
;***                       bit  9-15 = year-1980
;*** Output         A    = second
;***                B    = minute
;***                C    = hour
;***                D    = day (starting from 1)
;***                E    = month (starting from 1)
;***                HL   = year
;*** Destroyed      F
;*** Description    Decodes the file timestamp, which is used for the file system.
;***                You can use this function after reading the timestamp of a
;***                file with 035 (DIRPRR) or 038 (DIRINP).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILF2T
        ret
EndLib

Library SyFile_FILT2F
;******************************************************************************
;*** Name           File_Encode_Timestamp
;*** Input          A    = second
;***                B    = minute
;***                C    = hour
;***                D    = day (starting from 1)
;***                E    = month (starting from 1)
;***                HL   = year
;*** Output         BC   = Time code (see FILF2T)
;***                DE   = Date code (see FILF2T)
;*** Destroyed      AF,HL,IX,IY
;*** Description    Encodes the file timestamp, which is used for the file system.
;***                You can use this function before changing the timestamp of a
;***                file with 034 (DIRPRS).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILT2F
        ret
EndLib

Library SyFile_FILLIN
;******************************************************************************
;*** Name           File_LineInput
;*** Input          A    = Filehandler ID
;***                HL   = Destination buffer address (size must be 255 bytes)
;***                E    = Destination buffer ram bank (0-8)
;*** Output         BC   = Number of read bytes (without terminator)
;***                ZF   = 0 -> 1 or more bytes have been loaded
;***                       1 -> EOF reached, nothing has been loaded
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,HL,IX,IY
;*** Description    Reads one text line out of an opened file. A text line is
;***                terminated by a single 13, a single 10, a combination of 13+10,
;***                a combination of 10+13 or by a single 26 ("end of file" code).
;***                The line terminator will not be copied to the destination line
;***                buffer, but a 0 will be added behind the last char of the line.
;***                This function allows you to read a text file line by line at a
;***                very high speed, because you don't need to read single chars
;***                and check for line feeds by yourself.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILLIN
        ret
EndLib


Library SyFile_DIRDEV
;******************************************************************************
;*** Name           Directory_Device
;*** Input          A    = Driveletter ("A"-"Z")
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Selects the actual drive.
;***                As your application is running in a multitasking environment,
;***                unfortunately this command does not make many sense, as other
;***                applications could select an other drive again.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRDEV
        ret
EndLib

Library SyFile_DIRPTH
;******************************************************************************
;*** Name           Directory_Path
;*** Input          IXH  = File path ram bank (0-8)
;***                HL   = File path address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Selects the actual path for the actual or a different drive.
;***                As your application is running in a multitasking environment,
;***                unfortunately this command does not make many sense, as other
;***                applications could select an other path again.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRPTH
        ret
EndLib

Library SyFile_DIRPRS
;******************************************************************************
;*** Name           Directory_Property_Set
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;***                A    = Property type
;***                       0 = Attribute          -> C  = attribute
;***                                                      Bit0 = 1 -> Read only
;***                                                      Bit1 = 1 -> Hidden
;***                                                      Bit2 = 1 -> System
;***                                                      Bit5 = 1 -> Archive
;***                       1 = Timestamp modified -> BC = time code, DE = date code
;***                       2 = Timestamp created  -> BC = time code, DE = date code
;***                BC,DE= see above
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Changes a property of a file or a directory. You can set the
;***                attribute, the "created" time and the "modified" time.
;***                For more information about the time and date code see 023
;***                (FILF2T).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRPRS
        ret
EndLib

Library SyFile_DIRPRR
;******************************************************************************
;*** Name           Directory_Property_Get
;*** Input          IXH  = File path and name ram bank (0-8)
;***                HL   = File path and name address
;***                A    = Property type
;***                       0 = Attribute
;***                       1 = Timestamp modified
;***                       2 = Timestamp created
;*** Output         C    = Attributes (if requested)
;***                       Bit0 = 1 -> Read only
;***                       Bit1 = 1 -> Hidden
;***                       Bit2 = 1 -> System
;***                       Bit3 = 1 -> Volume ID
;***                       Bit4 = 1 -> Directory
;***                       Bit5 = 1 -> Archive
;***                BC,DE= Time and date code (if requested)
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,HL,IX,IY
;*** Description    Reads a property of a file or a directory.
;***                For more information about the time and date code see 023
;***                (FILF2T).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRPRR
        ret
EndLib

Library SyFile_DIRREN
;******************************************************************************
;*** Name           Directory_Rename
;*** Input          IXH  = Ram bank (0-8) of old and new file name
;***                HL   = Address of file path and old file name
;***                DE   = Address of new file name
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Renames a file or a directory. The new file name must not
;***                include a path. The function will fail, if a file or directory
;***                with the new name already exists.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRREN
        ret
EndLib

Library SyFile_DIRNEW
;******************************************************************************
;*** Name           Directory_New
;*** Input          IXH  = Directory path and name ram bank (0-8)
;***                HL   = Directory path and name address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Creates a new directory. The function will fail, if a file or
;***                directory with the same name already exists.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRNEW
        ret
EndLib

Library SyFile_DIRINP
;******************************************************************************
;*** Name           Directory_Input
;*** Input          IXH  = Directory path ram bank (0-8)
;***                HL   = Directory path address (may include a search mask)
;***                IXL  = forbidden attributes
;***                       Bit0 = 1 -> don't show read only files
;***                       Bit1 = 1 -> don't show hidden files
;***                       Bit2 = 1 -> don't show system files
;***                       Bit3 = 1 -> don't show volume ID entries
;***                       Bit4 = 1 -> don't show directories
;***                       Bit5 = 1 -> don't show archive files
;***                A    = Destination buffer ram bank (0-8)
;***                DE   = Destination buffer address
;***                BC   = Destination buffer length
;***                IY   = Number of entries, which should be skipped
;*** Output         HL   = Number of read entries
;***                BC   = Remaining unused space in the destination buffer
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,DE,IX,IY
;*** Data structure 00  4B  File length (32bit double word)
;***                04  1W  Date code, see 023 (FILF2T)
;***                06  1W  Time code, see 023 (FILF2T)
;***                08  1B  Attributes, see 035 (DIRPRR)
;***                09  ?B  File or sub directory name
;***                ??  1B  0 terminator
;*** Description    Reads the content of a directory. You can specify a name filter
;***                filter by adding a file mask to the path (* and ? are allowed)
;***                and an attribute filter. We recommend always to set Bit3
;***                (volume ID) of the attribute filter byte.
;***                The system skips the specified amount of entries first and
;***                then loads as many entries as exist or as there is place in the
;***                destination buffer. Please note, that the entries will not be
;***                sorted. Depending on its name every entry in the destination
;***                buffer can have a different length and is terminated with 0
;***                behind the file name. Filenames don't contain spaces.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRINP
        ret
EndLib

Library SyFile_DIRDEL
;******************************************************************************
;*** Name           Directory_DeleteFile
;*** Input          IXH  = File path and name/mask ram bank (0-8)
;***                HL   = File path and name/mask address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Deletes one or more files. You can delete multiple files by
;***                using a file mask (* and ? are allowed).
;***                This function can't be used for deleting directories.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRDEL
        ret
EndLib

Library SyFile_DIRRMD
;******************************************************************************
;*** Name           Directory_DeleteDirectory
;*** Input          IXH  = Directory path and name ram bank (0-8)
;***                HL   = Directory path and name address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Deletes a sub directory. The sub directory has to be empty
;***                and not read only, otherwise the operation will be aborted.
;***                You can specify the directory with or without "/" at the
;***                end of the full path.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRRMD
        ret
EndLib

Library SyFile_DIRMOV
;******************************************************************************
;*** Name           Directory_Move
;*** Input          IXH  = File/directory old and new path ram bank (0-8)
;***                HL   = File/directory source path and name address
;***                DE   = File/directory destination path address
;*** Output         CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Moves a file or sub directory into another directory of the
;***                same drive. That means, that the drive letter of the source
;***                path must be the same like the drive letter of the
;***                destination path, otherwise the operation will be aborted.
;***                You can either move files or sub directories with this
;***                function, in both cases the source path+name must not end
;***                with a "/".
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRMOV
        ret
EndLib

Library SyFile_DIRINF
;******************************************************************************
;*** Name           Directory_DriveInformation
;*** Input          A    = Driveletter ("A"-"Z")
;***                C    = Information type
;***                       0 = general drive information
;***                       1 = free and total amount of memory
;*** Output         - Information type 0:
;***                A    = Type
;***                       00 = Device does not exist
;***                       01 = Device is ready
;***                       02 = Device is not initialized
;***                       03 = Device is corrupt
;***                B    = Medium
;***                       01 = Floppy disc single side (Amsdos)
;***                       02 = Floppy disc double side (Fat 12)
;***                       08 = Ram disc
;***                       16 = IDE hard disc or CF card (Fat 16, Fat 32)
;***                C    = File system
;***                       01 = Amsdos Data
;***                       02 = Amsdos System
;***                       16 = Fat 12
;***                       17 = Fat 16
;***                       18 = Fat 32
;***                D    = Sectors per cluster
;***                IY,IX= Total number of clusters
;***                - Information type 1:
;***                HL,DE= Number of free 512Byte sectors
;***                IY,IX= Total number of clusters
;***                C    = Sectors per cluster
;***                - Information type 0 and 1:
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      F
;*** Description    Returns information about one drive. This function can be
;***                used to find out the amount of free memory on one drive.
;***                Please note, that calculating the free amount of memory on
;***                a FAT16 device may take a while, as everytime the whole FAT
;***                (up to 128KB) needs to be scanned.
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRINF
        ret
EndLib

Library SyFile_DEVDIR
;******************************************************************************
;*** Name           Directory_Input_Extended
;*** Input          A    = [bit0-3] Destination buffer ram bank (0-8)
;***                       [bit4-7] Directory path ram bank (0-8)
;***                HL   = Directory path address (may include a search mask)
;***                DE   = Destination buffer address. This must first contain two
;***                       words with additional information at the beginning:
;***                       00  1W  Address of list control table
;***                       02  1W  Maximum number of entries
;***                       This function will overwrite this information and fill
;***                       the buffer with the directory data.
;***                BC   = Maximum size of destination buffer
;***                IXL  = forbidden attributes
;***                       Bit0 = 1 -> don't show read only files
;***                       Bit1 = 1 -> don't show hidden files
;***                       Bit2 = 1 -> don't show system files
;***                       Bit3 = 1 -> don't show volume ID entries
;***                       Bit4 = 1 -> don't show directories
;***                       Bit5 = 1 -> don't show archive files
;***                IY   = Number of entries, which should be skipped
;***                IXH  = Additional columns
;***                       Bit0 = 1 -> File size
;***                       Bit1 = 1 -> Date and time (last modified)
;***                       Bit2 = 1 -> Attributes
;*** Output         HL   = Number of read entries
;***                CF   = Error state (0 = ok, 1 = error; A = error code)
;*** Destroyed      AF,BC,DE,IX,IY
;*** Description    This is a very powerful extension of the directory input
;***                (DIRINP) function. It reads the content of a directory and
;***                converts it into ready to use list control data. So if your
;***                application wants to display the content of a directory inside
;***                a list control, it can use this function and doesn't need to do
;***                any conversion jobs by itself. Also the list control itself can
;***                do the sorting of the directory.
;***                First you have to reserve two memory areas in the same ram
;***                bank. One area needs to be reserved inside the data ram area.
;***                It will contain the texts (file names, dates etc.) and numbers
;***                (file sizes) for the list control. You can choose any size, but
;***                we recommend at least 4000 Bytes. BC must contain its size,
;***                when you call the function. DE contains the address, and the
;***                low nibble of A the ram bank number.
;***                The second area needs to be reserved inside the transfer ram
;***                area of the same bank. It contains the data structure of the
;***                list control. It size is calculated like this:
;***                Size = Maximum_number_of_entries * (4 + Additional_columns * 2)
;***                So when you have two additional columns (like date and
;***                attributes) and want to load up to 100 entries, you need to
;***                reserve 800 bytes.
;***                As there are no more Z80-registers available, the address of
;***                this memory area and the maximum number of entries must be
;***                written to the beginning of the other memory area.
;***                For additional information about reading directories see 038
;***                (DIRINP).
;******************************************************************************
        call SySystem_CallFunction
        db MSC_SYS_SYSFIL
        db FNC_FIL_DEVDIR
        ret
EndLib


;### SUB ROUTINES #############################################################

Library SySystem_CallFunction
;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
        ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
SyCallN db 0
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                    - SYMBOS SYSTEM MANAGER FUNCTIONS -                     @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   28.10.2005

;The system manager is responsible for starting and stopping applications and
;it also provides several dialogue services.
;This library supports you in using the system manager functions.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SySystem_PRGRUN
;******************************************************************************
;*** Name           Program_Run_Command
;*** Input          HL = File path and name address
;***                A  = [Bit0-3] File path and name ram bank (0-8)
;***                     [Bit7  ] Flag, if system error message should be
;***                              suppressed
;*** Output         A  = Success status
;***                     0 = OK
;***                     1 = File does not exist
;***                     2 = File is not an executable and its type is not
;***                         associated with an application
;***                     3 = Error while loading (see P8 for error code)
;***                     4 = Memory full
;***                - If success status is 0:
;***                L  = Application ID
;***                H  = Process ID (the applications main process)
;***                - If success status is 3:
;***                L  = File manager error code
;*** Destroyed      F,BC,DE,IX,IY
;*** Description    Loads and starts an application or opens a document with a
;***                known type by loading the associated application first.
;***                If Bit7 of A is not set, the system will open a message box,
;***                if an error occurs during the loading process.
;***                If the operation was successful, you will find the
;***                application ID and the process ID in L and H. If it failed
;***                because of loading problems L contains the file manager
;***                error code.
;******************************************************************************
        ld c,MSC_SYS_PRGRUN
        call SySystem_SendMessage
SySPRn1 call SySystem_WaitMessage
        cp MSR_SYS_PRGRUN
        jr nz,SySPRn1
        ld a,(iy+1)
        ld l,(iy+8)
        ld h,(iy+9)
        ret
EndLib

Library SySystem_PRGEND
;******************************************************************************
;*** Name           Program_End_Command
;*** Input          L  = Application ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Stops an application and releases all its used system
;***                resources. This command first stops all processes of the
;***                application. After this all open windows will be closed and the
;***                reserved memory will be released.
;***                Please note, that this command can't release memory, stop
;***                processes and timers or close windows, which are not
;***                registered for the application. Such resources first have
;***                to be released by the application itself.
;******************************************************************************
        ld c,MSC_SYS_PRGEND
        jp SySystem_SendMessage
EndLib

Library SySystem_SYSWRN
;******************************************************************************
;*** Name           Dialogue_Infobox_Command
;*** Input          HL = Content data address (#C000-#FFFF)
;***                A  = Content data ram bank (0-8)
;***                E  = [Bit0-6] Number of buttons (MUST BY ALWAYS 1)
;***                     [Bit7  ] Box type
;***                              0 = warning (default warning symbol)
;***                              1 = info (own symbol will be used)
;*** Content data   00  1W  Address of text line 1
;***                02  1W  4 * [text line 1 pen] + 2
;***                04  1W  Address of text line 2
;***                06  1W  4 * [text line 2 pen] + 2
;***                08  1W  Address of text line 3
;***                10  1W  4 * [text line 3 pen] + 2
;***                - if E[bit7] is 1:
;***                12  1W  Address of symbol (24x24 pixel SymbOS graphic format)
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Opens an info or warning box and displays three line of text
;***                and one "OK" button. If Bit7 of E is set to 1 you can specify
;***                an own symbol, which will be showed left to the text. If this
;***                bit is not set, a "!"-warning symbol will be displayed.
;***                Currently multiple choice alert boxes are not supported, which
;***                means, that the number of buttons always have to be set to 1.
;***                Please note, that the content data must always be placed in the
;***                transfer ram area (#C000-#FFFF). The texts itself and the
;***                optional graphic must always be placed inside a 16K (data ram
;***                area).
;***                As the text line pen, you should choose 1, so 6 would be the
;***                correct value.
;***                For more information about the mentioned memory types (data,
;***                transfer) see the "applications" chapter.
;***                For more information about the SymbOS graphic format see the
;***                "desktop manager data records" chapter.
;******************************************************************************
        ld c,MSC_SYS_SYSWRN
        jp SySystem_SendMessage
EndLib

Library SySystem_SELOPN
;******************************************************************************
;*** Name           Dialogue_FileSelector_Command
;*** Input          HL = File mask, path and name address (#C000-#FFFF)
;***                     00  3B  File extension filter (e.g. "*  ")
;***                     03  1B  0
;***                     04 256B path and filename
;***                A  = File mask, path and name ram bank (0-8)
;***                C  = Attribute filter
;***                     Bit0 = 1 -> don't show read only files
;***                     Bit1 = 1 -> don't show hidden files
;***                     Bit2 = 1 -> don't show system files
;***                     Bit3 = 1 -> don't show volume ID entries
;***                     Bit4 = 1 -> don't show directories
;***                     Bit5 = 1 -> don't show archive files
;***                IX = Maximum number of directory entries
;***                IY = Maximum size of directory data buffer
;***                DE = Data record of the caller window; the file selector
;***                     window will be a super window of it, during its open)
;*** Output         A  = Success status
;***                     0 -> The user choosed a file and closed the dialogue
;***                          with "OK". The complete file path and name can be
;***                          found in the filepath buffer of the application.
;***                     1 -> The user aborted the file selection. The content
;***                          of the applications filepath buffer is unchanged.
;***                     2 -> The file selection dialogue is currently used by
;***                          another application. It can only be opened once
;***                          at the same time. The user should close the
;***                          dialogue first before it can be opened again by
;***                          the application.
;***                     3 -> Memory full. There was not enough memory
;***                          available for the directory buffer and/or the
;***                          list data structure.
;***                     4 -> No window available. The desktop manager couldn't
;***                          open a new window for the dialogue, as the
;***                          maximum number of windows (32) has already been
;***                          reached.
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Opens the file selection dialogue. In this dialogue the user
;***                can move through the directory structure, change the drive and
;***                search and select a file.
;***                If you specify a path, the dialogue will start directly in the
;***                directory. If you append a filename, too, it will be used as
;***                the preselected file.
;***                You can filter the entries of the directory by attributes and
;***                filename extension. We recommend always to set Bit3 of the
;***                attribute filter byte.
;***                The File mask/path/name string (260 bytes) must always be
;***                placed in the transfer ram area (#C000-#FFFF). For more
;***                information about this memory types see the "applications"
;***                chapter.
;***                Please note, that the system will reserve memory to store the
;***                listed directory entries and the data structure of the list.
;***                With IX and IY you can choose, how much memory should be used.
;***                We recommend to set the number of entries between 100 and 200
;***                (Amsdos supports a maximum amount of 64 entries) and to set the
;***                data buffer between 5000 and 10000.
;******************************************************************************
        ld (SySSOpW),de
        push iy
        ld iy,AppMsgB
        ld (iy+6),a
        ld (iy+7),c
        ld (iy+8),l
        ld (iy+9),h
        db #dd:ld a,l
        ld (iy+10),a
        db #dd:ld a,h
        ld (iy+11),a
        pop de
        ld (iy+12),e
        ld (iy+13),d
        ld c,MSC_SYS_SELOPN
        call SySystem_SendMessage
SySSOp1 call SySystem_WaitMessage
        cp MSR_SYS_SELOPN
        jr nz,SySSOp1
        ld a,(iy+1)
        cp -1
        ret nz
        ld ix,(SySSOpW)
        ld a,(iy+2)
        ld (ix+51),a
        jr SySSOp1
SySSOpW dw 0
EndLib


;### SUB ROUTINES #############################################################

Library SySystem_SendMessage
;******************************************************************************
;*** Input          C       = Command
;***                HL,A,DE = additional Parameters
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the system manager
;******************************************************************************
        ld iy,AppMsgB
        ld (iy+0),c
        ld (iy+1),l
        ld (iy+2),h
        ld (iy+3),a
        ld (iy+4),e
        ld (iy+5),d
        db #dd:ld h,3       ;3 is the number of the system manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #10
        ret
EndLib

Library SySystem_WaitMessage
;******************************************************************************
;*** Input          -
;*** Output         IY = message buffer
;***                A  = first byte in the Message buffer (IY+0)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the desktop manager, which includes the
;***                window ID and additional parameters
;******************************************************************************
        ld iy,AppMsgB
SySWMs1 db #dd:ld h,3       ;3 is the number of the system manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #08             ;wait for a system manager message
        db #dd:dec l
        jr nz,SySWMs1
        ld a,(iy+0)
        ret
EndLib
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@              S Y M S T U D I O   S Y S T E M   L I B R A R Y               @
;@                    - SYMBOS DESKTOP MANAGER FUNCTIONS -                    @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;Author: Prodatron / Symbiosis
;Date:   27.10.2005

;The desktop manager is responsible for all actions, which are taking place on
;the video screen. Especially the handling of the application windows is done
;by the desktop manager.
;This library supports you in using the desktop manager functions.
;The existance of "AppPrzN" (a byte, where the ID of the applications process
;is stored) and "AppMsgB" (the message buffer, 14 bytes, which are placed in
;the transfer ram area) is required.


Library SyDesktop_WINOPN
;******************************************************************************
;*** Name           Window_Open_Command
;*** Input          A  = Window data record ram bank (0-8)
;***                DE = Window data record address (#C000-#FFFF)
;*** Output         A  = Window ID (only, if CF=0)
;***                CF = Success status
;***                     0 = OK
;***                     1 = window couldn't be opened, as the maximum number
;***                         of windows (32) has been reached
;*** Destroyed      BC,DE,HL,IX,IY
;*** Description    Opens a new window. Its data record must be placed in the
;***                transfer ram area (between #c000 and #ffff).
;***                For more information about the window data record see the
;***                chapter "desktop manager data records".
;***                For more information about the transfer ram memory types see
;***                the "applications" chapter.
;******************************************************************************
        ld b,a
        db #dd:ld l,e
        db #dd:ld h,d
        ld a,(AppPrzN)      ;register window for the application process
        ld (ix+3),a
        ld a,b
        ld c,MSC_DSK_WINOPN
        call SyDesktop_SendMessage
SyWOpn1 call SyDesktop_WaitMessage
        cp MSR_DSK_WOPNER
        scf
        ret z               ;return with set carry flag, if window couldn't be opened
        cp MSR_DSK_WOPNOK
        jr nz,SyWOpn1       ;different message than "open ok" -> continue waiting
        ld a,(iy+4)         ;get window ID and return with cleared carry flag
        ret
EndLib

Library SyDesktop_WINMEN
;******************************************************************************
;*** Name           Window_Redraw_Menu_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the menu bar of a window. If you changed your menus you
;***                should call this command to update the screen display.
;******************************************************************************
        ld c,MSC_DSK_WINMEN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WININH
;******************************************************************************
;*** Name           Window_Redraw_Content_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  content.
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws one, all or a specified number of controls inside the
;***                window content. This command is very important, if you make
;***                changes and want to display them.
;***                This command is identical with MSC_DSK_WINDIN with the
;***                exception, that it only works, if the window has focus. Because
;***                of this, it is a little bit faster, as the desktop manager
;***                doesn't need to take care about other windows, which could hide
;***                some parts of the window.
;******************************************************************************
        ld c,MSC_DSK_WININH
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINTOL
;******************************************************************************
;*** Name           Window_Redraw_Toolbar_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  toolbar.
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws one, all or a specified number of controls inside the
;***                window toolbar. Use this command to update the screen display,
;***                if you made changes in the toolbar.
;******************************************************************************
        ld c,MSC_DSK_WINTOL
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINTIT
;******************************************************************************
;*** Name           Window_Redraw_Title_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the title bar of a window. Use this command to update
;***                the screen display, if you changed the text of the window
;***                title.
;******************************************************************************
        ld c,MSC_DSK_WINTIT
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINSTA
;******************************************************************************
;*** Name           Window_Redraw_Statusbar_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the status bar of a window. Use this command to update
;***                the screen display, if you changed the text of the status bar.
;******************************************************************************
        ld c,MSC_DSK_WINSTA
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMVX
;******************************************************************************
;*** Name           Window_Set_ContentX_Command
;*** Input          A  = Window ID
;***                DE = new X offset of the visible window content
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    If the size of the window content is larger than the visible
;***                part, you can scroll its X offset with this command. The
;***                command works also, if the window is not resizeable by the
;***                user.
;******************************************************************************
        ld c,MSC_DSK_WINMVX
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMVY
;******************************************************************************
;*** Name           Window_Set_ContentY_Command
;*** Input          A  = Window ID
;***                DE = new Y offset of the visible window content
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    If the size of the window content is larger than the visible
;***                part, you can scroll its Y offset with this command. The
;***                command works also, if the window is not resizeable by the
;***                user.
;******************************************************************************
        ld c,MSC_DSK_WINMVY
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINTOP
;******************************************************************************
;*** Name           Window_Focus_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Takes the window to the front position on the screen.
;******************************************************************************
        ld c,MSC_DSK_WINTOP
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMAX
;******************************************************************************
;*** Name           Window_Size_Maximize_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is minimized or restored
;*** Description    Maximizes a window. A maximized window has a special status,
;***                where it can't be moved to another screen position.
;******************************************************************************
        ld c,MSC_DSK_WINMAX
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMIN
;******************************************************************************
;*** Name           Window_Size_Minimize_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is maximized or restored
;*** Description    Minimizes a window. It will disappear from the screen and can
;***                only be accessed by the user via the task bar.
;******************************************************************************
        ld c,MSC_DSK_WINMIN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMID
;******************************************************************************
;*** Name           Window_Size_Restore_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is maximized or minimized
;*** Description    Restores the window or the size of the window, if it was
;***                minimized or maximized before.
;******************************************************************************
        ld c,MSC_DSK_WINMID
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINMOV
;******************************************************************************
;*** Name           Window_Set_Position_Command
;*** Input          A  = Window ID
;***                DE = new X window position
;***                HL = new Y window position
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if the window is not maximized
;*** Description    Moves the window to another position on the screen. This will
;***                not work, if the window is maximized.
;******************************************************************************
        ld c,MSC_DSK_WINMOV
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINSIZ
;******************************************************************************
;*** Name           Window_Set_Size_Command
;*** Input          A  = Window ID
;***                DE = new window width
;***                HL = new window height
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Resizes a window. This command will always work, even if the
;***                window is not resizeable by the user.
;***                Please note, that the size always refers to the visible content
;***                of the window, not to the whole window including the control
;***                elements. So with title bar, scroll bars etc. a window can have
;***                a bigger size on the screen.
;******************************************************************************
        ld c,MSC_DSK_WINSIZ
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINCLS
;******************************************************************************
;*** Name           Window_Close_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Closes the window. The desktop manager will remove it from the
;***                screen.
;******************************************************************************
        ld c,MSC_DSK_WINCLS
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINDIN
;******************************************************************************
;*** Name           Window_Redraw_ContentExtended_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  content.
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    Redraws one, all or a specified number of controls inside the
;***                window content. This command is identical with MSC_DSK_WININH
;***                with the exception, that it always works but with less speed.
;***                For more information see MSC_DSK_WININH.
;******************************************************************************
        ld c,MSC_DSK_WINDIN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINSLD
;******************************************************************************
;*** Name           Window_Redraw_Slider_Command
;*** Input          A  = Window ID
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works only, if window has focus
;*** Description    Redraws the two slider of the window, with which the user can
;***                scroll the content. Sliders will only be displayed, if the
;***                window is resizeable.
;***                Usally you should use MSC_DSK_WINMVX and MSC_DSK_WINMVY to
;***                scroll the content of the window. These commands will update
;***                the sliders by themself.
;***                If you manipulate the content position in the window data
;***                record by yourself, you can use this command to update the
;***                screen display.
;******************************************************************************
        ld c,MSC_DSK_WINSLD
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_WINPIN
;******************************************************************************
;*** Name           Window_Redraw_ContentArea_Command
;*** Input          A  = Window ID
;***                E  = -1, control ID or negative number of controls
;***                     000 - 239 -> the control with the specified ID will be
;***                                  redrawed.
;***                     240 - 254 -> redraws -P2 controls, starting from
;***                                  control P3. As an example, if P2 is -3
;***                                  (253) and P3 is 5, the controls 5, 6 and 7
;***                                  will be redrawed.
;***                     255       -> redraws all controls inside the window
;***                                  content.
;***                HL = Area X begin inside the window content
;***                BC = Area Y begin
;***                IX = Area X length
;***                IY = Area Y length
;***                - if E is between 240 and 254:
;***                D = ID of the first control, which should be redrawed.
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Limitation     works always
;*** Description    This command works like MSC_DSK_WINDIN, but it updates only a
;***                specified area inside the window content. Changes outside the
;***                area won't be updated. This command is especially useful for
;***                updating large graphics, if only a part of the graphic should
;***                be updated, and you don't want to loose performance with
;***                updating the other parts of it, too.
;***                For more information see MSC_DSK_WINDIN and MSC_DSK_WININH.
;******************************************************************************
        ld (AppMsgB+06),bc
        ld (AppMsgB+08),ix
        ld (AppMsgB+10),iy
        ld c,MSC_DSK_WINPIN
        jp SyDesktop_SendMessage
EndLib

Library SyDesktop_MODGET
;******************************************************************************
;*** Name           DesktopService_ScreenModeGet
;*** Input          -
;*** Output         E  = Screen mode
;***                     0 = 160 x 200, 16 colours
;***                     1 = 320 x 200,  4 colours (standard mode)
;***                     2 = 640 x 200,  2 colours
;*** Destroyed      F,BC,DE,HL,IX,IY
;*** Description    Returns the actual screen resolution and number of possible
;***                colours.
;******************************************************************************
        ld a,DSK_SRV_MODGET
        jp SyDesktop_Service
EndLib

Library SyDesktop_MODSET
;******************************************************************************
;*** Name           DesktopService_ScreenModeSet
;*** Input          E  = Screen mode
;***                     0 = 160 x 200, 16 colours
;***                     1 = 320 x 200,  4 colours (standard mode)
;***                     2 = 640 x 200,  2 colours
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sets the screen resolution and number of possible colours.
;******************************************************************************
        ld a,DSK_SRV_MODSET
        jp SyDesktop_Service
EndLib

Library SyDesktop_COLGET
;******************************************************************************
;*** Name           DesktopService_ColourGet
;*** Input          E  = Colour number (0-15)
;*** Output         D  = Bit[0-3] blue  component (0-15)
;***                     Bit[4-7] green component (0-15)
;***                L  = Bit[0-3] red   component (0-15)
;*** Destroyed      AF,BC,E,H,IX,IY
;*** Description    Returns the definition of a colours. Please note, that you
;***                always have a range of 4096, even if the computer is not a CPC
;***                PLUS, as the system recalculates the colour for standard CPCs
;***                (factor 5,33 for each component).
;******************************************************************************
        ld a,DSK_SRV_COLGET
        jp SyDesktop_Service
EndLib

Library SyDesktop_COLSET
;******************************************************************************
;*** Name           DesktopService_ColourSet
;*** Input          E  = Colour number (0-15)
;***                D  = Bit[0-3] blue  component (0-15)
;***                     Bit[4-7] green component (0-15)
;***                L  = Bit[0-3] red   component (0-15)
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Defines one colour. Please note, that you always have a range
;***                of 4096, even if the computer is not a CPC PLUS, as the system
;***                recalculates the colour for standard CPCs (factor 5,33 for each
;***                component).
;******************************************************************************
        ld a,DSK_SRV_COLSET
        jp SyDesktop_Service
EndLib

Library SyDesktop_DSKBGR
;******************************************************************************
;*** Name           DesktopService_RedrawBackground
;*** Input          -
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Redraws the desktop background.
;******************************************************************************
        ld a,DSK_SRV_DSKBGR
        jp SyDesktop_Service
EndLib

Library SyDesktop_DSKPLT
;******************************************************************************
;*** Name           DesktopService_RedrawComplete
;*** Input          -
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Redraws the complete screen. The background, the task bar and
;***                all windows will be updated.
;******************************************************************************
        ld a,DSK_SRV_DSKPLT
        jp SyDesktop_Service
EndLib


;### SUB ROUTINES #############################################################

Library SyDesktop_Service
;******************************************************************************
;*** Input          A     = Function
;***                DE,HL = additional parameters
;*** Output         DE,HL = returned parameters
;*** Destroyed      AF,BC,IX,IY
;*** Description    Sends a service request message to the desktop manager,
;***                waits for the answer and returns with the result
;******************************************************************************
        ld c,MSC_DSK_DSKSRV
        ld (SyDSrvN),a
        push af
        call SyDesktop_SendMessage
        pop af
        cp 1
        jr z,SyDSrv1
        cp 3
        jr z,SyDSrv1
        cp 5
        ret nz
SyDSrv1 call SyDesktop_WaitMessage
        cp MSR_DSK_DSKSRV
        jr nz,SyDSrv1
        ld a,(SyDSrvN)
        cp (iy+1)
        jr nz,SyDSrv1
        ld e,(iy+2)
        ld d,(iy+3)
        ld l,(iy+4)
        ld h,(iy+5)
        ret
SyDSrvN db 0
EndLib

Library SyDesktop_SendMessage
;******************************************************************************
;*** Input          C  = Command
;***                A  = Window ID
;***                DE,HL = additional parameters
;*** Output         -
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the desktop manager, which includes the
;***                window ID and additional parameters
;******************************************************************************
        ld iy,AppMsgB
        ld (iy+0),c
        ld (iy+1),a
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        db #dd:ld h,2       ;2 is the number of the desktop manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #10
        ret
EndLib

Library SyDesktop_WaitMessage
;******************************************************************************
;*** Input          -
;*** Output         IY = message buffer
;***                A  = first byte in the Message buffer (IY+0)
;*** Destroyed      AF,BC,DE,HL,IX,IY
;*** Description    Sends a message to the desktop manager, which includes the
;***                window ID and additional parameters
;******************************************************************************
        ld iy,AppMsgB
SyDWMs1 db #dd:ld h,2       ;2 is the number of the desktop manager process
        ld a,(AppPrzN)
        db #dd:ld l,a
        rst #08             ;wait for a desktop manager message
        db #dd:dec l
        jr nz,SyDWMs1
        ld a,(iy+0)
        ret
EndLib
.AppTrnEnd


